/* This code is AUTOGENERATED!!! */

#include "state.h"
#include "state_internals.h"

void crStateLightingDiff(CRLightingBits *b, CRbitvalue *bitID,
		CRContext *fromCtx, CRContext *toCtx)
{
	CRLightingState *from = &(fromCtx->lighting);
	CRLightingState *to = &(toCtx->lighting);
	unsigned int j, i;
	CRbitvalue nbitID[CR_MAX_BITARRAY];
	for (j = 0; j<CR_MAX_BITARRAY; j++)
		nbitID[j] = ~bitID[j];
	i = 0; /* silence compiler */
	if (CHECKDIRTY(b->colorMaterial, bitID))
	{
		if (from->colorMaterialFace != to->colorMaterialFace ||
		    from->colorMaterialMode != to->colorMaterialMode)
		{
			diff_api.ColorMaterial(to->colorMaterialFace,
			    to->colorMaterialMode);
			from->colorMaterialFace = to->colorMaterialFace;
			from->colorMaterialMode = to->colorMaterialMode;
		}
		CLEARDIRTY(b->colorMaterial, nbitID);
	}
	if (CHECKDIRTY(b->enable, bitID))
	{
		glAble able[2];
		able[0] = diff_api.Disable;
		able[1] = diff_api.Enable;
		if (from->lighting != to->lighting)
		{
			able[to->lighting](GL_LIGHTING);
			from->lighting = to->lighting;
		}
		if (from->colorMaterial != to->colorMaterial)
		{
			able[to->colorMaterial](GL_COLOR_MATERIAL);
			from->colorMaterial = to->colorMaterial;
		}
		if (from->colorSumEXT != to->colorSumEXT)
		{
			able[to->colorSumEXT](GL_COLOR_SUM_EXT);
			from->colorSumEXT = to->colorSumEXT;
		}
		CLEARDIRTY(b->enable, nbitID);
	}
	if (CHECKDIRTY(b->shadeModel, bitID))
	{
		if (from->shadeModel != to->shadeModel)
		{
			diff_api.ShadeModel(to->shadeModel);
			from->shadeModel = to->shadeModel;
		}
		CLEARDIRTY(b->shadeModel, nbitID);
	}
	if (CHECKDIRTY(b->lightModel, bitID))
	{
		if (from->lightModelAmbient.r != to->lightModelAmbient.r ||
		    from->lightModelAmbient.g != to->lightModelAmbient.g ||
		    from->lightModelAmbient.b != to->lightModelAmbient.b ||
		    from->lightModelAmbient.a != to->lightModelAmbient.a)
		{
			GLfloat varg[4];
			varg[0] = to->lightModelAmbient.r;
			varg[1] = to->lightModelAmbient.g;
			varg[2] = to->lightModelAmbient.b;
			varg[3] = to->lightModelAmbient.a;
			diff_api.LightModelfv(GL_LIGHT_MODEL_AMBIENT, varg);
			from->lightModelAmbient = to->lightModelAmbient;
		}
		if (from->lightModelLocalViewer != to->lightModelLocalViewer)
		{
			diff_api.LightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, to->lightModelLocalViewer==GL_TRUE);
			from->lightModelLocalViewer = to->lightModelLocalViewer;
		}
		if (from->lightModelTwoSide != to->lightModelTwoSide)
		{
			diff_api.LightModeli(GL_LIGHT_MODEL_TWO_SIDE, to->lightModelTwoSide==GL_TRUE);
			from->lightModelTwoSide = to->lightModelTwoSide;
		}
		if (from->lightModelColorControlEXT != to->lightModelColorControlEXT)
		{
			diff_api.LightModeli(GL_LIGHT_MODEL_COLOR_CONTROL_EXT, to->lightModelColorControlEXT);
			from->lightModelColorControlEXT = to->lightModelColorControlEXT;
		}
		CLEARDIRTY(b->lightModel, nbitID);
	}
	if (CHECKDIRTY(b->material, bitID))
	{
		if (from->ambient[0].r != to->ambient[0].r ||
		    from->ambient[0].g != to->ambient[0].g ||
		    from->ambient[0].b != to->ambient[0].b ||
		    from->ambient[0].a != to->ambient[0].a)
		{
			GLfloat varg[4];
			varg[0] = to->ambient[0].r;
			varg[1] = to->ambient[0].g;
			varg[2] = to->ambient[0].b;
			varg[3] = to->ambient[0].a;
			diff_api.Materialfv( GL_FRONT,  GL_AMBIENT, varg);
			from->ambient[0] = to->ambient[0];
		}
		if (from->ambient[1].r != to->ambient[1].r ||
		    from->ambient[1].g != to->ambient[1].g ||
		    from->ambient[1].b != to->ambient[1].b ||
		    from->ambient[1].a != to->ambient[1].a)
		{
			GLfloat varg[4];
			varg[0] = to->ambient[1].r;
			varg[1] = to->ambient[1].g;
			varg[2] = to->ambient[1].b;
			varg[3] = to->ambient[1].a;
			diff_api.Materialfv( GL_BACK,  GL_AMBIENT, varg);
			from->ambient[1] = to->ambient[1];
		}
		if (from->diffuse[0].r != to->diffuse[0].r ||
		    from->diffuse[0].g != to->diffuse[0].g ||
		    from->diffuse[0].b != to->diffuse[0].b ||
		    from->diffuse[0].a != to->diffuse[0].a)
		{
			GLfloat varg[4];
			varg[0] = to->diffuse[0].r;
			varg[1] = to->diffuse[0].g;
			varg[2] = to->diffuse[0].b;
			varg[3] = to->diffuse[0].a;
			diff_api.Materialfv( GL_FRONT,  GL_DIFFUSE, varg);
			from->diffuse[0] = to->diffuse[0];
		}
		if (from->diffuse[1].r != to->diffuse[1].r ||
		    from->diffuse[1].g != to->diffuse[1].g ||
		    from->diffuse[1].b != to->diffuse[1].b ||
		    from->diffuse[1].a != to->diffuse[1].a)
		{
			GLfloat varg[4];
			varg[0] = to->diffuse[1].r;
			varg[1] = to->diffuse[1].g;
			varg[2] = to->diffuse[1].b;
			varg[3] = to->diffuse[1].a;
			diff_api.Materialfv( GL_BACK,  GL_DIFFUSE, varg);
			from->diffuse[1] = to->diffuse[1];
		}
		if (from->specular[0].r != to->specular[0].r ||
		    from->specular[0].g != to->specular[0].g ||
		    from->specular[0].b != to->specular[0].b ||
		    from->specular[0].a != to->specular[0].a)
		{
			GLfloat varg[4];
			varg[0] = to->specular[0].r;
			varg[1] = to->specular[0].g;
			varg[2] = to->specular[0].b;
			varg[3] = to->specular[0].a;
			diff_api.Materialfv( GL_FRONT,  GL_SPECULAR, varg);
			from->specular[0] = to->specular[0];
		}
		if (from->specular[1].r != to->specular[1].r ||
		    from->specular[1].g != to->specular[1].g ||
		    from->specular[1].b != to->specular[1].b ||
		    from->specular[1].a != to->specular[1].a)
		{
			GLfloat varg[4];
			varg[0] = to->specular[1].r;
			varg[1] = to->specular[1].g;
			varg[2] = to->specular[1].b;
			varg[3] = to->specular[1].a;
			diff_api.Materialfv( GL_BACK,  GL_SPECULAR, varg);
			from->specular[1] = to->specular[1];
		}
		if (from->emission[0].r != to->emission[0].r ||
		    from->emission[0].g != to->emission[0].g ||
		    from->emission[0].b != to->emission[0].b ||
		    from->emission[0].a != to->emission[0].a)
		{
			GLfloat varg[4];
			varg[0] = to->emission[0].r;
			varg[1] = to->emission[0].g;
			varg[2] = to->emission[0].b;
			varg[3] = to->emission[0].a;
			diff_api.Materialfv( GL_FRONT,  GL_EMISSION, varg);
			from->emission[0] = to->emission[0];
		}
		if (from->emission[1].r != to->emission[1].r ||
		    from->emission[1].g != to->emission[1].g ||
		    from->emission[1].b != to->emission[1].b ||
		    from->emission[1].a != to->emission[1].a)
		{
			GLfloat varg[4];
			varg[0] = to->emission[1].r;
			varg[1] = to->emission[1].g;
			varg[2] = to->emission[1].b;
			varg[3] = to->emission[1].a;
			diff_api.Materialfv( GL_BACK,  GL_EMISSION, varg);
			from->emission[1] = to->emission[1];
		}
		if (from->shininess[0] != to->shininess[0])
		{
			diff_api.Materialf( GL_FRONT,  GL_SHININESS, to->shininess[0]);
			from->shininess[0] = to->shininess[0];
		}
		if (from->shininess[1] != to->shininess[1])
		{
			diff_api.Materialf( GL_BACK,  GL_SHININESS, to->shininess[1]);
			from->shininess[1] = to->shininess[1];
		}
		CLEARDIRTY(b->material, nbitID);
	}
	for (i=0; i<CR_MAX_LIGHTS; i++) {
		CRLightBits *lb = b->light+i;
		CRLight *tl = to->light+i;
		CRLight *cl = from->light+i;
		if (!(CHECKDIRTY(lb->dirty, bitID))) continue;
		if (CHECKDIRTY(lb->enable, bitID))
		{
			glAble able[2];
			able[0] = diff_api.Disable;
			able[1] = diff_api.Enable;
			if (cl->enable != tl->enable)
			{
				able[tl->enable](GL_LIGHT0+i);
				cl->enable = tl->enable;
			}
			CLEARDIRTY(lb->enable, nbitID);
		}
		if (CHECKDIRTY(lb->ambient, bitID))
		{
			if (cl->ambient.r != tl->ambient.r ||
			    cl->ambient.g != tl->ambient.g ||
			    cl->ambient.b != tl->ambient.b ||
			    cl->ambient.a != tl->ambient.a)
			{
				GLfloat varg[4];
				varg[0] = tl->ambient.r;
				varg[1] = tl->ambient.g;
				varg[2] = tl->ambient.b;
				varg[3] = tl->ambient.a;
				diff_api.Lightfv( GL_LIGHT0+i,  GL_AMBIENT, varg);
				cl->ambient = tl->ambient;
			}
			CLEARDIRTY(lb->ambient, nbitID);
		}
		if (CHECKDIRTY(lb->diffuse, bitID))
		{
			if (cl->diffuse.r != tl->diffuse.r ||
			    cl->diffuse.g != tl->diffuse.g ||
			    cl->diffuse.b != tl->diffuse.b ||
			    cl->diffuse.a != tl->diffuse.a)
			{
				GLfloat varg[4];
				varg[0] = tl->diffuse.r;
				varg[1] = tl->diffuse.g;
				varg[2] = tl->diffuse.b;
				varg[3] = tl->diffuse.a;
				diff_api.Lightfv( GL_LIGHT0+i,  GL_DIFFUSE, varg);
				cl->diffuse = tl->diffuse;
			}
			CLEARDIRTY(lb->diffuse, nbitID);
		}
		if (CHECKDIRTY(lb->specular, bitID))
		{
			if (cl->specular.r != tl->specular.r ||
			    cl->specular.g != tl->specular.g ||
			    cl->specular.b != tl->specular.b ||
			    cl->specular.a != tl->specular.a)
			{
				GLfloat varg[4];
				varg[0] = tl->specular.r;
				varg[1] = tl->specular.g;
				varg[2] = tl->specular.b;
				varg[3] = tl->specular.a;
				diff_api.Lightfv( GL_LIGHT0+i,  GL_SPECULAR, varg);
				cl->specular = tl->specular;
			}
			CLEARDIRTY(lb->specular, nbitID);
		}
		if (CHECKDIRTY(lb->attenuation, bitID))
		{
			if (cl->constantAttenuation != tl->constantAttenuation)
			{
				diff_api.Lightf( GL_LIGHT0+i,  GL_CONSTANT_ATTENUATION, tl->constantAttenuation);
				cl->constantAttenuation = tl->constantAttenuation;
			}
			if (cl->linearAttenuation != tl->linearAttenuation)
			{
				diff_api.Lightf( GL_LIGHT0+i,  GL_LINEAR_ATTENUATION, tl->linearAttenuation);
				cl->linearAttenuation = tl->linearAttenuation;
			}
			if (cl->quadraticAttenuation != tl->quadraticAttenuation)
			{
				diff_api.Lightf( GL_LIGHT0+i,  GL_QUADRATIC_ATTENUATION, tl->quadraticAttenuation);
				cl->quadraticAttenuation = tl->quadraticAttenuation;
			}
			CLEARDIRTY(lb->attenuation, nbitID);
		}
		if (CHECKDIRTY(lb->position, bitID))
		{
			diff_api.MatrixMode(GL_MODELVIEW);
			diff_api.PushMatrix();
			diff_api.LoadIdentity();
			if (cl->position.x != tl->position.x ||
			    cl->position.y != tl->position.y ||
			    cl->position.z != tl->position.z ||
			    cl->position.w != tl->position.w)
			{
				GLfloat varg[4];
				varg[0] = tl->position.x;
				varg[1] = tl->position.y;
				varg[2] = tl->position.z;
				varg[3] = tl->position.w;
				diff_api.Lightfv( GL_LIGHT0+i,  GL_POSITION, varg);
				cl->position = tl->position;
			}
			diff_api.PopMatrix();
			diff_api.MatrixMode(toCtx->transform.matrixMode);
			CLEARDIRTY(lb->position, nbitID);
		}
		if (CHECKDIRTY(lb->spot, bitID))
		{
			diff_api.MatrixMode(GL_MODELVIEW);
			diff_api.PushMatrix();
			diff_api.LoadIdentity();
			if (cl->spotDirection.x != tl->spotDirection.x ||
			    cl->spotDirection.y != tl->spotDirection.y ||
			    cl->spotDirection.z != tl->spotDirection.z)
			{
				GLfloat varg[3];
				varg[0] = tl->spotDirection.x;
				varg[1] = tl->spotDirection.y;
				varg[2] = tl->spotDirection.z;
				diff_api.Lightfv( GL_LIGHT0+i,  GL_SPOT_DIRECTION, varg);
				cl->spotDirection = tl->spotDirection;
			}
			if (cl->spotExponent != tl->spotExponent)
			{
				diff_api.Lightf( GL_LIGHT0+i,  GL_SPOT_EXPONENT, tl->spotExponent);
				cl->spotExponent = tl->spotExponent;
			}
			if (cl->spotCutoff != tl->spotCutoff)
			{
				diff_api.Lightf( GL_LIGHT0+i,  GL_SPOT_CUTOFF, tl->spotCutoff);
				cl->spotCutoff = tl->spotCutoff;
			}
			diff_api.PopMatrix();
			diff_api.MatrixMode(toCtx->transform.matrixMode);
			CLEARDIRTY(lb->spot, nbitID);
		}
		CLEARDIRTY(lb->dirty, nbitID);
	}
	CLEARDIRTY(b->dirty, nbitID);
}

void crStateLightingSwitch(CRLightingBits *b, CRbitvalue *bitID,
		CRContext *fromCtx, CRContext *toCtx)
{
	CRLightingState *from = &(fromCtx->lighting);
	CRLightingState *to = &(toCtx->lighting);
	unsigned int j, i;
	CRbitvalue nbitID[CR_MAX_BITARRAY];
	for (j = 0; j<CR_MAX_BITARRAY; j++)
		nbitID[j] = ~bitID[j];
	i = 0; /* silence compiler */
	if (CHECKDIRTY(b->colorMaterial, bitID))
	{
		if (from->colorMaterialFace != to->colorMaterialFace ||
		    from->colorMaterialMode != to->colorMaterialMode)
		{
			diff_api.ColorMaterial(to->colorMaterialFace,
			    to->colorMaterialMode);
			FILLDIRTY(b->colorMaterial);
			FILLDIRTY(b->dirty);
		}
		CLEARDIRTY(b->colorMaterial, nbitID);
	}
	if (CHECKDIRTY(b->enable, bitID))
	{
		glAble able[2];
		able[0] = diff_api.Disable;
		able[1] = diff_api.Enable;
		if (from->lighting != to->lighting)
		{
			able[to->lighting](GL_LIGHTING);
			FILLDIRTY(b->enable);
			FILLDIRTY(b->dirty);
		}
		if (from->colorMaterial != to->colorMaterial)
		{
			able[to->colorMaterial](GL_COLOR_MATERIAL);
			FILLDIRTY(b->enable);
			FILLDIRTY(b->dirty);
		}
		if (from->colorSumEXT != to->colorSumEXT)
		{
			able[to->colorSumEXT](GL_COLOR_SUM_EXT);
			FILLDIRTY(b->enable);
			FILLDIRTY(b->dirty);
		}
		CLEARDIRTY(b->enable, nbitID);
	}
	if (CHECKDIRTY(b->shadeModel, bitID))
	{
		if (from->shadeModel != to->shadeModel)
		{
			diff_api.ShadeModel(to->shadeModel);
			FILLDIRTY(b->shadeModel);
			FILLDIRTY(b->dirty);
		}
		CLEARDIRTY(b->shadeModel, nbitID);
	}
	if (CHECKDIRTY(b->lightModel, bitID))
	{
		if (from->lightModelAmbient.r != to->lightModelAmbient.r ||
		    from->lightModelAmbient.g != to->lightModelAmbient.g ||
		    from->lightModelAmbient.b != to->lightModelAmbient.b ||
		    from->lightModelAmbient.a != to->lightModelAmbient.a)
		{
			GLfloat varg[4];
			varg[0] = to->lightModelAmbient.r;
			varg[1] = to->lightModelAmbient.g;
			varg[2] = to->lightModelAmbient.b;
			varg[3] = to->lightModelAmbient.a;
			diff_api.LightModelfv(GL_LIGHT_MODEL_AMBIENT, varg);
			FILLDIRTY(b->lightModel);
			FILLDIRTY(b->dirty);
		}
		if (from->lightModelLocalViewer != to->lightModelLocalViewer)
		{
			diff_api.LightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, to->lightModelLocalViewer==GL_TRUE);
			FILLDIRTY(b->lightModel);
			FILLDIRTY(b->dirty);
		}
		if (from->lightModelTwoSide != to->lightModelTwoSide)
		{
			diff_api.LightModeli(GL_LIGHT_MODEL_TWO_SIDE, to->lightModelTwoSide==GL_TRUE);
			FILLDIRTY(b->lightModel);
			FILLDIRTY(b->dirty);
		}
		if (from->lightModelColorControlEXT != to->lightModelColorControlEXT)
		{
			diff_api.LightModeli(GL_LIGHT_MODEL_COLOR_CONTROL_EXT, to->lightModelColorControlEXT);
			FILLDIRTY(b->lightModel);
			FILLDIRTY(b->dirty);
		}
		CLEARDIRTY(b->lightModel, nbitID);
	}
	if (CHECKDIRTY(b->material, bitID))
	{
		if (from->ambient[0].r != to->ambient[0].r ||
		    from->ambient[0].g != to->ambient[0].g ||
		    from->ambient[0].b != to->ambient[0].b ||
		    from->ambient[0].a != to->ambient[0].a)
		{
			GLfloat varg[4];
			varg[0] = to->ambient[0].r;
			varg[1] = to->ambient[0].g;
			varg[2] = to->ambient[0].b;
			varg[3] = to->ambient[0].a;
			diff_api.Materialfv( GL_FRONT,  GL_AMBIENT, varg);
			FILLDIRTY(b->material);
			FILLDIRTY(b->dirty);
		}
		if (from->ambient[1].r != to->ambient[1].r ||
		    from->ambient[1].g != to->ambient[1].g ||
		    from->ambient[1].b != to->ambient[1].b ||
		    from->ambient[1].a != to->ambient[1].a)
		{
			GLfloat varg[4];
			varg[0] = to->ambient[1].r;
			varg[1] = to->ambient[1].g;
			varg[2] = to->ambient[1].b;
			varg[3] = to->ambient[1].a;
			diff_api.Materialfv( GL_BACK,  GL_AMBIENT, varg);
			FILLDIRTY(b->material);
			FILLDIRTY(b->dirty);
		}
		if (from->diffuse[0].r != to->diffuse[0].r ||
		    from->diffuse[0].g != to->diffuse[0].g ||
		    from->diffuse[0].b != to->diffuse[0].b ||
		    from->diffuse[0].a != to->diffuse[0].a)
		{
			GLfloat varg[4];
			varg[0] = to->diffuse[0].r;
			varg[1] = to->diffuse[0].g;
			varg[2] = to->diffuse[0].b;
			varg[3] = to->diffuse[0].a;
			diff_api.Materialfv( GL_FRONT,  GL_DIFFUSE, varg);
			FILLDIRTY(b->material);
			FILLDIRTY(b->dirty);
		}
		if (from->diffuse[1].r != to->diffuse[1].r ||
		    from->diffuse[1].g != to->diffuse[1].g ||
		    from->diffuse[1].b != to->diffuse[1].b ||
		    from->diffuse[1].a != to->diffuse[1].a)
		{
			GLfloat varg[4];
			varg[0] = to->diffuse[1].r;
			varg[1] = to->diffuse[1].g;
			varg[2] = to->diffuse[1].b;
			varg[3] = to->diffuse[1].a;
			diff_api.Materialfv( GL_BACK,  GL_DIFFUSE, varg);
			FILLDIRTY(b->material);
			FILLDIRTY(b->dirty);
		}
		if (from->specular[0].r != to->specular[0].r ||
		    from->specular[0].g != to->specular[0].g ||
		    from->specular[0].b != to->specular[0].b ||
		    from->specular[0].a != to->specular[0].a)
		{
			GLfloat varg[4];
			varg[0] = to->specular[0].r;
			varg[1] = to->specular[0].g;
			varg[2] = to->specular[0].b;
			varg[3] = to->specular[0].a;
			diff_api.Materialfv( GL_FRONT,  GL_SPECULAR, varg);
			FILLDIRTY(b->material);
			FILLDIRTY(b->dirty);
		}
		if (from->specular[1].r != to->specular[1].r ||
		    from->specular[1].g != to->specular[1].g ||
		    from->specular[1].b != to->specular[1].b ||
		    from->specular[1].a != to->specular[1].a)
		{
			GLfloat varg[4];
			varg[0] = to->specular[1].r;
			varg[1] = to->specular[1].g;
			varg[2] = to->specular[1].b;
			varg[3] = to->specular[1].a;
			diff_api.Materialfv( GL_BACK,  GL_SPECULAR, varg);
			FILLDIRTY(b->material);
			FILLDIRTY(b->dirty);
		}
		if (from->emission[0].r != to->emission[0].r ||
		    from->emission[0].g != to->emission[0].g ||
		    from->emission[0].b != to->emission[0].b ||
		    from->emission[0].a != to->emission[0].a)
		{
			GLfloat varg[4];
			varg[0] = to->emission[0].r;
			varg[1] = to->emission[0].g;
			varg[2] = to->emission[0].b;
			varg[3] = to->emission[0].a;
			diff_api.Materialfv( GL_FRONT,  GL_EMISSION, varg);
			FILLDIRTY(b->material);
			FILLDIRTY(b->dirty);
		}
		if (from->emission[1].r != to->emission[1].r ||
		    from->emission[1].g != to->emission[1].g ||
		    from->emission[1].b != to->emission[1].b ||
		    from->emission[1].a != to->emission[1].a)
		{
			GLfloat varg[4];
			varg[0] = to->emission[1].r;
			varg[1] = to->emission[1].g;
			varg[2] = to->emission[1].b;
			varg[3] = to->emission[1].a;
			diff_api.Materialfv( GL_BACK,  GL_EMISSION, varg);
			FILLDIRTY(b->material);
			FILLDIRTY(b->dirty);
		}
		if (from->shininess[0] != to->shininess[0])
		{
			diff_api.Materialf( GL_FRONT,  GL_SHININESS, to->shininess[0]);
			FILLDIRTY(b->material);
			FILLDIRTY(b->dirty);
		}
		if (from->shininess[1] != to->shininess[1])
		{
			diff_api.Materialf( GL_BACK,  GL_SHININESS, to->shininess[1]);
			FILLDIRTY(b->material);
			FILLDIRTY(b->dirty);
		}
		CLEARDIRTY(b->material, nbitID);
	}
	for (i=0; i<CR_MAX_LIGHTS; i++) {
		CRLightBits *lb = b->light+i;
		CRLight *tl = to->light+i;
		CRLight *cl = from->light+i;
		if (!(CHECKDIRTY(lb->dirty, bitID))) continue;
		if (CHECKDIRTY(lb->enable, bitID))
		{
			glAble able[2];
			able[0] = diff_api.Disable;
			able[1] = diff_api.Enable;
			if (cl->enable != tl->enable)
			{
				able[tl->enable](GL_LIGHT0+i);
				FILLDIRTY(lb->enable);
				FILLDIRTY(lb->dirty);
				FILLDIRTY(b->dirty);
			}
			CLEARDIRTY(lb->enable, nbitID);
		}
		if (CHECKDIRTY(lb->ambient, bitID))
		{
			if (cl->ambient.r != tl->ambient.r ||
			    cl->ambient.g != tl->ambient.g ||
			    cl->ambient.b != tl->ambient.b ||
			    cl->ambient.a != tl->ambient.a)
			{
				GLfloat varg[4];
				varg[0] = tl->ambient.r;
				varg[1] = tl->ambient.g;
				varg[2] = tl->ambient.b;
				varg[3] = tl->ambient.a;
				diff_api.Lightfv( GL_LIGHT0+i,  GL_AMBIENT, varg);
				FILLDIRTY(lb->ambient);
				FILLDIRTY(lb->dirty);
				FILLDIRTY(b->dirty);
			}
			CLEARDIRTY(lb->ambient, nbitID);
		}
		if (CHECKDIRTY(lb->diffuse, bitID))
		{
			if (cl->diffuse.r != tl->diffuse.r ||
			    cl->diffuse.g != tl->diffuse.g ||
			    cl->diffuse.b != tl->diffuse.b ||
			    cl->diffuse.a != tl->diffuse.a)
			{
				GLfloat varg[4];
				varg[0] = tl->diffuse.r;
				varg[1] = tl->diffuse.g;
				varg[2] = tl->diffuse.b;
				varg[3] = tl->diffuse.a;
				diff_api.Lightfv( GL_LIGHT0+i,  GL_DIFFUSE, varg);
				FILLDIRTY(lb->diffuse);
				FILLDIRTY(lb->dirty);
				FILLDIRTY(b->dirty);
			}
			CLEARDIRTY(lb->diffuse, nbitID);
		}
		if (CHECKDIRTY(lb->specular, bitID))
		{
			if (cl->specular.r != tl->specular.r ||
			    cl->specular.g != tl->specular.g ||
			    cl->specular.b != tl->specular.b ||
			    cl->specular.a != tl->specular.a)
			{
				GLfloat varg[4];
				varg[0] = tl->specular.r;
				varg[1] = tl->specular.g;
				varg[2] = tl->specular.b;
				varg[3] = tl->specular.a;
				diff_api.Lightfv( GL_LIGHT0+i,  GL_SPECULAR, varg);
				FILLDIRTY(lb->specular);
				FILLDIRTY(lb->dirty);
				FILLDIRTY(b->dirty);
			}
			CLEARDIRTY(lb->specular, nbitID);
		}
		if (CHECKDIRTY(lb->attenuation, bitID))
		{
			if (cl->constantAttenuation != tl->constantAttenuation)
			{
				diff_api.Lightf( GL_LIGHT0+i,  GL_CONSTANT_ATTENUATION, tl->constantAttenuation);
				FILLDIRTY(lb->attenuation);
				FILLDIRTY(lb->dirty);
				FILLDIRTY(b->dirty);
			}
			if (cl->linearAttenuation != tl->linearAttenuation)
			{
				diff_api.Lightf( GL_LIGHT0+i,  GL_LINEAR_ATTENUATION, tl->linearAttenuation);
				FILLDIRTY(lb->attenuation);
				FILLDIRTY(lb->dirty);
				FILLDIRTY(b->dirty);
			}
			if (cl->quadraticAttenuation != tl->quadraticAttenuation)
			{
				diff_api.Lightf( GL_LIGHT0+i,  GL_QUADRATIC_ATTENUATION, tl->quadraticAttenuation);
				FILLDIRTY(lb->attenuation);
				FILLDIRTY(lb->dirty);
				FILLDIRTY(b->dirty);
			}
			CLEARDIRTY(lb->attenuation, nbitID);
		}
		if (CHECKDIRTY(lb->position, bitID))
		{
			diff_api.MatrixMode(GL_MODELVIEW);
			diff_api.PushMatrix();
			diff_api.LoadIdentity();
			if (cl->position.x != tl->position.x ||
			    cl->position.y != tl->position.y ||
			    cl->position.z != tl->position.z ||
			    cl->position.w != tl->position.w)
			{
				GLfloat varg[4];
				varg[0] = tl->position.x;
				varg[1] = tl->position.y;
				varg[2] = tl->position.z;
				varg[3] = tl->position.w;
				diff_api.Lightfv( GL_LIGHT0+i,  GL_POSITION, varg);
				FILLDIRTY(lb->position);
				FILLDIRTY(lb->dirty);
				FILLDIRTY(b->dirty);
			}
			diff_api.PopMatrix();
			diff_api.MatrixMode(toCtx->transform.matrixMode);
			CLEARDIRTY(lb->position, nbitID);
		}
		if (CHECKDIRTY(lb->spot, bitID))
		{
			diff_api.MatrixMode(GL_MODELVIEW);
			diff_api.PushMatrix();
			diff_api.LoadIdentity();
			if (cl->spotDirection.x != tl->spotDirection.x ||
			    cl->spotDirection.y != tl->spotDirection.y ||
			    cl->spotDirection.z != tl->spotDirection.z)
			{
				GLfloat varg[3];
				varg[0] = tl->spotDirection.x;
				varg[1] = tl->spotDirection.y;
				varg[2] = tl->spotDirection.z;
				diff_api.Lightfv( GL_LIGHT0+i,  GL_SPOT_DIRECTION, varg);
				FILLDIRTY(lb->spot);
				FILLDIRTY(lb->dirty);
				FILLDIRTY(b->dirty);
			}
			if (cl->spotExponent != tl->spotExponent)
			{
				diff_api.Lightf( GL_LIGHT0+i,  GL_SPOT_EXPONENT, tl->spotExponent);
				FILLDIRTY(lb->spot);
				FILLDIRTY(lb->dirty);
				FILLDIRTY(b->dirty);
			}
			if (cl->spotCutoff != tl->spotCutoff)
			{
				diff_api.Lightf( GL_LIGHT0+i,  GL_SPOT_CUTOFF, tl->spotCutoff);
				FILLDIRTY(lb->spot);
				FILLDIRTY(lb->dirty);
				FILLDIRTY(b->dirty);
			}
			diff_api.PopMatrix();
			diff_api.MatrixMode(toCtx->transform.matrixMode);
			CLEARDIRTY(lb->spot, nbitID);
		}
		CLEARDIRTY(lb->dirty, nbitID);
	}
	CLEARDIRTY(b->dirty, nbitID);
}

