/* This code is AUTOGENERATED!!! */

#include "state.h"
#include "state_internals.h"

void crStatePolygonDiff(CRPolygonBits *b, CRbitvalue *bitID,
		CRContext *fromCtx, CRContext *toCtx)
{
	CRPolygonState *from = &(fromCtx->polygon);
	CRPolygonState *to = &(toCtx->polygon);
	unsigned int j, i;
	CRbitvalue nbitID[CR_MAX_BITARRAY];
	for (j = 0; j<CR_MAX_BITARRAY; j++)
		nbitID[j] = ~bitID[j];
	i = 0; /* silence compiler */
	if (CHECKDIRTY(b->enable, bitID))
	{
		glAble able[2];
		able[0] = diff_api.Disable;
		able[1] = diff_api.Enable;
		if (from->polygonSmooth != to->polygonSmooth)
		{
			able[to->polygonSmooth](GL_POLYGON_SMOOTH);
			from->polygonSmooth = to->polygonSmooth;
		}
		if (from->polygonOffsetFill != to->polygonOffsetFill)
		{
			able[to->polygonOffsetFill](GL_POLYGON_OFFSET_FILL);
			from->polygonOffsetFill = to->polygonOffsetFill;
		}
		if (from->polygonOffsetLine != to->polygonOffsetLine)
		{
			able[to->polygonOffsetLine](GL_POLYGON_OFFSET_LINE);
			from->polygonOffsetLine = to->polygonOffsetLine;
		}
		if (from->polygonOffsetPoint != to->polygonOffsetPoint)
		{
			able[to->polygonOffsetPoint](GL_POLYGON_OFFSET_POINT);
			from->polygonOffsetPoint = to->polygonOffsetPoint;
		}
		if (from->polygonStipple != to->polygonStipple)
		{
			able[to->polygonStipple](GL_POLYGON_STIPPLE);
			from->polygonStipple = to->polygonStipple;
		}
		if (from->cullFace != to->cullFace)
		{
			able[to->cullFace](GL_CULL_FACE);
			from->cullFace = to->cullFace;
		}
		CLEARDIRTY(b->enable, nbitID);
	}
	if (CHECKDIRTY(b->offset, bitID))
	{
		if (from->offsetFactor != to->offsetFactor ||
		    from->offsetUnits != to->offsetUnits)
		{
			diff_api.PolygonOffset(to->offsetFactor,
			    to->offsetUnits);
			from->offsetFactor = to->offsetFactor;
			from->offsetUnits = to->offsetUnits;
		}
		CLEARDIRTY(b->offset, nbitID);
	}
	if (CHECKDIRTY(b->mode, bitID))
	{
		if (from->frontFace != to->frontFace)
		{
			diff_api.FrontFace(to->frontFace);
			from->frontFace = to->frontFace;
		}
		if (from->cullFaceMode != to->cullFaceMode)
		{
			diff_api.CullFace(to->cullFaceMode);
			from->cullFaceMode = to->cullFaceMode;
		}
		if (from->backMode != to->backMode)
		{
			diff_api.PolygonMode(GL_BACK, to->backMode);
			from->backMode = to->backMode;
		}
		if (from->frontMode != to->frontMode)
		{
			diff_api.PolygonMode(GL_FRONT, to->frontMode);
			from->frontMode = to->frontMode;
		}
		CLEARDIRTY(b->mode, nbitID);
	}
	if (CHECKDIRTY(b->stipple, bitID))
	{
		int iStripple;
		diff_api.PolygonStipple ((GLubyte *) to->stipple);
		for (iStripple=0; iStripple<32; iStripple++)
		{
			from->stipple[iStripple] = to->stipple[iStripple];
		}
		CLEARDIRTY(b->stipple, nbitID);
	}
	CLEARDIRTY(b->dirty, nbitID);
}

void crStatePolygonSwitch(CRPolygonBits *b, CRbitvalue *bitID,
		CRContext *fromCtx, CRContext *toCtx)
{
	CRPolygonState *from = &(fromCtx->polygon);
	CRPolygonState *to = &(toCtx->polygon);
	unsigned int j, i;
	CRbitvalue nbitID[CR_MAX_BITARRAY];
	for (j = 0; j<CR_MAX_BITARRAY; j++)
		nbitID[j] = ~bitID[j];
	i = 0; /* silence compiler */
	if (CHECKDIRTY(b->enable, bitID))
	{
		glAble able[2];
		able[0] = diff_api.Disable;
		able[1] = diff_api.Enable;
		if (from->polygonSmooth != to->polygonSmooth)
		{
			able[to->polygonSmooth](GL_POLYGON_SMOOTH);
			FILLDIRTY(b->enable);
			FILLDIRTY(b->dirty);
		}
		if (from->polygonOffsetFill != to->polygonOffsetFill)
		{
			able[to->polygonOffsetFill](GL_POLYGON_OFFSET_FILL);
			FILLDIRTY(b->enable);
			FILLDIRTY(b->dirty);
		}
		if (from->polygonOffsetLine != to->polygonOffsetLine)
		{
			able[to->polygonOffsetLine](GL_POLYGON_OFFSET_LINE);
			FILLDIRTY(b->enable);
			FILLDIRTY(b->dirty);
		}
		if (from->polygonOffsetPoint != to->polygonOffsetPoint)
		{
			able[to->polygonOffsetPoint](GL_POLYGON_OFFSET_POINT);
			FILLDIRTY(b->enable);
			FILLDIRTY(b->dirty);
		}
		if (from->polygonStipple != to->polygonStipple)
		{
			able[to->polygonStipple](GL_POLYGON_STIPPLE);
			FILLDIRTY(b->enable);
			FILLDIRTY(b->dirty);
		}
		if (from->cullFace != to->cullFace)
		{
			able[to->cullFace](GL_CULL_FACE);
			FILLDIRTY(b->enable);
			FILLDIRTY(b->dirty);
		}
		CLEARDIRTY(b->enable, nbitID);
	}
	if (CHECKDIRTY(b->offset, bitID))
	{
		if (from->offsetFactor != to->offsetFactor ||
		    from->offsetUnits != to->offsetUnits)
		{
			diff_api.PolygonOffset(to->offsetFactor,
			    to->offsetUnits);
			FILLDIRTY(b->offset);
			FILLDIRTY(b->dirty);
		}
		CLEARDIRTY(b->offset, nbitID);
	}
	if (CHECKDIRTY(b->mode, bitID))
	{
		if (from->frontFace != to->frontFace)
		{
			diff_api.FrontFace(to->frontFace);
			FILLDIRTY(b->mode);
			FILLDIRTY(b->dirty);
		}
		if (from->cullFaceMode != to->cullFaceMode)
		{
			diff_api.CullFace(to->cullFaceMode);
			FILLDIRTY(b->mode);
			FILLDIRTY(b->dirty);
		}
		if (from->backMode != to->backMode)
		{
			diff_api.PolygonMode(GL_BACK, to->backMode);
			FILLDIRTY(b->mode);
			FILLDIRTY(b->dirty);
		}
		if (from->frontMode != to->frontMode)
		{
			diff_api.PolygonMode(GL_FRONT, to->frontMode);
			FILLDIRTY(b->mode);
			FILLDIRTY(b->dirty);
		}
		CLEARDIRTY(b->mode, nbitID);
	}
	if (CHECKDIRTY(b->stipple, bitID))
	{
		if (from->stipple != to->stipple)
		{
			diff_api.PolygonStipple ((GLubyte *) to->stipple);
			FILLDIRTY(b->stipple);
			FILLDIRTY(b->dirty);
		}
		CLEARDIRTY(b->stipple, nbitID);
	}
	CLEARDIRTY(b->dirty, nbitID);
}

