/* Copyright (c) 2001, Stanford University
	All rights reserved.

	See the file LICENSE.txt for information on redistributing this software. */
	

/* DO NOT EDIT - THIS FILE GENERATED BY THE packer.py SCRIPT */

/* For each of the OpenGL functions we have a packer function which
 * packs the function's opcode and arguments into a buffer.
 */

#include "packer.h"
#include "cr_opcodes.h"


#ifndef IN_RING0
void PACK_APIENTRY crPackAccum(CR_PACKER_CONTEXT_ARGDECL GLenum op, GLfloat value)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_ACCUM_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, op);
	WRITE_DATA(12, GLfloat, value);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackAccumSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum op, GLfloat value)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_ACCUM_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(op));
	WRITE_DATA(12, GLuint, SWAPFLOAT(value));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackActiveStencilFaceEXT(CR_PACKER_CONTEXT_ARGDECL GLenum face)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_ACTIVESTENCILFACEEXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, face);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackActiveStencilFaceEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum face)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_ACTIVESTENCILFACEEXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(face));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackActiveTextureARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_ACTIVETEXTUREARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, texture);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackActiveTextureARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_ACTIVETEXTUREARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(texture));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackAlphaFunc(CR_PACKER_CONTEXT_ARGDECL GLenum func, GLclampf ref)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, func);
	WRITE_DATA(4, GLclampf, ref);
	WRITE_OPCODE(pc, CR_ALPHAFUNC_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackAlphaFuncSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum func, GLclampf ref)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, SWAP32(func));
	WRITE_DATA(4, GLuint, SWAPFLOAT(ref));
	WRITE_OPCODE(pc, CR_ALPHAFUNC_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackArrayElement(CR_PACKER_CONTEXT_ARGDECL GLint i)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLint, i);
	WRITE_OPCODE(pc, CR_ARRAYELEMENT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackArrayElementSWAP(CR_PACKER_CONTEXT_ARGDECL GLint i)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLint, SWAP32(i));
	WRITE_OPCODE(pc, CR_ARRAYELEMENT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackAttachShader(CR_PACKER_CONTEXT_ARGDECL GLuint program, GLuint shader)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_ATTACHSHADER_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, program);
	WRITE_DATA(12, GLuint, shader);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackAttachShaderSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint program, GLuint shader)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_ATTACHSHADER_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(program));
	WRITE_DATA(12, GLuint, SWAP32(shader));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackBarrierCreateCR(CR_PACKER_CONTEXT_ARGDECL GLuint name, GLuint count)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_BARRIERCREATECR_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, name);
	WRITE_DATA(12, GLuint, count);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBarrierCreateCRSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint name, GLuint count)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_BARRIERCREATECR_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(name));
	WRITE_DATA(12, GLuint, SWAP32(count));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackBarrierDestroyCR(CR_PACKER_CONTEXT_ARGDECL GLuint name)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_BARRIERDESTROYCR_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, name);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBarrierDestroyCRSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint name)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_BARRIERDESTROYCR_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(name));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackBarrierExecCR(CR_PACKER_CONTEXT_ARGDECL GLuint name)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_BARRIEREXECCR_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, name);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBarrierExecCRSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint name)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_BARRIEREXECCR_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(name));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackBindBufferARB(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint buffer)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_BINDBUFFERARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, buffer);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBindBufferARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint buffer)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_BINDBUFFERARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(buffer));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackBindFramebufferEXT(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint framebuffer)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_BINDFRAMEBUFFEREXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, framebuffer);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBindFramebufferEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint framebuffer)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_BINDFRAMEBUFFEREXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(framebuffer));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackBindProgramARB(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint program)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_BINDPROGRAMARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, program);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBindProgramARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint program)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_BINDPROGRAMARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(program));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackBindProgramNV(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint id)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_BINDPROGRAMNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, id);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBindProgramNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint id)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_BINDPROGRAMNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(id));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackBindRenderbufferEXT(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint renderbuffer)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_BINDRENDERBUFFEREXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, renderbuffer);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBindRenderbufferEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint renderbuffer)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_BINDRENDERBUFFEREXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(renderbuffer));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackBindTexture(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint texture)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, target);
	WRITE_DATA(4, GLuint, texture);
	WRITE_OPCODE(pc, CR_BINDTEXTURE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBindTextureSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint texture)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, SWAP32(target));
	WRITE_DATA(4, GLuint, SWAP32(texture));
	WRITE_OPCODE(pc, CR_BINDTEXTURE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackBlendColorEXT(CR_PACKER_CONTEXT_ARGDECL GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, 24);
	WRITE_DATA(4, GLenum, CR_BLENDCOLOREXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLclampf, red);
	WRITE_DATA(12, GLclampf, green);
	WRITE_DATA(16, GLclampf, blue);
	WRITE_DATA(20, GLclampf, alpha);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBlendColorEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, SWAP32(24));
	WRITE_DATA(4, GLenum, SWAP32(CR_BLENDCOLOREXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAPFLOAT(red));
	WRITE_DATA(12, GLuint, SWAPFLOAT(green));
	WRITE_DATA(16, GLuint, SWAPFLOAT(blue));
	WRITE_DATA(20, GLuint, SWAPFLOAT(alpha));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackBlendEquationEXT(CR_PACKER_CONTEXT_ARGDECL GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_BLENDEQUATIONEXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, mode);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBlendEquationEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_BLENDEQUATIONEXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(mode));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackBlendEquationSeparate(CR_PACKER_CONTEXT_ARGDECL GLenum modeRGB, GLenum modeAlpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_BLENDEQUATIONSEPARATE_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, modeRGB);
	WRITE_DATA(12, GLenum, modeAlpha);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBlendEquationSeparateSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum modeRGB, GLenum modeAlpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_BLENDEQUATIONSEPARATE_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(modeRGB));
	WRITE_DATA(12, GLenum, SWAP32(modeAlpha));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackBlendFunc(CR_PACKER_CONTEXT_ARGDECL GLenum sfactor, GLenum dfactor)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, sfactor);
	WRITE_DATA(4, GLenum, dfactor);
	WRITE_OPCODE(pc, CR_BLENDFUNC_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBlendFuncSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum sfactor, GLenum dfactor)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, SWAP32(sfactor));
	WRITE_DATA(4, GLenum, SWAP32(dfactor));
	WRITE_OPCODE(pc, CR_BLENDFUNC_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackBlendFuncSeparateEXT(CR_PACKER_CONTEXT_ARGDECL GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorA, GLenum dfactorA)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, 24);
	WRITE_DATA(4, GLenum, CR_BLENDFUNCSEPARATEEXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, sfactorRGB);
	WRITE_DATA(12, GLenum, dfactorRGB);
	WRITE_DATA(16, GLenum, sfactorA);
	WRITE_DATA(20, GLenum, dfactorA);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBlendFuncSeparateEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorA, GLenum dfactorA)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, SWAP32(24));
	WRITE_DATA(4, GLenum, SWAP32(CR_BLENDFUNCSEPARATEEXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(sfactorRGB));
	WRITE_DATA(12, GLenum, SWAP32(dfactorRGB));
	WRITE_DATA(16, GLenum, SWAP32(sfactorA));
	WRITE_DATA(20, GLenum, SWAP32(dfactorA));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackBlitFramebufferEXT(CR_PACKER_CONTEXT_ARGDECL GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 48);
	WRITE_DATA(0, GLint, 48);
	WRITE_DATA(4, GLenum, CR_BLITFRAMEBUFFEREXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLint, srcX0);
	WRITE_DATA(12, GLint, srcY0);
	WRITE_DATA(16, GLint, srcX1);
	WRITE_DATA(20, GLint, srcY1);
	WRITE_DATA(24, GLint, dstX0);
	WRITE_DATA(28, GLint, dstY0);
	WRITE_DATA(32, GLint, dstX1);
	WRITE_DATA(36, GLint, dstY1);
	WRITE_DATA(40, GLbitfield, mask);
	WRITE_DATA(44, GLenum, filter);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBlitFramebufferEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 48);
	WRITE_DATA(0, GLint, SWAP32(48));
	WRITE_DATA(4, GLenum, SWAP32(CR_BLITFRAMEBUFFEREXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLint, SWAP32(srcX0));
	WRITE_DATA(12, GLint, SWAP32(srcY0));
	WRITE_DATA(16, GLint, SWAP32(srcX1));
	WRITE_DATA(20, GLint, SWAP32(srcY1));
	WRITE_DATA(24, GLint, SWAP32(dstX0));
	WRITE_DATA(28, GLint, SWAP32(dstY0));
	WRITE_DATA(32, GLint, SWAP32(dstX1));
	WRITE_DATA(36, GLint, SWAP32(dstY1));
	WRITE_DATA(40, GLbitfield, SWAP32(mask));
	WRITE_DATA(44, GLenum, SWAP32(filter));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackCallList(CR_PACKER_CONTEXT_ARGDECL GLuint list)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLuint, list);
	WRITE_OPCODE(pc, CR_CALLLIST_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCallListSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint list)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLuint, SWAP32(list));
	WRITE_OPCODE(pc, CR_CALLLIST_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackCheckFramebufferStatusEXT(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_CHECKFRAMEBUFFERSTATUSEXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCheckFramebufferStatusEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_CHECKFRAMEBUFFERSTATUSEXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackChromiumParameterfCR(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLfloat value)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_CHROMIUMPARAMETERFCR_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLfloat, value);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackChromiumParameterfCRSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLfloat value)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_CHROMIUMPARAMETERFCR_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAPFLOAT(value));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
void PACK_APIENTRY crPackChromiumParameteriCR(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLint value)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_CHROMIUMPARAMETERICR_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLint, value);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackChromiumParameteriCRSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLint value)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_CHROMIUMPARAMETERICR_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLint, SWAP32(value));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#ifndef IN_RING0
void PACK_APIENTRY crPackClear(CR_PACKER_CONTEXT_ARGDECL GLbitfield mask)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLbitfield, mask);
	WRITE_OPCODE(pc, CR_CLEAR_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClearSWAP(CR_PACKER_CONTEXT_ARGDECL GLbitfield mask)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLbitfield, SWAP32(mask));
	WRITE_OPCODE(pc, CR_CLEAR_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackClearAccum(CR_PACKER_CONTEXT_ARGDECL GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, 24);
	WRITE_DATA(4, GLenum, CR_CLEARACCUM_EXTEND_OPCODE);
	WRITE_DATA(8, GLfloat, red);
	WRITE_DATA(12, GLfloat, green);
	WRITE_DATA(16, GLfloat, blue);
	WRITE_DATA(20, GLfloat, alpha);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClearAccumSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, SWAP32(24));
	WRITE_DATA(4, GLenum, SWAP32(CR_CLEARACCUM_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAPFLOAT(red));
	WRITE_DATA(12, GLuint, SWAPFLOAT(green));
	WRITE_DATA(16, GLuint, SWAPFLOAT(blue));
	WRITE_DATA(20, GLuint, SWAPFLOAT(alpha));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackClearColor(CR_PACKER_CONTEXT_ARGDECL GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, 24);
	WRITE_DATA(4, GLenum, CR_CLEARCOLOR_EXTEND_OPCODE);
	WRITE_DATA(8, GLclampf, red);
	WRITE_DATA(12, GLclampf, green);
	WRITE_DATA(16, GLclampf, blue);
	WRITE_DATA(20, GLclampf, alpha);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClearColorSWAP(CR_PACKER_CONTEXT_ARGDECL GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, SWAP32(24));
	WRITE_DATA(4, GLenum, SWAP32(CR_CLEARCOLOR_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAPFLOAT(red));
	WRITE_DATA(12, GLuint, SWAPFLOAT(green));
	WRITE_DATA(16, GLuint, SWAPFLOAT(blue));
	WRITE_DATA(20, GLuint, SWAPFLOAT(alpha));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackClearDepth(CR_PACKER_CONTEXT_ARGDECL GLclampd depth)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_CLEARDEPTH_EXTEND_OPCODE);
	WRITE_DOUBLE(8, depth);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClearDepthSWAP(CR_PACKER_CONTEXT_ARGDECL GLclampd depth)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_CLEARDEPTH_EXTEND_OPCODE));
	WRITE_SWAPPED_DOUBLE(8, depth);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackClearIndex(CR_PACKER_CONTEXT_ARGDECL GLfloat c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_CLEARINDEX_EXTEND_OPCODE);
	WRITE_DATA(8, GLfloat, c);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClearIndexSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_CLEARINDEX_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAPFLOAT(c));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackClearStencil(CR_PACKER_CONTEXT_ARGDECL GLint s)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_CLEARSTENCIL_EXTEND_OPCODE);
	WRITE_DATA(8, GLint, s);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClearStencilSWAP(CR_PACKER_CONTEXT_ARGDECL GLint s)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_CLEARSTENCIL_EXTEND_OPCODE));
	WRITE_DATA(8, GLint, SWAP32(s));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackClientActiveTextureARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_CLIENTACTIVETEXTUREARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, texture);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClientActiveTextureARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_CLIENTACTIVETEXTUREARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(texture));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor3b(CR_PACKER_CONTEXT_ARGDECL GLbyte red, GLbyte green, GLbyte blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 4, GL_TRUE);
	pc->current.c.color.b3 = data_ptr;
	WRITE_DATA(0, GLbyte, red);
	WRITE_DATA(1, GLbyte, green);
	WRITE_DATA(2, GLbyte, blue);
	WRITE_OPCODE(pc, CR_COLOR3B_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3bSWAP(CR_PACKER_CONTEXT_ARGDECL GLbyte red, GLbyte green, GLbyte blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 4, GL_TRUE);
	pc->current.c.color.b3 = data_ptr;
	WRITE_DATA(0, GLbyte, red);
	WRITE_DATA(1, GLbyte, green);
	WRITE_DATA(2, GLbyte, blue);
	WRITE_OPCODE(pc, CR_COLOR3B_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor3bv(CR_PACKER_CONTEXT_ARGDECL const GLbyte * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3bv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 4, GL_TRUE);
	pc->current.c.color.b3 = data_ptr;
	WRITE_DATA(0, GLbyte, v[0]);
	WRITE_DATA(1, GLbyte, v[1]);
	WRITE_DATA(2, GLbyte, v[2]);
	WRITE_OPCODE(pc, CR_COLOR3B_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3bvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLbyte * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3bv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 4, GL_TRUE);
	pc->current.c.color.b3 = data_ptr;
	WRITE_DATA(0, GLbyte, v[0]);
	WRITE_DATA(1, GLbyte, v[1]);
	WRITE_DATA(2, GLbyte, v[2]);
	WRITE_OPCODE(pc, CR_COLOR3B_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor3d(CR_PACKER_CONTEXT_ARGDECL GLdouble red, GLdouble green, GLdouble blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 24, GL_TRUE);
	pc->current.c.color.d3 = data_ptr;
	WRITE_DOUBLE(0, red);
	WRITE_DOUBLE(8, green);
	WRITE_DOUBLE(16, blue);
	WRITE_OPCODE(pc, CR_COLOR3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3dSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble red, GLdouble green, GLdouble blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 24, GL_TRUE);
	pc->current.c.color.d3 = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, red);
	WRITE_SWAPPED_DOUBLE(8, green);
	WRITE_SWAPPED_DOUBLE(16, blue);
	WRITE_OPCODE(pc, CR_COLOR3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor3dv(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 24, GL_TRUE);
	pc->current.c.color.d3 = data_ptr;
	WRITE_DOUBLE(0, v[0]);
	WRITE_DOUBLE(8, v[1]);
	WRITE_DOUBLE(16, v[2]);
	WRITE_OPCODE(pc, CR_COLOR3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3dvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 24, GL_TRUE);
	pc->current.c.color.d3 = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, v[0]);
	WRITE_SWAPPED_DOUBLE(8, v[1]);
	WRITE_SWAPPED_DOUBLE(16, v[2]);
	WRITE_OPCODE(pc, CR_COLOR3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor3f(CR_PACKER_CONTEXT_ARGDECL GLfloat red, GLfloat green, GLfloat blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 12, GL_TRUE);
	pc->current.c.color.f3 = data_ptr;
	WRITE_DATA(0, GLfloat, red);
	WRITE_DATA(4, GLfloat, green);
	WRITE_DATA(8, GLfloat, blue);
	WRITE_OPCODE(pc, CR_COLOR3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3fSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat red, GLfloat green, GLfloat blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 12, GL_TRUE);
	pc->current.c.color.f3 = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(red));
	WRITE_DATA(4, GLuint, SWAPFLOAT(green));
	WRITE_DATA(8, GLuint, SWAPFLOAT(blue));
	WRITE_OPCODE(pc, CR_COLOR3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor3fv(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 12, GL_TRUE);
	pc->current.c.color.f3 = data_ptr;
	WRITE_DATA(0, GLfloat, v[0]);
	WRITE_DATA(4, GLfloat, v[1]);
	WRITE_DATA(8, GLfloat, v[2]);
	WRITE_OPCODE(pc, CR_COLOR3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3fvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 12, GL_TRUE);
	pc->current.c.color.f3 = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(v[0]));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v[1]));
	WRITE_DATA(8, GLuint, SWAPFLOAT(v[2]));
	WRITE_OPCODE(pc, CR_COLOR3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor3i(CR_PACKER_CONTEXT_ARGDECL GLint red, GLint green, GLint blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 12, GL_TRUE);
	pc->current.c.color.i3 = data_ptr;
	WRITE_DATA(0, GLint, red);
	WRITE_DATA(4, GLint, green);
	WRITE_DATA(8, GLint, blue);
	WRITE_OPCODE(pc, CR_COLOR3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3iSWAP(CR_PACKER_CONTEXT_ARGDECL GLint red, GLint green, GLint blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 12, GL_TRUE);
	pc->current.c.color.i3 = data_ptr;
	WRITE_DATA(0, GLint, SWAP32(red));
	WRITE_DATA(4, GLint, SWAP32(green));
	WRITE_DATA(8, GLint, SWAP32(blue));
	WRITE_OPCODE(pc, CR_COLOR3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor3iv(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 12, GL_TRUE);
	pc->current.c.color.i3 = data_ptr;
	WRITE_DATA(0, GLint, v[0]);
	WRITE_DATA(4, GLint, v[1]);
	WRITE_DATA(8, GLint, v[2]);
	WRITE_OPCODE(pc, CR_COLOR3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3ivSWAP(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 12, GL_TRUE);
	pc->current.c.color.i3 = data_ptr;
	WRITE_DATA(0, GLint, SWAP32(v[0]));
	WRITE_DATA(4, GLint, SWAP32(v[1]));
	WRITE_DATA(8, GLint, SWAP32(v[2]));
	WRITE_OPCODE(pc, CR_COLOR3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor3s(CR_PACKER_CONTEXT_ARGDECL GLshort red, GLshort green, GLshort blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 8, GL_TRUE);
	pc->current.c.color.s3 = data_ptr;
	WRITE_DATA(0, GLshort, red);
	WRITE_DATA(2, GLshort, green);
	WRITE_DATA(4, GLshort, blue);
	WRITE_OPCODE(pc, CR_COLOR3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3sSWAP(CR_PACKER_CONTEXT_ARGDECL GLshort red, GLshort green, GLshort blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 8, GL_TRUE);
	pc->current.c.color.s3 = data_ptr;
	WRITE_DATA(0, GLshort, SWAP16(red));
	WRITE_DATA(2, GLshort, SWAP16(green));
	WRITE_DATA(4, GLshort, SWAP16(blue));
	WRITE_OPCODE(pc, CR_COLOR3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor3sv(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 8, GL_TRUE);
	pc->current.c.color.s3 = data_ptr;
	WRITE_DATA(0, GLshort, v[0]);
	WRITE_DATA(2, GLshort, v[1]);
	WRITE_DATA(4, GLshort, v[2]);
	WRITE_OPCODE(pc, CR_COLOR3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3svSWAP(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 8, GL_TRUE);
	pc->current.c.color.s3 = data_ptr;
	WRITE_DATA(0, GLshort, SWAP16(v[0]));
	WRITE_DATA(2, GLshort, SWAP16(v[1]));
	WRITE_DATA(4, GLshort, SWAP16(v[2]));
	WRITE_OPCODE(pc, CR_COLOR3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor3ub(CR_PACKER_CONTEXT_ARGDECL GLubyte red, GLubyte green, GLubyte blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 4, GL_TRUE);
	pc->current.c.color.ub3 = data_ptr;
	WRITE_DATA(0, GLubyte, red);
	WRITE_DATA(1, GLubyte, green);
	WRITE_DATA(2, GLubyte, blue);
	WRITE_OPCODE(pc, CR_COLOR3UB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3ubSWAP(CR_PACKER_CONTEXT_ARGDECL GLubyte red, GLubyte green, GLubyte blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 4, GL_TRUE);
	pc->current.c.color.ub3 = data_ptr;
	WRITE_DATA(0, GLubyte, red);
	WRITE_DATA(1, GLubyte, green);
	WRITE_DATA(2, GLubyte, blue);
	WRITE_OPCODE(pc, CR_COLOR3UB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor3ubv(CR_PACKER_CONTEXT_ARGDECL const GLubyte * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3ubv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 4, GL_TRUE);
	pc->current.c.color.ub3 = data_ptr;
	WRITE_DATA(0, GLubyte, v[0]);
	WRITE_DATA(1, GLubyte, v[1]);
	WRITE_DATA(2, GLubyte, v[2]);
	WRITE_OPCODE(pc, CR_COLOR3UB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3ubvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLubyte * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3ubv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 4, GL_TRUE);
	pc->current.c.color.ub3 = data_ptr;
	WRITE_DATA(0, GLubyte, v[0]);
	WRITE_DATA(1, GLubyte, v[1]);
	WRITE_DATA(2, GLubyte, v[2]);
	WRITE_OPCODE(pc, CR_COLOR3UB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor3ui(CR_PACKER_CONTEXT_ARGDECL GLuint red, GLuint green, GLuint blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 12, GL_TRUE);
	pc->current.c.color.ui3 = data_ptr;
	WRITE_DATA(0, GLuint, red);
	WRITE_DATA(4, GLuint, green);
	WRITE_DATA(8, GLuint, blue);
	WRITE_OPCODE(pc, CR_COLOR3UI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3uiSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint red, GLuint green, GLuint blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 12, GL_TRUE);
	pc->current.c.color.ui3 = data_ptr;
	WRITE_DATA(0, GLuint, SWAP32(red));
	WRITE_DATA(4, GLuint, SWAP32(green));
	WRITE_DATA(8, GLuint, SWAP32(blue));
	WRITE_OPCODE(pc, CR_COLOR3UI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor3uiv(CR_PACKER_CONTEXT_ARGDECL const GLuint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3uiv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 12, GL_TRUE);
	pc->current.c.color.ui3 = data_ptr;
	WRITE_DATA(0, GLuint, v[0]);
	WRITE_DATA(4, GLuint, v[1]);
	WRITE_DATA(8, GLuint, v[2]);
	WRITE_OPCODE(pc, CR_COLOR3UI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3uivSWAP(CR_PACKER_CONTEXT_ARGDECL const GLuint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3uiv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 12, GL_TRUE);
	pc->current.c.color.ui3 = data_ptr;
	WRITE_DATA(0, GLuint, SWAP32(v[0]));
	WRITE_DATA(4, GLuint, SWAP32(v[1]));
	WRITE_DATA(8, GLuint, SWAP32(v[2]));
	WRITE_OPCODE(pc, CR_COLOR3UI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor3us(CR_PACKER_CONTEXT_ARGDECL GLushort red, GLushort green, GLushort blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 8, GL_TRUE);
	pc->current.c.color.us3 = data_ptr;
	WRITE_DATA(0, GLushort, red);
	WRITE_DATA(2, GLushort, green);
	WRITE_DATA(4, GLushort, blue);
	WRITE_OPCODE(pc, CR_COLOR3US_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3usSWAP(CR_PACKER_CONTEXT_ARGDECL GLushort red, GLushort green, GLushort blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 8, GL_TRUE);
	pc->current.c.color.us3 = data_ptr;
	WRITE_DATA(0, GLushort, SWAP16(red));
	WRITE_DATA(2, GLushort, SWAP16(green));
	WRITE_DATA(4, GLushort, SWAP16(blue));
	WRITE_OPCODE(pc, CR_COLOR3US_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor3usv(CR_PACKER_CONTEXT_ARGDECL const GLushort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3usv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 8, GL_TRUE);
	pc->current.c.color.us3 = data_ptr;
	WRITE_DATA(0, GLushort, v[0]);
	WRITE_DATA(2, GLushort, v[1]);
	WRITE_DATA(4, GLushort, v[2]);
	WRITE_OPCODE(pc, CR_COLOR3US_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3usvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLushort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3usv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 8, GL_TRUE);
	pc->current.c.color.us3 = data_ptr;
	WRITE_DATA(0, GLushort, SWAP16(v[0]));
	WRITE_DATA(2, GLushort, SWAP16(v[1]));
	WRITE_DATA(4, GLushort, SWAP16(v[2]));
	WRITE_OPCODE(pc, CR_COLOR3US_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor4b(CR_PACKER_CONTEXT_ARGDECL GLbyte red, GLbyte green, GLbyte blue, GLbyte alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 4, GL_TRUE);
	pc->current.c.color.b4 = data_ptr;
	WRITE_DATA(0, GLbyte, red);
	WRITE_DATA(1, GLbyte, green);
	WRITE_DATA(2, GLbyte, blue);
	WRITE_DATA(3, GLbyte, alpha);
	WRITE_OPCODE(pc, CR_COLOR4B_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4bSWAP(CR_PACKER_CONTEXT_ARGDECL GLbyte red, GLbyte green, GLbyte blue, GLbyte alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 4, GL_TRUE);
	pc->current.c.color.b4 = data_ptr;
	WRITE_DATA(0, GLbyte, red);
	WRITE_DATA(1, GLbyte, green);
	WRITE_DATA(2, GLbyte, blue);
	WRITE_DATA(3, GLbyte, alpha);
	WRITE_OPCODE(pc, CR_COLOR4B_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor4bv(CR_PACKER_CONTEXT_ARGDECL const GLbyte * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4bv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 4, GL_TRUE);
	pc->current.c.color.b4 = data_ptr;
	WRITE_DATA(0, GLbyte, v[0]);
	WRITE_DATA(1, GLbyte, v[1]);
	WRITE_DATA(2, GLbyte, v[2]);
	WRITE_DATA(3, GLbyte, v[3]);
	WRITE_OPCODE(pc, CR_COLOR4B_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4bvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLbyte * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4bv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 4, GL_TRUE);
	pc->current.c.color.b4 = data_ptr;
	WRITE_DATA(0, GLbyte, v[0]);
	WRITE_DATA(1, GLbyte, v[1]);
	WRITE_DATA(2, GLbyte, v[2]);
	WRITE_DATA(3, GLbyte, v[3]);
	WRITE_OPCODE(pc, CR_COLOR4B_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor4d(CR_PACKER_CONTEXT_ARGDECL GLdouble red, GLdouble green, GLdouble blue, GLdouble alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 32, GL_TRUE);
	pc->current.c.color.d4 = data_ptr;
	WRITE_DOUBLE(0, red);
	WRITE_DOUBLE(8, green);
	WRITE_DOUBLE(16, blue);
	WRITE_DOUBLE(24, alpha);
	WRITE_OPCODE(pc, CR_COLOR4D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4dSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble red, GLdouble green, GLdouble blue, GLdouble alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 32, GL_TRUE);
	pc->current.c.color.d4 = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, red);
	WRITE_SWAPPED_DOUBLE(8, green);
	WRITE_SWAPPED_DOUBLE(16, blue);
	WRITE_SWAPPED_DOUBLE(24, alpha);
	WRITE_OPCODE(pc, CR_COLOR4D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor4dv(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4dv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 32, GL_TRUE);
	pc->current.c.color.d4 = data_ptr;
	WRITE_DOUBLE(0, v[0]);
	WRITE_DOUBLE(8, v[1]);
	WRITE_DOUBLE(16, v[2]);
	WRITE_DOUBLE(24, v[3]);
	WRITE_OPCODE(pc, CR_COLOR4D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4dvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4dv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 32, GL_TRUE);
	pc->current.c.color.d4 = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, v[0]);
	WRITE_SWAPPED_DOUBLE(8, v[1]);
	WRITE_SWAPPED_DOUBLE(16, v[2]);
	WRITE_SWAPPED_DOUBLE(24, v[3]);
	WRITE_OPCODE(pc, CR_COLOR4D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor4f(CR_PACKER_CONTEXT_ARGDECL GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 16, GL_TRUE);
	pc->current.c.color.f4 = data_ptr;
	WRITE_DATA(0, GLfloat, red);
	WRITE_DATA(4, GLfloat, green);
	WRITE_DATA(8, GLfloat, blue);
	WRITE_DATA(12, GLfloat, alpha);
	WRITE_OPCODE(pc, CR_COLOR4F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4fSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 16, GL_TRUE);
	pc->current.c.color.f4 = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(red));
	WRITE_DATA(4, GLuint, SWAPFLOAT(green));
	WRITE_DATA(8, GLuint, SWAPFLOAT(blue));
	WRITE_DATA(12, GLuint, SWAPFLOAT(alpha));
	WRITE_OPCODE(pc, CR_COLOR4F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor4fv(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4fv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 16, GL_TRUE);
	pc->current.c.color.f4 = data_ptr;
	WRITE_DATA(0, GLfloat, v[0]);
	WRITE_DATA(4, GLfloat, v[1]);
	WRITE_DATA(8, GLfloat, v[2]);
	WRITE_DATA(12, GLfloat, v[3]);
	WRITE_OPCODE(pc, CR_COLOR4F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4fvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4fv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 16, GL_TRUE);
	pc->current.c.color.f4 = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(v[0]));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v[1]));
	WRITE_DATA(8, GLuint, SWAPFLOAT(v[2]));
	WRITE_DATA(12, GLuint, SWAPFLOAT(v[3]));
	WRITE_OPCODE(pc, CR_COLOR4F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor4i(CR_PACKER_CONTEXT_ARGDECL GLint red, GLint green, GLint blue, GLint alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 16, GL_TRUE);
	pc->current.c.color.i4 = data_ptr;
	WRITE_DATA(0, GLint, red);
	WRITE_DATA(4, GLint, green);
	WRITE_DATA(8, GLint, blue);
	WRITE_DATA(12, GLint, alpha);
	WRITE_OPCODE(pc, CR_COLOR4I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4iSWAP(CR_PACKER_CONTEXT_ARGDECL GLint red, GLint green, GLint blue, GLint alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 16, GL_TRUE);
	pc->current.c.color.i4 = data_ptr;
	WRITE_DATA(0, GLint, SWAP32(red));
	WRITE_DATA(4, GLint, SWAP32(green));
	WRITE_DATA(8, GLint, SWAP32(blue));
	WRITE_DATA(12, GLint, SWAP32(alpha));
	WRITE_OPCODE(pc, CR_COLOR4I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor4iv(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4iv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 16, GL_TRUE);
	pc->current.c.color.i4 = data_ptr;
	WRITE_DATA(0, GLint, v[0]);
	WRITE_DATA(4, GLint, v[1]);
	WRITE_DATA(8, GLint, v[2]);
	WRITE_DATA(12, GLint, v[3]);
	WRITE_OPCODE(pc, CR_COLOR4I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4ivSWAP(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4iv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 16, GL_TRUE);
	pc->current.c.color.i4 = data_ptr;
	WRITE_DATA(0, GLint, SWAP32(v[0]));
	WRITE_DATA(4, GLint, SWAP32(v[1]));
	WRITE_DATA(8, GLint, SWAP32(v[2]));
	WRITE_DATA(12, GLint, SWAP32(v[3]));
	WRITE_OPCODE(pc, CR_COLOR4I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor4s(CR_PACKER_CONTEXT_ARGDECL GLshort red, GLshort green, GLshort blue, GLshort alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 8, GL_TRUE);
	pc->current.c.color.s4 = data_ptr;
	WRITE_DATA(0, GLshort, red);
	WRITE_DATA(2, GLshort, green);
	WRITE_DATA(4, GLshort, blue);
	WRITE_DATA(6, GLshort, alpha);
	WRITE_OPCODE(pc, CR_COLOR4S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4sSWAP(CR_PACKER_CONTEXT_ARGDECL GLshort red, GLshort green, GLshort blue, GLshort alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 8, GL_TRUE);
	pc->current.c.color.s4 = data_ptr;
	WRITE_DATA(0, GLshort, SWAP16(red));
	WRITE_DATA(2, GLshort, SWAP16(green));
	WRITE_DATA(4, GLshort, SWAP16(blue));
	WRITE_DATA(6, GLshort, SWAP16(alpha));
	WRITE_OPCODE(pc, CR_COLOR4S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor4sv(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4sv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 8, GL_TRUE);
	pc->current.c.color.s4 = data_ptr;
	WRITE_DATA(0, GLshort, v[0]);
	WRITE_DATA(2, GLshort, v[1]);
	WRITE_DATA(4, GLshort, v[2]);
	WRITE_DATA(6, GLshort, v[3]);
	WRITE_OPCODE(pc, CR_COLOR4S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4svSWAP(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4sv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 8, GL_TRUE);
	pc->current.c.color.s4 = data_ptr;
	WRITE_DATA(0, GLshort, SWAP16(v[0]));
	WRITE_DATA(2, GLshort, SWAP16(v[1]));
	WRITE_DATA(4, GLshort, SWAP16(v[2]));
	WRITE_DATA(6, GLshort, SWAP16(v[3]));
	WRITE_OPCODE(pc, CR_COLOR4S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor4ub(CR_PACKER_CONTEXT_ARGDECL GLubyte red, GLubyte green, GLubyte blue, GLubyte alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 4, GL_TRUE);
	pc->current.c.color.ub4 = data_ptr;
	WRITE_DATA(0, GLubyte, red);
	WRITE_DATA(1, GLubyte, green);
	WRITE_DATA(2, GLubyte, blue);
	WRITE_DATA(3, GLubyte, alpha);
	WRITE_OPCODE(pc, CR_COLOR4UB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4ubSWAP(CR_PACKER_CONTEXT_ARGDECL GLubyte red, GLubyte green, GLubyte blue, GLubyte alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 4, GL_TRUE);
	pc->current.c.color.ub4 = data_ptr;
	WRITE_DATA(0, GLubyte, red);
	WRITE_DATA(1, GLubyte, green);
	WRITE_DATA(2, GLubyte, blue);
	WRITE_DATA(3, GLubyte, alpha);
	WRITE_OPCODE(pc, CR_COLOR4UB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor4ubv(CR_PACKER_CONTEXT_ARGDECL const GLubyte * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4ubv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 4, GL_TRUE);
	pc->current.c.color.ub4 = data_ptr;
	WRITE_DATA(0, GLubyte, v[0]);
	WRITE_DATA(1, GLubyte, v[1]);
	WRITE_DATA(2, GLubyte, v[2]);
	WRITE_DATA(3, GLubyte, v[3]);
	WRITE_OPCODE(pc, CR_COLOR4UB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4ubvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLubyte * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4ubv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 4, GL_TRUE);
	pc->current.c.color.ub4 = data_ptr;
	WRITE_DATA(0, GLubyte, v[0]);
	WRITE_DATA(1, GLubyte, v[1]);
	WRITE_DATA(2, GLubyte, v[2]);
	WRITE_DATA(3, GLubyte, v[3]);
	WRITE_OPCODE(pc, CR_COLOR4UB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor4ui(CR_PACKER_CONTEXT_ARGDECL GLuint red, GLuint green, GLuint blue, GLuint alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 16, GL_TRUE);
	pc->current.c.color.ui4 = data_ptr;
	WRITE_DATA(0, GLuint, red);
	WRITE_DATA(4, GLuint, green);
	WRITE_DATA(8, GLuint, blue);
	WRITE_DATA(12, GLuint, alpha);
	WRITE_OPCODE(pc, CR_COLOR4UI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4uiSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint red, GLuint green, GLuint blue, GLuint alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 16, GL_TRUE);
	pc->current.c.color.ui4 = data_ptr;
	WRITE_DATA(0, GLuint, SWAP32(red));
	WRITE_DATA(4, GLuint, SWAP32(green));
	WRITE_DATA(8, GLuint, SWAP32(blue));
	WRITE_DATA(12, GLuint, SWAP32(alpha));
	WRITE_OPCODE(pc, CR_COLOR4UI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor4uiv(CR_PACKER_CONTEXT_ARGDECL const GLuint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4uiv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 16, GL_TRUE);
	pc->current.c.color.ui4 = data_ptr;
	WRITE_DATA(0, GLuint, v[0]);
	WRITE_DATA(4, GLuint, v[1]);
	WRITE_DATA(8, GLuint, v[2]);
	WRITE_DATA(12, GLuint, v[3]);
	WRITE_OPCODE(pc, CR_COLOR4UI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4uivSWAP(CR_PACKER_CONTEXT_ARGDECL const GLuint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4uiv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 16, GL_TRUE);
	pc->current.c.color.ui4 = data_ptr;
	WRITE_DATA(0, GLuint, SWAP32(v[0]));
	WRITE_DATA(4, GLuint, SWAP32(v[1]));
	WRITE_DATA(8, GLuint, SWAP32(v[2]));
	WRITE_DATA(12, GLuint, SWAP32(v[3]));
	WRITE_OPCODE(pc, CR_COLOR4UI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor4us(CR_PACKER_CONTEXT_ARGDECL GLushort red, GLushort green, GLushort blue, GLushort alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 8, GL_TRUE);
	pc->current.c.color.us4 = data_ptr;
	WRITE_DATA(0, GLushort, red);
	WRITE_DATA(2, GLushort, green);
	WRITE_DATA(4, GLushort, blue);
	WRITE_DATA(6, GLushort, alpha);
	WRITE_OPCODE(pc, CR_COLOR4US_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4usSWAP(CR_PACKER_CONTEXT_ARGDECL GLushort red, GLushort green, GLushort blue, GLushort alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 8, GL_TRUE);
	pc->current.c.color.us4 = data_ptr;
	WRITE_DATA(0, GLushort, SWAP16(red));
	WRITE_DATA(2, GLushort, SWAP16(green));
	WRITE_DATA(4, GLushort, SWAP16(blue));
	WRITE_DATA(6, GLushort, SWAP16(alpha));
	WRITE_OPCODE(pc, CR_COLOR4US_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColor4usv(CR_PACKER_CONTEXT_ARGDECL const GLushort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4usv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 8, GL_TRUE);
	pc->current.c.color.us4 = data_ptr;
	WRITE_DATA(0, GLushort, v[0]);
	WRITE_DATA(2, GLushort, v[1]);
	WRITE_DATA(4, GLushort, v[2]);
	WRITE_DATA(6, GLushort, v[3]);
	WRITE_OPCODE(pc, CR_COLOR4US_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4usvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLushort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4usv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 8, GL_TRUE);
	pc->current.c.color.us4 = data_ptr;
	WRITE_DATA(0, GLushort, SWAP16(v[0]));
	WRITE_DATA(2, GLushort, SWAP16(v[1]));
	WRITE_DATA(4, GLushort, SWAP16(v[2]));
	WRITE_DATA(6, GLushort, SWAP16(v[3]));
	WRITE_OPCODE(pc, CR_COLOR4US_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColorMask(CR_PACKER_CONTEXT_ARGDECL GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 4, GL_TRUE);
	WRITE_DATA(0, GLboolean, red);
	WRITE_DATA(1, GLboolean, green);
	WRITE_DATA(2, GLboolean, blue);
	WRITE_DATA(3, GLboolean, alpha);
	WRITE_OPCODE(pc, CR_COLORMASK_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColorMaskSWAP(CR_PACKER_CONTEXT_ARGDECL GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 4, GL_TRUE);
	WRITE_DATA(0, GLboolean, red);
	WRITE_DATA(1, GLboolean, green);
	WRITE_DATA(2, GLboolean, blue);
	WRITE_DATA(3, GLboolean, alpha);
	WRITE_OPCODE(pc, CR_COLORMASK_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackColorMaterial(CR_PACKER_CONTEXT_ARGDECL GLenum face, GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 8, GL_TRUE);
	WRITE_DATA(0, GLenum, face);
	WRITE_DATA(4, GLenum, mode);
	WRITE_OPCODE(pc, CR_COLORMATERIAL_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColorMaterialSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum face, GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 8, GL_TRUE);
	WRITE_DATA(0, GLenum, SWAP32(face));
	WRITE_DATA(4, GLenum, SWAP32(mode));
	WRITE_OPCODE(pc, CR_COLORMATERIAL_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackCombinerInputNV(CR_PACKER_CONTEXT_ARGDECL GLenum stage, GLenum portion, GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_COMBINERINPUTNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, stage);
	WRITE_DATA(12, GLenum, portion);
	WRITE_DATA(16, GLenum, variable);
	WRITE_DATA(20, GLenum, input);
	WRITE_DATA(24, GLenum, mapping);
	WRITE_DATA(28, GLenum, componentUsage);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCombinerInputNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum stage, GLenum portion, GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_COMBINERINPUTNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(stage));
	WRITE_DATA(12, GLenum, SWAP32(portion));
	WRITE_DATA(16, GLenum, SWAP32(variable));
	WRITE_DATA(20, GLenum, SWAP32(input));
	WRITE_DATA(24, GLenum, SWAP32(mapping));
	WRITE_DATA(28, GLenum, SWAP32(componentUsage));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackCombinerOutputNV(CR_PACKER_CONTEXT_ARGDECL GLenum stage, GLenum portion, GLenum abOutput, GLenum cdOutput, GLenum sumOutput, GLenum scale, GLenum bias, GLboolean abDotProduct, GLboolean cdDotProduct, GLboolean muxSum)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 40);
	WRITE_DATA(0, GLint, 40);
	WRITE_DATA(4, GLenum, CR_COMBINEROUTPUTNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, stage);
	WRITE_DATA(12, GLenum, portion);
	WRITE_DATA(16, GLenum, abOutput);
	WRITE_DATA(20, GLenum, cdOutput);
	WRITE_DATA(24, GLenum, sumOutput);
	WRITE_DATA(28, GLenum, scale);
	WRITE_DATA(32, GLenum, bias);
	WRITE_DATA(36, GLboolean, abDotProduct);
	WRITE_DATA(37, GLboolean, cdDotProduct);
	WRITE_DATA(38, GLboolean, muxSum);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCombinerOutputNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum stage, GLenum portion, GLenum abOutput, GLenum cdOutput, GLenum sumOutput, GLenum scale, GLenum bias, GLboolean abDotProduct, GLboolean cdDotProduct, GLboolean muxSum)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 40);
	WRITE_DATA(0, GLint, SWAP32(40));
	WRITE_DATA(4, GLenum, SWAP32(CR_COMBINEROUTPUTNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(stage));
	WRITE_DATA(12, GLenum, SWAP32(portion));
	WRITE_DATA(16, GLenum, SWAP32(abOutput));
	WRITE_DATA(20, GLenum, SWAP32(cdOutput));
	WRITE_DATA(24, GLenum, SWAP32(sumOutput));
	WRITE_DATA(28, GLenum, SWAP32(scale));
	WRITE_DATA(32, GLenum, SWAP32(bias));
	WRITE_DATA(36, GLboolean, abDotProduct);
	WRITE_DATA(37, GLboolean, cdDotProduct);
	WRITE_DATA(38, GLboolean, muxSum);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackCombinerParameterfNV(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLfloat param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_COMBINERPARAMETERFNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, pname);
	WRITE_DATA(12, GLfloat, param);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCombinerParameterfNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLfloat param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_COMBINERPARAMETERFNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(pname));
	WRITE_DATA(12, GLuint, SWAPFLOAT(param));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackCombinerParameteriNV(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLint param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_COMBINERPARAMETERINV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, pname);
	WRITE_DATA(12, GLint, param);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCombinerParameteriNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLint param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_COMBINERPARAMETERINV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(pname));
	WRITE_DATA(12, GLint, SWAP32(param));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackCompileShader(CR_PACKER_CONTEXT_ARGDECL GLuint shader)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_COMPILESHADER_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, shader);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCompileShaderSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint shader)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_COMPILESHADER_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(shader));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackCopyPixels(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y, GLsizei width, GLsizei height, GLenum type)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLint, x);
	WRITE_DATA(4, GLint, y);
	WRITE_DATA(8, GLsizei, width);
	WRITE_DATA(12, GLsizei, height);
	WRITE_DATA(16, GLenum, type);
	WRITE_OPCODE(pc, CR_COPYPIXELS_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCopyPixelsSWAP(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y, GLsizei width, GLsizei height, GLenum type)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLint, SWAP32(x));
	WRITE_DATA(4, GLint, SWAP32(y));
	WRITE_DATA(8, GLsizei, SWAP32(width));
	WRITE_DATA(12, GLsizei, SWAP32(height));
	WRITE_DATA(16, GLenum, SWAP32(type));
	WRITE_OPCODE(pc, CR_COPYPIXELS_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackCopyTexImage1D(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLint level, GLenum internalFormat, GLint x, GLint y, GLsizei width, GLint border)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLenum, target);
	WRITE_DATA(4, GLint, level);
	WRITE_DATA(8, GLenum, internalFormat);
	WRITE_DATA(12, GLint, x);
	WRITE_DATA(16, GLint, y);
	WRITE_DATA(20, GLsizei, width);
	WRITE_DATA(24, GLint, border);
	WRITE_OPCODE(pc, CR_COPYTEXIMAGE1D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCopyTexImage1DSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLint level, GLenum internalFormat, GLint x, GLint y, GLsizei width, GLint border)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLenum, SWAP32(target));
	WRITE_DATA(4, GLint, SWAP32(level));
	WRITE_DATA(8, GLenum, SWAP32(internalFormat));
	WRITE_DATA(12, GLint, SWAP32(x));
	WRITE_DATA(16, GLint, SWAP32(y));
	WRITE_DATA(20, GLsizei, SWAP32(width));
	WRITE_DATA(24, GLint, SWAP32(border));
	WRITE_OPCODE(pc, CR_COPYTEXIMAGE1D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackCopyTexImage2D(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLint level, GLenum internalFormat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLenum, target);
	WRITE_DATA(4, GLint, level);
	WRITE_DATA(8, GLenum, internalFormat);
	WRITE_DATA(12, GLint, x);
	WRITE_DATA(16, GLint, y);
	WRITE_DATA(20, GLsizei, width);
	WRITE_DATA(24, GLsizei, height);
	WRITE_DATA(28, GLint, border);
	WRITE_OPCODE(pc, CR_COPYTEXIMAGE2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCopyTexImage2DSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLint level, GLenum internalFormat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLenum, SWAP32(target));
	WRITE_DATA(4, GLint, SWAP32(level));
	WRITE_DATA(8, GLenum, SWAP32(internalFormat));
	WRITE_DATA(12, GLint, SWAP32(x));
	WRITE_DATA(16, GLint, SWAP32(y));
	WRITE_DATA(20, GLsizei, SWAP32(width));
	WRITE_DATA(24, GLsizei, SWAP32(height));
	WRITE_DATA(28, GLint, SWAP32(border));
	WRITE_OPCODE(pc, CR_COPYTEXIMAGE2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackCopyTexSubImage1D(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLenum, target);
	WRITE_DATA(4, GLint, level);
	WRITE_DATA(8, GLint, xoffset);
	WRITE_DATA(12, GLint, x);
	WRITE_DATA(16, GLint, y);
	WRITE_DATA(20, GLsizei, width);
	WRITE_OPCODE(pc, CR_COPYTEXSUBIMAGE1D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCopyTexSubImage1DSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLenum, SWAP32(target));
	WRITE_DATA(4, GLint, SWAP32(level));
	WRITE_DATA(8, GLint, SWAP32(xoffset));
	WRITE_DATA(12, GLint, SWAP32(x));
	WRITE_DATA(16, GLint, SWAP32(y));
	WRITE_DATA(20, GLsizei, SWAP32(width));
	WRITE_OPCODE(pc, CR_COPYTEXSUBIMAGE1D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackCopyTexSubImage2D(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLenum, target);
	WRITE_DATA(4, GLint, level);
	WRITE_DATA(8, GLint, xoffset);
	WRITE_DATA(12, GLint, yoffset);
	WRITE_DATA(16, GLint, x);
	WRITE_DATA(20, GLint, y);
	WRITE_DATA(24, GLsizei, width);
	WRITE_DATA(28, GLsizei, height);
	WRITE_OPCODE(pc, CR_COPYTEXSUBIMAGE2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCopyTexSubImage2DSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLenum, SWAP32(target));
	WRITE_DATA(4, GLint, SWAP32(level));
	WRITE_DATA(8, GLint, SWAP32(xoffset));
	WRITE_DATA(12, GLint, SWAP32(yoffset));
	WRITE_DATA(16, GLint, SWAP32(x));
	WRITE_DATA(20, GLint, SWAP32(y));
	WRITE_DATA(24, GLsizei, SWAP32(width));
	WRITE_DATA(28, GLsizei, SWAP32(height));
	WRITE_OPCODE(pc, CR_COPYTEXSUBIMAGE2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackCopyTexSubImage3D(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	WRITE_DATA(0, GLenum, target);
	WRITE_DATA(4, GLint, level);
	WRITE_DATA(8, GLint, xoffset);
	WRITE_DATA(12, GLint, yoffset);
	WRITE_DATA(16, GLint, zoffset);
	WRITE_DATA(20, GLint, x);
	WRITE_DATA(24, GLint, y);
	WRITE_DATA(28, GLsizei, width);
	WRITE_DATA(32, GLsizei, height);
	WRITE_OPCODE(pc, CR_COPYTEXSUBIMAGE3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCopyTexSubImage3DSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	WRITE_DATA(0, GLenum, SWAP32(target));
	WRITE_DATA(4, GLint, SWAP32(level));
	WRITE_DATA(8, GLint, SWAP32(xoffset));
	WRITE_DATA(12, GLint, SWAP32(yoffset));
	WRITE_DATA(16, GLint, SWAP32(zoffset));
	WRITE_DATA(20, GLint, SWAP32(x));
	WRITE_DATA(24, GLint, SWAP32(y));
	WRITE_DATA(28, GLsizei, SWAP32(width));
	WRITE_DATA(32, GLsizei, SWAP32(height));
	WRITE_OPCODE(pc, CR_COPYTEXSUBIMAGE3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackCreateProgram(CR_PACKER_CONTEXT_ARGDECL GLuint * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, 24);
	WRITE_DATA(4, GLenum, CR_CREATEPROGRAM_EXTEND_OPCODE);
	WRITE_NETWORK_POINTER(8, (void *) return_value);
	WRITE_NETWORK_POINTER(16, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCreateProgramSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, SWAP32(24));
	WRITE_DATA(4, GLenum, SWAP32(CR_CREATEPROGRAM_EXTEND_OPCODE));
	WRITE_NETWORK_POINTER(8, (void *) return_value);
	WRITE_NETWORK_POINTER(16, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackCreateShader(CR_PACKER_CONTEXT_ARGDECL GLenum type, GLuint * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_CREATESHADER_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, type);
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCreateShaderSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum type, GLuint * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_CREATESHADER_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(type));
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackCullFace(CR_PACKER_CONTEXT_ARGDECL GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLenum, mode);
	WRITE_OPCODE(pc, CR_CULLFACE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCullFaceSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLenum, SWAP32(mode));
	WRITE_OPCODE(pc, CR_CULLFACE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackDeleteLists(CR_PACKER_CONTEXT_ARGDECL GLuint list, GLsizei range)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_DELETELISTS_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, list);
	WRITE_DATA(12, GLsizei, range);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDeleteListsSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint list, GLsizei range)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_DELETELISTS_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(list));
	WRITE_DATA(12, GLsizei, SWAP32(range));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackDeleteObjectARB(CR_PACKER_CONTEXT_ARGDECL VBoxGLhandleARB obj)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_DELETEOBJECTARB_EXTEND_OPCODE);
	WRITE_DATA(8, VBoxGLhandleARB, obj);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDeleteObjectARBSWAP(CR_PACKER_CONTEXT_ARGDECL VBoxGLhandleARB obj)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_DELETEOBJECTARB_EXTEND_OPCODE));
	WRITE_DATA(8, VBoxGLhandleARB, SWAP32(obj));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackDeleteProgram(CR_PACKER_CONTEXT_ARGDECL GLuint program)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_DELETEPROGRAM_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, program);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDeleteProgramSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint program)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_DELETEPROGRAM_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(program));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackDeleteShader(CR_PACKER_CONTEXT_ARGDECL GLuint shader)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_DELETESHADER_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, shader);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDeleteShaderSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint shader)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_DELETESHADER_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(shader));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackDepthFunc(CR_PACKER_CONTEXT_ARGDECL GLenum func)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLenum, func);
	WRITE_OPCODE(pc, CR_DEPTHFUNC_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDepthFuncSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum func)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLenum, SWAP32(func));
	WRITE_OPCODE(pc, CR_DEPTHFUNC_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackDepthMask(CR_PACKER_CONTEXT_ARGDECL GLboolean flag)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLboolean, flag);
	WRITE_OPCODE(pc, CR_DEPTHMASK_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDepthMaskSWAP(CR_PACKER_CONTEXT_ARGDECL GLboolean flag)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLboolean, flag);
	WRITE_OPCODE(pc, CR_DEPTHMASK_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackDepthRange(CR_PACKER_CONTEXT_ARGDECL GLclampd zNear, GLclampd zFar)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DOUBLE(0, zNear);
	WRITE_DOUBLE(8, zFar);
	WRITE_OPCODE(pc, CR_DEPTHRANGE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDepthRangeSWAP(CR_PACKER_CONTEXT_ARGDECL GLclampd zNear, GLclampd zFar)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_SWAPPED_DOUBLE(0, zNear);
	WRITE_SWAPPED_DOUBLE(8, zFar);
	WRITE_OPCODE(pc, CR_DEPTHRANGE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackDestroyContext(CR_PACKER_CONTEXT_ARGDECL GLint ctx)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_DESTROYCONTEXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLint, ctx);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDestroyContextSWAP(CR_PACKER_CONTEXT_ARGDECL GLint ctx)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_DESTROYCONTEXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLint, SWAP32(ctx));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackDetachShader(CR_PACKER_CONTEXT_ARGDECL GLuint program, GLuint shader)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_DETACHSHADER_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, program);
	WRITE_DATA(12, GLuint, shader);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDetachShaderSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint program, GLuint shader)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_DETACHSHADER_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(program));
	WRITE_DATA(12, GLuint, SWAP32(shader));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackDisable(CR_PACKER_CONTEXT_ARGDECL GLenum cap)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLenum, cap);
	WRITE_OPCODE(pc, CR_DISABLE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDisableSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum cap)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLenum, SWAP32(cap));
	WRITE_OPCODE(pc, CR_DISABLE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackDisableClientState(CR_PACKER_CONTEXT_ARGDECL GLenum array)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLenum, array);
	WRITE_OPCODE(pc, CR_DISABLECLIENTSTATE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDisableClientStateSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum array)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLenum, SWAP32(array));
	WRITE_OPCODE(pc, CR_DISABLECLIENTSTATE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackDisableVertexAttribArrayARB(CR_PACKER_CONTEXT_ARGDECL GLuint index)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_DISABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, index);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDisableVertexAttribArrayARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_DISABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(index));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackDrawArrays(CR_PACKER_CONTEXT_ARGDECL GLenum mode, GLint first, GLsizei count)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLenum, mode);
	WRITE_DATA(4, GLint, first);
	WRITE_DATA(8, GLsizei, count);
	WRITE_OPCODE(pc, CR_DRAWARRAYS_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDrawArraysSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum mode, GLint first, GLsizei count)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLenum, SWAP32(mode));
	WRITE_DATA(4, GLint, SWAP32(first));
	WRITE_DATA(8, GLsizei, SWAP32(count));
	WRITE_OPCODE(pc, CR_DRAWARRAYS_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackDrawBuffer(CR_PACKER_CONTEXT_ARGDECL GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_DRAWBUFFER_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, mode);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDrawBufferSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_DRAWBUFFER_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(mode));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackEdgeFlag(CR_PACKER_CONTEXT_ARGDECL GLboolean flag)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.edgeFlag.l1 = data_ptr;
	WRITE_DATA(0, GLboolean, flag);
	WRITE_OPCODE(pc, CR_EDGEFLAG_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEdgeFlagSWAP(CR_PACKER_CONTEXT_ARGDECL GLboolean flag)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.edgeFlag.l1 = data_ptr;
	WRITE_DATA(0, GLboolean, flag);
	WRITE_OPCODE(pc, CR_EDGEFLAG_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackEdgeFlagv(CR_PACKER_CONTEXT_ARGDECL const GLboolean * flag)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!flag) {
        crDebug("App passed NULL as flag for EdgeFlagv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.edgeFlag.l1 = data_ptr;
	WRITE_DATA(0, GLboolean, flag[0]);
	WRITE_OPCODE(pc, CR_EDGEFLAG_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEdgeFlagvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLboolean * flag)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!flag) {
        crDebug("App passed NULL as flag for EdgeFlagv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.edgeFlag.l1 = data_ptr;
	WRITE_DATA(0, GLboolean, flag[0]);
	WRITE_OPCODE(pc, CR_EDGEFLAG_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackEnable(CR_PACKER_CONTEXT_ARGDECL GLenum cap)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLenum, cap);
	WRITE_OPCODE(pc, CR_ENABLE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEnableSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum cap)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLenum, SWAP32(cap));
	WRITE_OPCODE(pc, CR_ENABLE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackEnableClientState(CR_PACKER_CONTEXT_ARGDECL GLenum array)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLenum, array);
	WRITE_OPCODE(pc, CR_ENABLECLIENTSTATE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEnableClientStateSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum array)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLenum, SWAP32(array));
	WRITE_OPCODE(pc, CR_ENABLECLIENTSTATE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackEnableVertexAttribArrayARB(CR_PACKER_CONTEXT_ARGDECL GLuint index)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_ENABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, index);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEnableVertexAttribArrayARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_ENABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(index));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackEvalCoord1d(CR_PACKER_CONTEXT_ARGDECL GLdouble u)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DOUBLE(0, u);
	WRITE_OPCODE(pc, CR_EVALCOORD1D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord1dSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble u)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_SWAPPED_DOUBLE(0, u);
	WRITE_OPCODE(pc, CR_EVALCOORD1D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackEvalCoord1dv(CR_PACKER_CONTEXT_ARGDECL const GLdouble * u)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!u) {
        crDebug("App passed NULL as u for EvalCoord1dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DOUBLE(0, u[0]);
	WRITE_OPCODE(pc, CR_EVALCOORD1D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord1dvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * u)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!u) {
        crDebug("App passed NULL as u for EvalCoord1dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_SWAPPED_DOUBLE(0, u[0]);
	WRITE_OPCODE(pc, CR_EVALCOORD1D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackEvalCoord1f(CR_PACKER_CONTEXT_ARGDECL GLfloat u)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLfloat, u);
	WRITE_OPCODE(pc, CR_EVALCOORD1F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord1fSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat u)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLuint, SWAPFLOAT(u));
	WRITE_OPCODE(pc, CR_EVALCOORD1F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackEvalCoord1fv(CR_PACKER_CONTEXT_ARGDECL const GLfloat * u)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!u) {
        crDebug("App passed NULL as u for EvalCoord1fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLfloat, u[0]);
	WRITE_OPCODE(pc, CR_EVALCOORD1F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord1fvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * u)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!u) {
        crDebug("App passed NULL as u for EvalCoord1fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLuint, SWAPFLOAT(u[0]));
	WRITE_OPCODE(pc, CR_EVALCOORD1F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackEvalCoord2d(CR_PACKER_CONTEXT_ARGDECL GLdouble u, GLdouble v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DOUBLE(0, u);
	WRITE_DOUBLE(8, v);
	WRITE_OPCODE(pc, CR_EVALCOORD2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord2dSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble u, GLdouble v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_SWAPPED_DOUBLE(0, u);
	WRITE_SWAPPED_DOUBLE(8, v);
	WRITE_OPCODE(pc, CR_EVALCOORD2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackEvalCoord2dv(CR_PACKER_CONTEXT_ARGDECL const GLdouble * u)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!u) {
        crDebug("App passed NULL as u for EvalCoord2dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DOUBLE(0, u[0]);
	WRITE_DOUBLE(8, u[1]);
	WRITE_OPCODE(pc, CR_EVALCOORD2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord2dvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * u)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!u) {
        crDebug("App passed NULL as u for EvalCoord2dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_SWAPPED_DOUBLE(0, u[0]);
	WRITE_SWAPPED_DOUBLE(8, u[1]);
	WRITE_OPCODE(pc, CR_EVALCOORD2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackEvalCoord2f(CR_PACKER_CONTEXT_ARGDECL GLfloat u, GLfloat v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLfloat, u);
	WRITE_DATA(4, GLfloat, v);
	WRITE_OPCODE(pc, CR_EVALCOORD2F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord2fSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat u, GLfloat v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLuint, SWAPFLOAT(u));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v));
	WRITE_OPCODE(pc, CR_EVALCOORD2F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackEvalCoord2fv(CR_PACKER_CONTEXT_ARGDECL const GLfloat * u)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!u) {
        crDebug("App passed NULL as u for EvalCoord2fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLfloat, u[0]);
	WRITE_DATA(4, GLfloat, u[1]);
	WRITE_OPCODE(pc, CR_EVALCOORD2F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord2fvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * u)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!u) {
        crDebug("App passed NULL as u for EvalCoord2fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLuint, SWAPFLOAT(u[0]));
	WRITE_DATA(4, GLuint, SWAPFLOAT(u[1]));
	WRITE_OPCODE(pc, CR_EVALCOORD2F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackEvalMesh1(CR_PACKER_CONTEXT_ARGDECL GLenum mode, GLint i1, GLint i2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLenum, mode);
	WRITE_DATA(4, GLint, i1);
	WRITE_DATA(8, GLint, i2);
	WRITE_OPCODE(pc, CR_EVALMESH1_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalMesh1SWAP(CR_PACKER_CONTEXT_ARGDECL GLenum mode, GLint i1, GLint i2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLenum, SWAP32(mode));
	WRITE_DATA(4, GLint, SWAP32(i1));
	WRITE_DATA(8, GLint, SWAP32(i2));
	WRITE_OPCODE(pc, CR_EVALMESH1_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackEvalMesh2(CR_PACKER_CONTEXT_ARGDECL GLenum mode, GLint i1, GLint i2, GLint j1, GLint j2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLenum, mode);
	WRITE_DATA(4, GLint, i1);
	WRITE_DATA(8, GLint, i2);
	WRITE_DATA(12, GLint, j1);
	WRITE_DATA(16, GLint, j2);
	WRITE_OPCODE(pc, CR_EVALMESH2_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalMesh2SWAP(CR_PACKER_CONTEXT_ARGDECL GLenum mode, GLint i1, GLint i2, GLint j1, GLint j2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLenum, SWAP32(mode));
	WRITE_DATA(4, GLint, SWAP32(i1));
	WRITE_DATA(8, GLint, SWAP32(i2));
	WRITE_DATA(12, GLint, SWAP32(j1));
	WRITE_DATA(16, GLint, SWAP32(j2));
	WRITE_OPCODE(pc, CR_EVALMESH2_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackEvalPoint1(CR_PACKER_CONTEXT_ARGDECL GLint i)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLint, i);
	WRITE_OPCODE(pc, CR_EVALPOINT1_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalPoint1SWAP(CR_PACKER_CONTEXT_ARGDECL GLint i)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLint, SWAP32(i));
	WRITE_OPCODE(pc, CR_EVALPOINT1_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackEvalPoint2(CR_PACKER_CONTEXT_ARGDECL GLint i, GLint j)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, i);
	WRITE_DATA(4, GLint, j);
	WRITE_OPCODE(pc, CR_EVALPOINT2_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalPoint2SWAP(CR_PACKER_CONTEXT_ARGDECL GLint i, GLint j)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, SWAP32(i));
	WRITE_DATA(4, GLint, SWAP32(j));
	WRITE_OPCODE(pc, CR_EVALPOINT2_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackFinalCombinerInputNV(CR_PACKER_CONTEXT_ARGDECL GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, 24);
	WRITE_DATA(4, GLenum, CR_FINALCOMBINERINPUTNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, variable);
	WRITE_DATA(12, GLenum, input);
	WRITE_DATA(16, GLenum, mapping);
	WRITE_DATA(20, GLenum, componentUsage);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFinalCombinerInputNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, SWAP32(24));
	WRITE_DATA(4, GLenum, SWAP32(CR_FINALCOMBINERINPUTNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(variable));
	WRITE_DATA(12, GLenum, SWAP32(input));
	WRITE_DATA(16, GLenum, SWAP32(mapping));
	WRITE_DATA(20, GLenum, SWAP32(componentUsage));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackFinish(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS(pc);
	WRITE_OPCODE(pc, CR_FINISH_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFinishSWAP(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS(pc);
	WRITE_OPCODE(pc, CR_FINISH_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackFinishFenceNV(CR_PACKER_CONTEXT_ARGDECL GLuint fence)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_FINISHFENCENV_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, fence);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFinishFenceNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint fence)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_FINISHFENCENV_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(fence));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackFlush(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS(pc);
	WRITE_OPCODE(pc, CR_FLUSH_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFlushSWAP(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS(pc);
	WRITE_OPCODE(pc, CR_FLUSH_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackFlushVertexArrayRangeNV(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, 8);
	WRITE_DATA(4, GLenum, CR_FLUSHVERTEXARRAYRANGENV_EXTEND_OPCODE);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFlushVertexArrayRangeNVSWAP(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, SWAP32(8));
	WRITE_DATA(4, GLenum, SWAP32(CR_FLUSHVERTEXARRAYRANGENV_EXTEND_OPCODE));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackFogCoorddEXT(CR_PACKER_CONTEXT_ARGDECL GLdouble coord)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.fogCoord.d1 = data_ptr;
	WRITE_DOUBLE(0, coord);
	WRITE_OPCODE(pc, CR_FOGCOORDDEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogCoorddEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble coord)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.fogCoord.d1 = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, coord);
	WRITE_OPCODE(pc, CR_FOGCOORDDEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackFogCoorddvEXT(CR_PACKER_CONTEXT_ARGDECL const GLdouble * coord)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!coord) {
        crDebug("App passed NULL as coord for FogCoorddvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.fogCoord.d1 = data_ptr;
	WRITE_DOUBLE(0, coord[0]);
	WRITE_OPCODE(pc, CR_FOGCOORDDEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogCoorddvEXTSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * coord)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!coord) {
        crDebug("App passed NULL as coord for FogCoorddvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.fogCoord.d1 = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, coord[0]);
	WRITE_OPCODE(pc, CR_FOGCOORDDEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackFogCoordfEXT(CR_PACKER_CONTEXT_ARGDECL GLfloat coord)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.fogCoord.f1 = data_ptr;
	WRITE_DATA(0, GLfloat, coord);
	WRITE_OPCODE(pc, CR_FOGCOORDFEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogCoordfEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat coord)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.fogCoord.f1 = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(coord));
	WRITE_OPCODE(pc, CR_FOGCOORDFEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackFogCoordfvEXT(CR_PACKER_CONTEXT_ARGDECL const GLfloat * coord)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!coord) {
        crDebug("App passed NULL as coord for FogCoordfvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.fogCoord.f1 = data_ptr;
	WRITE_DATA(0, GLfloat, coord[0]);
	WRITE_OPCODE(pc, CR_FOGCOORDFEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogCoordfvEXTSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * coord)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!coord) {
        crDebug("App passed NULL as coord for FogCoordfvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.fogCoord.f1 = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(coord[0]));
	WRITE_OPCODE(pc, CR_FOGCOORDFEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackFogf(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLfloat param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, pname);
	WRITE_DATA(4, GLfloat, param);
	WRITE_OPCODE(pc, CR_FOGF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogfSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLfloat param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, SWAP32(pname));
	WRITE_DATA(4, GLuint, SWAPFLOAT(param));
	WRITE_OPCODE(pc, CR_FOGF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackFogi(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLint param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, pname);
	WRITE_DATA(4, GLint, param);
	WRITE_OPCODE(pc, CR_FOGI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogiSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLint param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, SWAP32(pname));
	WRITE_DATA(4, GLint, SWAP32(param));
	WRITE_OPCODE(pc, CR_FOGI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackFramebufferRenderbufferEXT(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, 24);
	WRITE_DATA(4, GLenum, CR_FRAMEBUFFERRENDERBUFFEREXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, attachment);
	WRITE_DATA(16, GLenum, renderbuffertarget);
	WRITE_DATA(20, GLuint, renderbuffer);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFramebufferRenderbufferEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, SWAP32(24));
	WRITE_DATA(4, GLenum, SWAP32(CR_FRAMEBUFFERRENDERBUFFEREXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(attachment));
	WRITE_DATA(16, GLenum, SWAP32(renderbuffertarget));
	WRITE_DATA(20, GLuint, SWAP32(renderbuffer));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackFramebufferTexture1DEXT(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_FRAMEBUFFERTEXTURE1DEXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, attachment);
	WRITE_DATA(16, GLenum, textarget);
	WRITE_DATA(20, GLuint, texture);
	WRITE_DATA(24, GLint, level);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFramebufferTexture1DEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_FRAMEBUFFERTEXTURE1DEXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(attachment));
	WRITE_DATA(16, GLenum, SWAP32(textarget));
	WRITE_DATA(20, GLuint, SWAP32(texture));
	WRITE_DATA(24, GLint, SWAP32(level));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackFramebufferTexture2DEXT(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_FRAMEBUFFERTEXTURE2DEXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, attachment);
	WRITE_DATA(16, GLenum, textarget);
	WRITE_DATA(20, GLuint, texture);
	WRITE_DATA(24, GLint, level);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFramebufferTexture2DEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_FRAMEBUFFERTEXTURE2DEXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(attachment));
	WRITE_DATA(16, GLenum, SWAP32(textarget));
	WRITE_DATA(20, GLuint, SWAP32(texture));
	WRITE_DATA(24, GLint, SWAP32(level));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackFramebufferTexture3DEXT(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_FRAMEBUFFERTEXTURE3DEXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, attachment);
	WRITE_DATA(16, GLenum, textarget);
	WRITE_DATA(20, GLuint, texture);
	WRITE_DATA(24, GLint, level);
	WRITE_DATA(28, GLint, zoffset);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFramebufferTexture3DEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_FRAMEBUFFERTEXTURE3DEXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(attachment));
	WRITE_DATA(16, GLenum, SWAP32(textarget));
	WRITE_DATA(20, GLuint, SWAP32(texture));
	WRITE_DATA(24, GLint, SWAP32(level));
	WRITE_DATA(28, GLint, SWAP32(zoffset));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackFrontFace(CR_PACKER_CONTEXT_ARGDECL GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLenum, mode);
	WRITE_OPCODE(pc, CR_FRONTFACE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFrontFaceSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLenum, SWAP32(mode));
	WRITE_OPCODE(pc, CR_FRONTFACE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackFrustum(CR_PACKER_CONTEXT_ARGDECL GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 48);
	WRITE_DOUBLE(0, left);
	WRITE_DOUBLE(8, right);
	WRITE_DOUBLE(16, bottom);
	WRITE_DOUBLE(24, top);
	WRITE_DOUBLE(32, zNear);
	WRITE_DOUBLE(40, zFar);
	WRITE_OPCODE(pc, CR_FRUSTUM_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFrustumSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 48);
	WRITE_SWAPPED_DOUBLE(0, left);
	WRITE_SWAPPED_DOUBLE(8, right);
	WRITE_SWAPPED_DOUBLE(16, bottom);
	WRITE_SWAPPED_DOUBLE(24, top);
	WRITE_SWAPPED_DOUBLE(32, zNear);
	WRITE_SWAPPED_DOUBLE(40, zFar);
	WRITE_OPCODE(pc, CR_FRUSTUM_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGenBuffersARB(CR_PACKER_CONTEXT_ARGDECL GLsizei n, GLuint * buffer, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GENBUFFERSARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLsizei, n);
	WRITE_NETWORK_POINTER(12, (void *) buffer);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenBuffersARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLsizei n, GLuint * buffer, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GENBUFFERSARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLsizei, SWAP32(n));
	WRITE_NETWORK_POINTER(12, (void *) buffer);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGenFencesNV(CR_PACKER_CONTEXT_ARGDECL GLsizei n, GLuint * fences, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GENFENCESNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLsizei, n);
	WRITE_NETWORK_POINTER(12, (void *) fences);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenFencesNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLsizei n, GLuint * fences, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GENFENCESNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLsizei, SWAP32(n));
	WRITE_NETWORK_POINTER(12, (void *) fences);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGenFramebuffersEXT(CR_PACKER_CONTEXT_ARGDECL GLsizei n, GLuint * framebuffers, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GENFRAMEBUFFERSEXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLsizei, n);
	WRITE_NETWORK_POINTER(12, (void *) framebuffers);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenFramebuffersEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLsizei n, GLuint * framebuffers, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GENFRAMEBUFFERSEXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLsizei, SWAP32(n));
	WRITE_NETWORK_POINTER(12, (void *) framebuffers);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGenLists(CR_PACKER_CONTEXT_ARGDECL GLsizei range, GLuint * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GENLISTS_EXTEND_OPCODE);
	WRITE_DATA(8, GLsizei, range);
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenListsSWAP(CR_PACKER_CONTEXT_ARGDECL GLsizei range, GLuint * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GENLISTS_EXTEND_OPCODE));
	WRITE_DATA(8, GLsizei, SWAP32(range));
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGenProgramsARB(CR_PACKER_CONTEXT_ARGDECL GLsizei n, GLuint * programs, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GENPROGRAMSARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLsizei, n);
	WRITE_NETWORK_POINTER(12, (void *) programs);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenProgramsARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLsizei n, GLuint * programs, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GENPROGRAMSARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLsizei, SWAP32(n));
	WRITE_NETWORK_POINTER(12, (void *) programs);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGenProgramsNV(CR_PACKER_CONTEXT_ARGDECL GLsizei n, GLuint * ids, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GENPROGRAMSNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLsizei, n);
	WRITE_NETWORK_POINTER(12, (void *) ids);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenProgramsNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLsizei n, GLuint * ids, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GENPROGRAMSNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLsizei, SWAP32(n));
	WRITE_NETWORK_POINTER(12, (void *) ids);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGenQueriesARB(CR_PACKER_CONTEXT_ARGDECL GLsizei n, GLuint * ids, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GENQUERIESARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLsizei, n);
	WRITE_NETWORK_POINTER(12, (void *) ids);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenQueriesARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLsizei n, GLuint * ids, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GENQUERIESARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLsizei, SWAP32(n));
	WRITE_NETWORK_POINTER(12, (void *) ids);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGenRenderbuffersEXT(CR_PACKER_CONTEXT_ARGDECL GLsizei n, GLuint * renderbuffers, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GENRENDERBUFFERSEXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLsizei, n);
	WRITE_NETWORK_POINTER(12, (void *) renderbuffers);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenRenderbuffersEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLsizei n, GLuint * renderbuffers, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GENRENDERBUFFERSEXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLsizei, SWAP32(n));
	WRITE_NETWORK_POINTER(12, (void *) renderbuffers);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGenTextures(CR_PACKER_CONTEXT_ARGDECL GLsizei n, GLuint * textures, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GENTEXTURES_EXTEND_OPCODE);
	WRITE_DATA(8, GLsizei, n);
	WRITE_NETWORK_POINTER(12, (void *) textures);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenTexturesSWAP(CR_PACKER_CONTEXT_ARGDECL GLsizei n, GLuint * textures, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GENTEXTURES_EXTEND_OPCODE));
	WRITE_DATA(8, GLsizei, SWAP32(n));
	WRITE_NETWORK_POINTER(12, (void *) textures);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGenerateMipmapEXT(CR_PACKER_CONTEXT_ARGDECL GLenum target)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_GENERATEMIPMAPEXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenerateMipmapEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_GENERATEMIPMAPEXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetBooleanv(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLboolean * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GETBOOLEANV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, pname);
	WRITE_NETWORK_POINTER(12, (void *) params);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetBooleanvSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLboolean * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETBOOLEANV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(12, (void *) params);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetBufferParameterivARB(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETBUFFERPARAMETERIVARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetBufferParameterivARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETBUFFERPARAMETERIVARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetChromiumParametervCR(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLenum type, GLsizei count, GLvoid * values, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 40);
	WRITE_DATA(0, GLint, 40);
	WRITE_DATA(4, GLenum, CR_GETCHROMIUMPARAMETERVCR_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_DATA(16, GLenum, type);
	WRITE_DATA(20, GLsizei, count);
	WRITE_NETWORK_POINTER(24, (void *) values);
	WRITE_NETWORK_POINTER(32, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetChromiumParametervCRSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLenum type, GLsizei count, GLvoid * values, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 40);
	WRITE_DATA(0, GLint, SWAP32(40));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETCHROMIUMPARAMETERVCR_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_DATA(16, GLenum, SWAP32(type));
	WRITE_DATA(20, GLsizei, SWAP32(count));
	WRITE_NETWORK_POINTER(24, (void *) values);
	WRITE_NETWORK_POINTER(32, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetClipPlane(CR_PACKER_CONTEXT_ARGDECL GLenum plane, GLdouble * equation, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GETCLIPPLANE_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, plane);
	WRITE_NETWORK_POINTER(12, (void *) equation);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetClipPlaneSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum plane, GLdouble * equation, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETCLIPPLANE_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(plane));
	WRITE_NETWORK_POINTER(12, (void *) equation);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetCombinerInputParameterfvNV(CR_PACKER_CONTEXT_ARGDECL GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 40);
	WRITE_DATA(0, GLint, 40);
	WRITE_DATA(4, GLenum, CR_GETCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, stage);
	WRITE_DATA(12, GLenum, portion);
	WRITE_DATA(16, GLenum, variable);
	WRITE_DATA(20, GLenum, pname);
	WRITE_NETWORK_POINTER(24, (void *) params);
	WRITE_NETWORK_POINTER(32, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetCombinerInputParameterfvNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 40);
	WRITE_DATA(0, GLint, SWAP32(40));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(stage));
	WRITE_DATA(12, GLenum, SWAP32(portion));
	WRITE_DATA(16, GLenum, SWAP32(variable));
	WRITE_DATA(20, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(24, (void *) params);
	WRITE_NETWORK_POINTER(32, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetCombinerInputParameterivNV(CR_PACKER_CONTEXT_ARGDECL GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 40);
	WRITE_DATA(0, GLint, 40);
	WRITE_DATA(4, GLenum, CR_GETCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, stage);
	WRITE_DATA(12, GLenum, portion);
	WRITE_DATA(16, GLenum, variable);
	WRITE_DATA(20, GLenum, pname);
	WRITE_NETWORK_POINTER(24, (void *) params);
	WRITE_NETWORK_POINTER(32, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetCombinerInputParameterivNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 40);
	WRITE_DATA(0, GLint, SWAP32(40));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(stage));
	WRITE_DATA(12, GLenum, SWAP32(portion));
	WRITE_DATA(16, GLenum, SWAP32(variable));
	WRITE_DATA(20, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(24, (void *) params);
	WRITE_NETWORK_POINTER(32, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetCombinerOutputParameterfvNV(CR_PACKER_CONTEXT_ARGDECL GLenum stage, GLenum portion, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	WRITE_DATA(0, GLint, 36);
	WRITE_DATA(4, GLenum, CR_GETCOMBINEROUTPUTPARAMETERFVNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, stage);
	WRITE_DATA(12, GLenum, portion);
	WRITE_DATA(16, GLenum, pname);
	WRITE_NETWORK_POINTER(20, (void *) params);
	WRITE_NETWORK_POINTER(28, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetCombinerOutputParameterfvNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum stage, GLenum portion, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	WRITE_DATA(0, GLint, SWAP32(36));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETCOMBINEROUTPUTPARAMETERFVNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(stage));
	WRITE_DATA(12, GLenum, SWAP32(portion));
	WRITE_DATA(16, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(20, (void *) params);
	WRITE_NETWORK_POINTER(28, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetCombinerOutputParameterivNV(CR_PACKER_CONTEXT_ARGDECL GLenum stage, GLenum portion, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	WRITE_DATA(0, GLint, 36);
	WRITE_DATA(4, GLenum, CR_GETCOMBINEROUTPUTPARAMETERIVNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, stage);
	WRITE_DATA(12, GLenum, portion);
	WRITE_DATA(16, GLenum, pname);
	WRITE_NETWORK_POINTER(20, (void *) params);
	WRITE_NETWORK_POINTER(28, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetCombinerOutputParameterivNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum stage, GLenum portion, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	WRITE_DATA(0, GLint, SWAP32(36));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETCOMBINEROUTPUTPARAMETERIVNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(stage));
	WRITE_DATA(12, GLenum, SWAP32(portion));
	WRITE_DATA(16, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(20, (void *) params);
	WRITE_NETWORK_POINTER(28, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetCombinerStageParameterfvNV(CR_PACKER_CONTEXT_ARGDECL GLenum stage, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETCOMBINERSTAGEPARAMETERFVNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, stage);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetCombinerStageParameterfvNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum stage, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETCOMBINERSTAGEPARAMETERFVNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(stage));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetDoublev(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLdouble * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GETDOUBLEV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, pname);
	WRITE_NETWORK_POINTER(12, (void *) params);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetDoublevSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLdouble * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETDOUBLEV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(12, (void *) params);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetError(CR_PACKER_CONTEXT_ARGDECL GLenum * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, 24);
	WRITE_DATA(4, GLenum, CR_GETERROR_EXTEND_OPCODE);
	WRITE_NETWORK_POINTER(8, (void *) return_value);
	WRITE_NETWORK_POINTER(16, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetErrorSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, SWAP32(24));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETERROR_EXTEND_OPCODE));
	WRITE_NETWORK_POINTER(8, (void *) return_value);
	WRITE_NETWORK_POINTER(16, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetFenceivNV(CR_PACKER_CONTEXT_ARGDECL GLuint fence, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETFENCEIVNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, fence);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetFenceivNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint fence, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETFENCEIVNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(fence));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetFinalCombinerInputParameterfvNV(CR_PACKER_CONTEXT_ARGDECL GLenum variable, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETFINALCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, variable);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetFinalCombinerInputParameterfvNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum variable, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETFINALCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(variable));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetFinalCombinerInputParameterivNV(CR_PACKER_CONTEXT_ARGDECL GLenum variable, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETFINALCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, variable);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetFinalCombinerInputParameterivNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum variable, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETFINALCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(variable));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetFloatv(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GETFLOATV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, pname);
	WRITE_NETWORK_POINTER(12, (void *) params);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetFloatvSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETFLOATV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(12, (void *) params);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetFramebufferAttachmentParameterivEXT(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum attachment, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	WRITE_DATA(0, GLint, 36);
	WRITE_DATA(4, GLenum, CR_GETFRAMEBUFFERATTACHMENTPARAMETERIVEXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, attachment);
	WRITE_DATA(16, GLenum, pname);
	WRITE_NETWORK_POINTER(20, (void *) params);
	WRITE_NETWORK_POINTER(28, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetFramebufferAttachmentParameterivEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum attachment, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	WRITE_DATA(0, GLint, SWAP32(36));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETFRAMEBUFFERATTACHMENTPARAMETERIVEXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(attachment));
	WRITE_DATA(16, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(20, (void *) params);
	WRITE_NETWORK_POINTER(28, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetHandleARB(CR_PACKER_CONTEXT_ARGDECL GLenum pname, VBoxGLhandleARB * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GETHANDLEARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, pname);
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetHandleARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum pname, VBoxGLhandleARB * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETHANDLEARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetIntegerv(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GETINTEGERV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, pname);
	WRITE_NETWORK_POINTER(12, (void *) params);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetIntegervSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETINTEGERV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(12, (void *) params);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetLightfv(CR_PACKER_CONTEXT_ARGDECL GLenum light, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETLIGHTFV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, light);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetLightfvSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum light, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETLIGHTFV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(light));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetLightiv(CR_PACKER_CONTEXT_ARGDECL GLenum light, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETLIGHTIV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, light);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetLightivSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum light, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETLIGHTIV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(light));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetMapdv(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum query, GLdouble * v, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETMAPDV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, query);
	WRITE_NETWORK_POINTER(16, (void *) v);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetMapdvSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum query, GLdouble * v, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETMAPDV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(query));
	WRITE_NETWORK_POINTER(16, (void *) v);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetMapfv(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum query, GLfloat * v, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETMAPFV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, query);
	WRITE_NETWORK_POINTER(16, (void *) v);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetMapfvSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum query, GLfloat * v, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETMAPFV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(query));
	WRITE_NETWORK_POINTER(16, (void *) v);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetMapiv(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum query, GLint * v, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETMAPIV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, query);
	WRITE_NETWORK_POINTER(16, (void *) v);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetMapivSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum query, GLint * v, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETMAPIV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(query));
	WRITE_NETWORK_POINTER(16, (void *) v);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetMaterialfv(CR_PACKER_CONTEXT_ARGDECL GLenum face, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETMATERIALFV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, face);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetMaterialfvSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum face, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETMATERIALFV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(face));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetMaterialiv(CR_PACKER_CONTEXT_ARGDECL GLenum face, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETMATERIALIV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, face);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetMaterialivSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum face, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETMATERIALIV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(face));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetObjectParameterfvARB(CR_PACKER_CONTEXT_ARGDECL VBoxGLhandleARB obj, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETOBJECTPARAMETERFVARB_EXTEND_OPCODE);
	WRITE_DATA(8, VBoxGLhandleARB, obj);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetObjectParameterfvARBSWAP(CR_PACKER_CONTEXT_ARGDECL VBoxGLhandleARB obj, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETOBJECTPARAMETERFVARB_EXTEND_OPCODE));
	WRITE_DATA(8, VBoxGLhandleARB, SWAP32(obj));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetObjectParameterivARB(CR_PACKER_CONTEXT_ARGDECL VBoxGLhandleARB obj, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETOBJECTPARAMETERIVARB_EXTEND_OPCODE);
	WRITE_DATA(8, VBoxGLhandleARB, obj);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetObjectParameterivARBSWAP(CR_PACKER_CONTEXT_ARGDECL VBoxGLhandleARB obj, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETOBJECTPARAMETERIVARB_EXTEND_OPCODE));
	WRITE_DATA(8, VBoxGLhandleARB, SWAP32(obj));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetPixelMapfv(CR_PACKER_CONTEXT_ARGDECL GLenum map, GLfloat * values, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GETPIXELMAPFV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, map);
	WRITE_NETWORK_POINTER(12, (void *) values);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetPixelMapfvSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum map, GLfloat * values, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETPIXELMAPFV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(map));
	WRITE_NETWORK_POINTER(12, (void *) values);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetPixelMapuiv(CR_PACKER_CONTEXT_ARGDECL GLenum map, GLuint * values, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GETPIXELMAPUIV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, map);
	WRITE_NETWORK_POINTER(12, (void *) values);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetPixelMapuivSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum map, GLuint * values, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETPIXELMAPUIV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(map));
	WRITE_NETWORK_POINTER(12, (void *) values);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetPixelMapusv(CR_PACKER_CONTEXT_ARGDECL GLenum map, GLushort * values, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GETPIXELMAPUSV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, map);
	WRITE_NETWORK_POINTER(12, (void *) values);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetPixelMapusvSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum map, GLushort * values, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETPIXELMAPUSV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(map));
	WRITE_NETWORK_POINTER(12, (void *) values);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetPointerv(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLvoid ** params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GETPOINTERV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, pname);
	WRITE_NETWORK_POINTER(12, (void *) params);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetPointervSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLvoid ** params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETPOINTERV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(12, (void *) params);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetPolygonStipple(CR_PACKER_CONTEXT_ARGDECL GLubyte * mask, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, 24);
	WRITE_DATA(4, GLenum, CR_GETPOLYGONSTIPPLE_EXTEND_OPCODE);
	WRITE_NETWORK_POINTER(8, (void *) mask);
	WRITE_NETWORK_POINTER(16, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetPolygonStippleSWAP(CR_PACKER_CONTEXT_ARGDECL GLubyte * mask, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, SWAP32(24));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETPOLYGONSTIPPLE_EXTEND_OPCODE));
	WRITE_NETWORK_POINTER(8, (void *) mask);
	WRITE_NETWORK_POINTER(16, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetProgramEnvParameterdvARB(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLdouble * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETPROGRAMENVPARAMETERDVARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramEnvParameterdvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLdouble * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETPROGRAMENVPARAMETERDVARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetProgramEnvParameterfvARB(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETPROGRAMENVPARAMETERFVARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramEnvParameterfvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETPROGRAMENVPARAMETERFVARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetProgramLocalParameterdvARB(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLdouble * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETPROGRAMLOCALPARAMETERDVARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramLocalParameterdvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLdouble * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETPROGRAMLOCALPARAMETERDVARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetProgramLocalParameterfvARB(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETPROGRAMLOCALPARAMETERFVARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramLocalParameterfvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETPROGRAMLOCALPARAMETERFVARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetProgramParameterdvNV(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLenum pname, GLdouble * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	WRITE_DATA(0, GLint, 36);
	WRITE_DATA(4, GLenum, CR_GETPROGRAMPARAMETERDVNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_DATA(16, GLenum, pname);
	WRITE_NETWORK_POINTER(20, (void *) params);
	WRITE_NETWORK_POINTER(28, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramParameterdvNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLenum pname, GLdouble * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	WRITE_DATA(0, GLint, SWAP32(36));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETPROGRAMPARAMETERDVNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_DATA(16, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(20, (void *) params);
	WRITE_NETWORK_POINTER(28, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetProgramParameterfvNV(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	WRITE_DATA(0, GLint, 36);
	WRITE_DATA(4, GLenum, CR_GETPROGRAMPARAMETERFVNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_DATA(16, GLenum, pname);
	WRITE_NETWORK_POINTER(20, (void *) params);
	WRITE_NETWORK_POINTER(28, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramParameterfvNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	WRITE_DATA(0, GLint, SWAP32(36));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETPROGRAMPARAMETERFVNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_DATA(16, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(20, (void *) params);
	WRITE_NETWORK_POINTER(28, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetProgramStringARB(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum pname, GLvoid * string, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETPROGRAMSTRINGARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) string);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramStringARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum pname, GLvoid * string, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETPROGRAMSTRINGARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) string);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetProgramStringNV(CR_PACKER_CONTEXT_ARGDECL GLuint id, GLenum pname, GLubyte * program, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETPROGRAMSTRINGNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, id);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) program);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramStringNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint id, GLenum pname, GLubyte * program, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETPROGRAMSTRINGNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(id));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) program);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetProgramiv(CR_PACKER_CONTEXT_ARGDECL GLuint program, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETPROGRAMIV_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, program);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramivSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint program, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETPROGRAMIV_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(program));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetProgramivARB(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETPROGRAMIVARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramivARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETPROGRAMIVARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetProgramivNV(CR_PACKER_CONTEXT_ARGDECL GLuint id, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETPROGRAMIVNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, id);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramivNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint id, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETPROGRAMIVNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(id));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetQueryObjectivARB(CR_PACKER_CONTEXT_ARGDECL GLuint id, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETQUERYOBJECTIVARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, id);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetQueryObjectivARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint id, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETQUERYOBJECTIVARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(id));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetQueryObjectuivARB(CR_PACKER_CONTEXT_ARGDECL GLuint id, GLenum pname, GLuint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETQUERYOBJECTUIVARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, id);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetQueryObjectuivARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint id, GLenum pname, GLuint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETQUERYOBJECTUIVARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(id));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetQueryivARB(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETQUERYIVARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetQueryivARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETQUERYIVARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetRenderbufferParameterivEXT(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETRENDERBUFFERPARAMETERIVEXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetRenderbufferParameterivEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETRENDERBUFFERPARAMETERIVEXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetShaderiv(CR_PACKER_CONTEXT_ARGDECL GLuint shader, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETSHADERIV_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, shader);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetShaderivSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint shader, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETSHADERIV_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(shader));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetString(CR_PACKER_CONTEXT_ARGDECL GLenum name, const GLubyte * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_GETSTRING_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, name);
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetStringSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum name, const GLubyte * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETSTRING_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(name));
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetTexEnvfv(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETTEXENVFV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexEnvfvSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETTEXENVFV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetTexEnviv(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETTEXENVIV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexEnvivSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETTEXENVIV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetTexGendv(CR_PACKER_CONTEXT_ARGDECL GLenum coord, GLenum pname, GLdouble * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETTEXGENDV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, coord);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexGendvSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum coord, GLenum pname, GLdouble * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETTEXGENDV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(coord));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetTexGenfv(CR_PACKER_CONTEXT_ARGDECL GLenum coord, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETTEXGENFV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, coord);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexGenfvSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum coord, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETTEXGENFV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(coord));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetTexGeniv(CR_PACKER_CONTEXT_ARGDECL GLenum coord, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETTEXGENIV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, coord);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexGenivSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum coord, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETTEXGENIV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(coord));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetTexLevelParameterfv(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLint level, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	WRITE_DATA(0, GLint, 36);
	WRITE_DATA(4, GLenum, CR_GETTEXLEVELPARAMETERFV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLint, level);
	WRITE_DATA(16, GLenum, pname);
	WRITE_NETWORK_POINTER(20, (void *) params);
	WRITE_NETWORK_POINTER(28, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexLevelParameterfvSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLint level, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	WRITE_DATA(0, GLint, SWAP32(36));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETTEXLEVELPARAMETERFV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLint, SWAP32(level));
	WRITE_DATA(16, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(20, (void *) params);
	WRITE_NETWORK_POINTER(28, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetTexLevelParameteriv(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLint level, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	WRITE_DATA(0, GLint, 36);
	WRITE_DATA(4, GLenum, CR_GETTEXLEVELPARAMETERIV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLint, level);
	WRITE_DATA(16, GLenum, pname);
	WRITE_NETWORK_POINTER(20, (void *) params);
	WRITE_NETWORK_POINTER(28, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexLevelParameterivSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLint level, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	WRITE_DATA(0, GLint, SWAP32(36));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETTEXLEVELPARAMETERIV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLint, SWAP32(level));
	WRITE_DATA(16, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(20, (void *) params);
	WRITE_NETWORK_POINTER(28, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetTexParameterfv(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETTEXPARAMETERFV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexParameterfvSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETTEXPARAMETERFV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetTexParameteriv(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETTEXPARAMETERIV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexParameterivSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETTEXPARAMETERIV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetTrackMatrixivNV(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint address, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	WRITE_DATA(0, GLint, 36);
	WRITE_DATA(4, GLenum, CR_GETTRACKMATRIXIVNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, address);
	WRITE_DATA(16, GLenum, pname);
	WRITE_NETWORK_POINTER(20, (void *) params);
	WRITE_NETWORK_POINTER(28, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTrackMatrixivNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint address, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	WRITE_DATA(0, GLint, SWAP32(36));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETTRACKMATRIXIVNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(address));
	WRITE_DATA(16, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(20, (void *) params);
	WRITE_NETWORK_POINTER(28, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetUniformfv(CR_PACKER_CONTEXT_ARGDECL GLuint program, GLint location, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETUNIFORMFV_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, program);
	WRITE_DATA(12, GLint, location);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetUniformfvSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint program, GLint location, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETUNIFORMFV_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(program));
	WRITE_DATA(12, GLint, SWAP32(location));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetUniformiv(CR_PACKER_CONTEXT_ARGDECL GLuint program, GLint location, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETUNIFORMIV_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, program);
	WRITE_DATA(12, GLint, location);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetUniformivSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint program, GLint location, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETUNIFORMIV_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(program));
	WRITE_DATA(12, GLint, SWAP32(location));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetVertexAttribPointervARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLenum pname, GLvoid ** pointer, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETVERTEXATTRIBPOINTERVARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, index);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) pointer);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribPointervARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLenum pname, GLvoid ** pointer, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETVERTEXATTRIBPOINTERVARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(index));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) pointer);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetVertexAttribPointervNV(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLenum pname, GLvoid ** pointer, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETVERTEXATTRIBPOINTERVNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, index);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) pointer);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribPointervNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLenum pname, GLvoid ** pointer, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETVERTEXATTRIBPOINTERVNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(index));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) pointer);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetVertexAttribdvARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLenum pname, GLdouble * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETVERTEXATTRIBDVARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, index);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribdvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLenum pname, GLdouble * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETVERTEXATTRIBDVARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(index));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetVertexAttribdvNV(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLenum pname, GLdouble * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETVERTEXATTRIBDVNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, index);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribdvNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLenum pname, GLdouble * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETVERTEXATTRIBDVNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(index));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetVertexAttribfvARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETVERTEXATTRIBFVARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, index);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribfvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETVERTEXATTRIBFVARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(index));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetVertexAttribfvNV(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETVERTEXATTRIBFVNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, index);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribfvNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLenum pname, GLfloat * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETVERTEXATTRIBFVNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(index));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetVertexAttribivARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETVERTEXATTRIBIVARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, index);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribivARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETVERTEXATTRIBIVARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(index));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackGetVertexAttribivNV(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_GETVERTEXATTRIBIVNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, index);
	WRITE_DATA(12, GLenum, pname);
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribivNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLenum pname, GLint * params, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_GETVERTEXATTRIBIVNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(index));
	WRITE_DATA(12, GLenum, SWAP32(pname));
	WRITE_NETWORK_POINTER(16, (void *) params);
	WRITE_NETWORK_POINTER(24, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackHint(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_HINT_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, mode);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackHintSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_HINT_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(mode));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIndexMask(CR_PACKER_CONTEXT_ARGDECL GLuint mask)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLuint, mask);
	WRITE_OPCODE(pc, CR_INDEXMASK_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexMaskSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint mask)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLuint, SWAP32(mask));
	WRITE_OPCODE(pc, CR_INDEXMASK_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIndexd(CR_PACKER_CONTEXT_ARGDECL GLdouble c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.index.d1 = data_ptr;
	WRITE_DOUBLE(0, c);
	WRITE_OPCODE(pc, CR_INDEXD_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexdSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.index.d1 = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, c);
	WRITE_OPCODE(pc, CR_INDEXD_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIndexdv(CR_PACKER_CONTEXT_ARGDECL const GLdouble * c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexdv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.index.d1 = data_ptr;
	WRITE_DOUBLE(0, c[0]);
	WRITE_OPCODE(pc, CR_INDEXD_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexdvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexdv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.index.d1 = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, c[0]);
	WRITE_OPCODE(pc, CR_INDEXD_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIndexf(CR_PACKER_CONTEXT_ARGDECL GLfloat c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.index.f1 = data_ptr;
	WRITE_DATA(0, GLfloat, c);
	WRITE_OPCODE(pc, CR_INDEXF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexfSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.index.f1 = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(c));
	WRITE_OPCODE(pc, CR_INDEXF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIndexfv(CR_PACKER_CONTEXT_ARGDECL const GLfloat * c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexfv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.index.f1 = data_ptr;
	WRITE_DATA(0, GLfloat, c[0]);
	WRITE_OPCODE(pc, CR_INDEXF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexfvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexfv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.index.f1 = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(c[0]));
	WRITE_OPCODE(pc, CR_INDEXF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIndexi(CR_PACKER_CONTEXT_ARGDECL GLint c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.index.i1 = data_ptr;
	WRITE_DATA(0, GLint, c);
	WRITE_OPCODE(pc, CR_INDEXI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexiSWAP(CR_PACKER_CONTEXT_ARGDECL GLint c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.index.i1 = data_ptr;
	WRITE_DATA(0, GLint, SWAP32(c));
	WRITE_OPCODE(pc, CR_INDEXI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIndexiv(CR_PACKER_CONTEXT_ARGDECL const GLint * c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexiv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.index.i1 = data_ptr;
	WRITE_DATA(0, GLint, c[0]);
	WRITE_OPCODE(pc, CR_INDEXI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexivSWAP(CR_PACKER_CONTEXT_ARGDECL const GLint * c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexiv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.index.i1 = data_ptr;
	WRITE_DATA(0, GLint, SWAP32(c[0]));
	WRITE_OPCODE(pc, CR_INDEXI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIndexs(CR_PACKER_CONTEXT_ARGDECL GLshort c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.index.s1 = data_ptr;
	WRITE_DATA(0, GLshort, c);
	WRITE_OPCODE(pc, CR_INDEXS_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexsSWAP(CR_PACKER_CONTEXT_ARGDECL GLshort c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.index.s1 = data_ptr;
	WRITE_DATA(0, GLshort, SWAP16(c));
	WRITE_OPCODE(pc, CR_INDEXS_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIndexsv(CR_PACKER_CONTEXT_ARGDECL const GLshort * c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexsv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.index.s1 = data_ptr;
	WRITE_DATA(0, GLshort, c[0]);
	WRITE_OPCODE(pc, CR_INDEXS_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexsvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLshort * c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexsv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.index.s1 = data_ptr;
	WRITE_DATA(0, GLshort, SWAP16(c[0]));
	WRITE_OPCODE(pc, CR_INDEXS_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIndexub(CR_PACKER_CONTEXT_ARGDECL GLubyte c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.index.ub1 = data_ptr;
	WRITE_DATA(0, GLubyte, c);
	WRITE_OPCODE(pc, CR_INDEXUB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexubSWAP(CR_PACKER_CONTEXT_ARGDECL GLubyte c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.index.ub1 = data_ptr;
	WRITE_DATA(0, GLubyte, c);
	WRITE_OPCODE(pc, CR_INDEXUB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIndexubv(CR_PACKER_CONTEXT_ARGDECL const GLubyte * c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexubv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.index.ub1 = data_ptr;
	WRITE_DATA(0, GLubyte, c[0]);
	WRITE_OPCODE(pc, CR_INDEXUB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexubvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLubyte * c)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexubv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.index.ub1 = data_ptr;
	WRITE_DATA(0, GLubyte, c[0]);
	WRITE_OPCODE(pc, CR_INDEXUB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackInitNames(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS(pc);
	WRITE_OPCODE(pc, CR_INITNAMES_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackInitNamesSWAP(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS(pc);
	WRITE_OPCODE(pc, CR_INITNAMES_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIsBufferARB(CR_PACKER_CONTEXT_ARGDECL GLuint buffer, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_ISBUFFERARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, buffer);
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsBufferARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint buffer, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_ISBUFFERARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(buffer));
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIsEnabled(CR_PACKER_CONTEXT_ARGDECL GLenum cap, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_ISENABLED_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, cap);
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsEnabledSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum cap, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_ISENABLED_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(cap));
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIsFenceNV(CR_PACKER_CONTEXT_ARGDECL GLuint fence, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_ISFENCENV_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, fence);
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsFenceNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint fence, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_ISFENCENV_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(fence));
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIsFramebufferEXT(CR_PACKER_CONTEXT_ARGDECL GLuint framebuffer, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_ISFRAMEBUFFEREXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, framebuffer);
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsFramebufferEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint framebuffer, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_ISFRAMEBUFFEREXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(framebuffer));
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIsList(CR_PACKER_CONTEXT_ARGDECL GLuint list, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_ISLIST_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, list);
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsListSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint list, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_ISLIST_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(list));
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIsProgram(CR_PACKER_CONTEXT_ARGDECL GLuint program, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_ISPROGRAM_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, program);
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsProgramSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint program, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_ISPROGRAM_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(program));
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIsProgramARB(CR_PACKER_CONTEXT_ARGDECL GLuint program, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_ISPROGRAMARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, program);
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsProgramARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint program, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_ISPROGRAMARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(program));
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIsQueryARB(CR_PACKER_CONTEXT_ARGDECL GLuint id, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_ISQUERYARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, id);
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsQueryARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint id, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_ISQUERYARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(id));
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIsRenderbufferEXT(CR_PACKER_CONTEXT_ARGDECL GLuint renderbuffer, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_ISRENDERBUFFEREXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, renderbuffer);
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsRenderbufferEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint renderbuffer, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_ISRENDERBUFFEREXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(renderbuffer));
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIsShader(CR_PACKER_CONTEXT_ARGDECL GLuint shader, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_ISSHADER_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, shader);
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsShaderSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint shader, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_ISSHADER_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(shader));
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackIsTexture(CR_PACKER_CONTEXT_ARGDECL GLuint texture, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_ISTEXTURE_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, texture);
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsTextureSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint texture, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_ISTEXTURE_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(texture));
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackLightModelf(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLfloat param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, pname);
	WRITE_DATA(4, GLfloat, param);
	WRITE_OPCODE(pc, CR_LIGHTMODELF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLightModelfSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLfloat param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, SWAP32(pname));
	WRITE_DATA(4, GLuint, SWAPFLOAT(param));
	WRITE_OPCODE(pc, CR_LIGHTMODELF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackLightModeli(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLint param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, pname);
	WRITE_DATA(4, GLint, param);
	WRITE_OPCODE(pc, CR_LIGHTMODELI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLightModeliSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLint param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, SWAP32(pname));
	WRITE_DATA(4, GLint, SWAP32(param));
	WRITE_OPCODE(pc, CR_LIGHTMODELI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackLightf(CR_PACKER_CONTEXT_ARGDECL GLenum light, GLenum pname, GLfloat param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLenum, light);
	WRITE_DATA(4, GLenum, pname);
	WRITE_DATA(8, GLfloat, param);
	WRITE_OPCODE(pc, CR_LIGHTF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLightfSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum light, GLenum pname, GLfloat param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLenum, SWAP32(light));
	WRITE_DATA(4, GLenum, SWAP32(pname));
	WRITE_DATA(8, GLuint, SWAPFLOAT(param));
	WRITE_OPCODE(pc, CR_LIGHTF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackLighti(CR_PACKER_CONTEXT_ARGDECL GLenum light, GLenum pname, GLint param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLenum, light);
	WRITE_DATA(4, GLenum, pname);
	WRITE_DATA(8, GLint, param);
	WRITE_OPCODE(pc, CR_LIGHTI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLightiSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum light, GLenum pname, GLint param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLenum, SWAP32(light));
	WRITE_DATA(4, GLenum, SWAP32(pname));
	WRITE_DATA(8, GLint, SWAP32(param));
	WRITE_OPCODE(pc, CR_LIGHTI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackLineStipple(CR_PACKER_CONTEXT_ARGDECL GLint factor, GLushort pattern)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, factor);
	WRITE_DATA(4, GLushort, pattern);
	WRITE_OPCODE(pc, CR_LINESTIPPLE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLineStippleSWAP(CR_PACKER_CONTEXT_ARGDECL GLint factor, GLushort pattern)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, SWAP32(factor));
	WRITE_DATA(4, GLushort, SWAP16(pattern));
	WRITE_OPCODE(pc, CR_LINESTIPPLE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackLineWidth(CR_PACKER_CONTEXT_ARGDECL GLfloat width)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLfloat, width);
	WRITE_OPCODE(pc, CR_LINEWIDTH_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLineWidthSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat width)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLuint, SWAPFLOAT(width));
	WRITE_OPCODE(pc, CR_LINEWIDTH_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackLinkProgram(CR_PACKER_CONTEXT_ARGDECL GLuint program)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_LINKPROGRAM_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, program);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLinkProgramSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint program)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_LINKPROGRAM_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(program));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackListBase(CR_PACKER_CONTEXT_ARGDECL GLuint base)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_LISTBASE_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, base);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackListBaseSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint base)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_LISTBASE_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(base));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackLoadIdentity(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS(pc);
	WRITE_OPCODE(pc, CR_LOADIDENTITY_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLoadIdentitySWAP(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS(pc);
	WRITE_OPCODE(pc, CR_LOADIDENTITY_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackLoadName(CR_PACKER_CONTEXT_ARGDECL GLuint name)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLuint, name);
	WRITE_OPCODE(pc, CR_LOADNAME_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLoadNameSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint name)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLuint, SWAP32(name));
	WRITE_OPCODE(pc, CR_LOADNAME_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackLogicOp(CR_PACKER_CONTEXT_ARGDECL GLenum opcode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_LOGICOP_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, opcode);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLogicOpSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum opcode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_LOGICOP_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(opcode));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMakeCurrent(CR_PACKER_CONTEXT_ARGDECL GLint window, GLint nativeWindow, GLint ctx)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLint, 20);
	WRITE_DATA(4, GLenum, CR_MAKECURRENT_EXTEND_OPCODE);
	WRITE_DATA(8, GLint, window);
	WRITE_DATA(12, GLint, nativeWindow);
	WRITE_DATA(16, GLint, ctx);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMakeCurrentSWAP(CR_PACKER_CONTEXT_ARGDECL GLint window, GLint nativeWindow, GLint ctx)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLint, SWAP32(20));
	WRITE_DATA(4, GLenum, SWAP32(CR_MAKECURRENT_EXTEND_OPCODE));
	WRITE_DATA(8, GLint, SWAP32(window));
	WRITE_DATA(12, GLint, SWAP32(nativeWindow));
	WRITE_DATA(16, GLint, SWAP32(ctx));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMapGrid1d(CR_PACKER_CONTEXT_ARGDECL GLint un, GLdouble u1, GLdouble u2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLint, un);
	WRITE_DOUBLE(4, u1);
	WRITE_DOUBLE(12, u2);
	WRITE_OPCODE(pc, CR_MAPGRID1D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMapGrid1dSWAP(CR_PACKER_CONTEXT_ARGDECL GLint un, GLdouble u1, GLdouble u2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLint, SWAP32(un));
	WRITE_SWAPPED_DOUBLE(4, u1);
	WRITE_SWAPPED_DOUBLE(12, u2);
	WRITE_OPCODE(pc, CR_MAPGRID1D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMapGrid1f(CR_PACKER_CONTEXT_ARGDECL GLint un, GLfloat u1, GLfloat u2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, un);
	WRITE_DATA(4, GLfloat, u1);
	WRITE_DATA(8, GLfloat, u2);
	WRITE_OPCODE(pc, CR_MAPGRID1F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMapGrid1fSWAP(CR_PACKER_CONTEXT_ARGDECL GLint un, GLfloat u1, GLfloat u2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(un));
	WRITE_DATA(4, GLuint, SWAPFLOAT(u1));
	WRITE_DATA(8, GLuint, SWAPFLOAT(u2));
	WRITE_OPCODE(pc, CR_MAPGRID1F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMapGrid2d(CR_PACKER_CONTEXT_ARGDECL GLint un, GLdouble u1, GLdouble u2, GLint vn, GLdouble v1, GLdouble v2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 40);
	WRITE_DATA(0, GLint, un);
	WRITE_DOUBLE(4, u1);
	WRITE_DOUBLE(12, u2);
	WRITE_DATA(20, GLint, vn);
	WRITE_DOUBLE(24, v1);
	WRITE_DOUBLE(32, v2);
	WRITE_OPCODE(pc, CR_MAPGRID2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMapGrid2dSWAP(CR_PACKER_CONTEXT_ARGDECL GLint un, GLdouble u1, GLdouble u2, GLint vn, GLdouble v1, GLdouble v2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 40);
	WRITE_DATA(0, GLint, SWAP32(un));
	WRITE_SWAPPED_DOUBLE(4, u1);
	WRITE_SWAPPED_DOUBLE(12, u2);
	WRITE_DATA(20, GLint, SWAP32(vn));
	WRITE_SWAPPED_DOUBLE(24, v1);
	WRITE_SWAPPED_DOUBLE(32, v2);
	WRITE_OPCODE(pc, CR_MAPGRID2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMapGrid2f(CR_PACKER_CONTEXT_ARGDECL GLint un, GLfloat u1, GLfloat u2, GLint vn, GLfloat v1, GLfloat v2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, un);
	WRITE_DATA(4, GLfloat, u1);
	WRITE_DATA(8, GLfloat, u2);
	WRITE_DATA(12, GLint, vn);
	WRITE_DATA(16, GLfloat, v1);
	WRITE_DATA(20, GLfloat, v2);
	WRITE_OPCODE(pc, CR_MAPGRID2F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMapGrid2fSWAP(CR_PACKER_CONTEXT_ARGDECL GLint un, GLfloat u1, GLfloat u2, GLint vn, GLfloat v1, GLfloat v2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, SWAP32(un));
	WRITE_DATA(4, GLuint, SWAPFLOAT(u1));
	WRITE_DATA(8, GLuint, SWAPFLOAT(u2));
	WRITE_DATA(12, GLint, SWAP32(vn));
	WRITE_DATA(16, GLuint, SWAPFLOAT(v1));
	WRITE_DATA(20, GLuint, SWAPFLOAT(v2));
	WRITE_OPCODE(pc, CR_MAPGRID2F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMaterialf(CR_PACKER_CONTEXT_ARGDECL GLenum face, GLenum pname, GLfloat param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLenum, face);
	WRITE_DATA(4, GLenum, pname);
	WRITE_DATA(8, GLfloat, param);
	WRITE_OPCODE(pc, CR_MATERIALF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMaterialfSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum face, GLenum pname, GLfloat param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLenum, SWAP32(face));
	WRITE_DATA(4, GLenum, SWAP32(pname));
	WRITE_DATA(8, GLuint, SWAPFLOAT(param));
	WRITE_OPCODE(pc, CR_MATERIALF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMateriali(CR_PACKER_CONTEXT_ARGDECL GLenum face, GLenum pname, GLint param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLenum, face);
	WRITE_DATA(4, GLenum, pname);
	WRITE_DATA(8, GLint, param);
	WRITE_OPCODE(pc, CR_MATERIALI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMaterialiSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum face, GLenum pname, GLint param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLenum, SWAP32(face));
	WRITE_DATA(4, GLenum, SWAP32(pname));
	WRITE_DATA(8, GLint, SWAP32(param));
	WRITE_OPCODE(pc, CR_MATERIALI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMatrixMode(CR_PACKER_CONTEXT_ARGDECL GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLenum, mode);
	WRITE_OPCODE(pc, CR_MATRIXMODE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMatrixModeSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLenum, SWAP32(mode));
	WRITE_OPCODE(pc, CR_MATRIXMODE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord1dARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLdouble s)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.d1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DOUBLE(4, s);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD1DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1dARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLdouble s)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.d1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_SWAPPED_DOUBLE(4, s);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD1DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord1dvARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLdouble * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord1dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.d1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DOUBLE(4, t[0]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD1DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1dvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLdouble * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord1dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.d1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_SWAPPED_DOUBLE(4, t[0]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD1DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord1fARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLfloat s)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.f1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLfloat, s);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD1FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1fARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLfloat s)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.f1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLuint, SWAPFLOAT(s));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD1FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord1fvARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLfloat * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord1fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.f1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLfloat, t[0]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD1FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1fvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLfloat * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord1fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.f1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLuint, SWAPFLOAT(t[0]));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD1FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord1iARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLint s)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.i1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLint, s);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD1IARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1iARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLint s)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.i1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLint, SWAP32(s));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD1IARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord1ivARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLint * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord1ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.i1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLint, t[0]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD1IARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1ivARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLint * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord1ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.i1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLint, SWAP32(t[0]));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD1IARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord1sARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLshort s)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.s1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLshort, s);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD1SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1sARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLshort s)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.s1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLshort, SWAP16(s));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD1SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord1svARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLshort * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord1svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.s1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLshort, t[0]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD1SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1svARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLshort * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord1svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.s1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLshort, SWAP16(t[0]));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD1SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord2dARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLdouble s, GLdouble t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.texCoord.d2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DOUBLE(4, s);
	WRITE_DOUBLE(12, t);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD2DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2dARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLdouble s, GLdouble t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.texCoord.d2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_SWAPPED_DOUBLE(4, s);
	WRITE_SWAPPED_DOUBLE(12, t);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD2DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord2dvARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLdouble * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord2dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.texCoord.d2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DOUBLE(4, t[0]);
	WRITE_DOUBLE(12, t[1]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD2DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2dvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLdouble * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord2dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.texCoord.d2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_SWAPPED_DOUBLE(4, t[0]);
	WRITE_SWAPPED_DOUBLE(12, t[1]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD2DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord2fARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLfloat s, GLfloat t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.f2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLfloat, s);
	WRITE_DATA(8, GLfloat, t);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD2FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2fARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLfloat s, GLfloat t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.f2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLuint, SWAPFLOAT(s));
	WRITE_DATA(8, GLuint, SWAPFLOAT(t));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD2FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord2fvARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLfloat * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord2fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.f2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLfloat, t[0]);
	WRITE_DATA(8, GLfloat, t[1]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD2FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2fvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLfloat * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord2fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.f2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLuint, SWAPFLOAT(t[0]));
	WRITE_DATA(8, GLuint, SWAPFLOAT(t[1]));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD2FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord2iARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLint s, GLint t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.i2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLint, s);
	WRITE_DATA(8, GLint, t);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD2IARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2iARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLint s, GLint t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.i2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLint, SWAP32(s));
	WRITE_DATA(8, GLint, SWAP32(t));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD2IARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord2ivARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLint * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord2ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.i2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLint, t[0]);
	WRITE_DATA(8, GLint, t[1]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD2IARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2ivARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLint * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord2ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.i2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLint, SWAP32(t[0]));
	WRITE_DATA(8, GLint, SWAP32(t[1]));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD2IARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord2sARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLshort s, GLshort t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.s2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLshort, s);
	WRITE_DATA(6, GLshort, t);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD2SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2sARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLshort s, GLshort t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.s2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLshort, SWAP16(s));
	WRITE_DATA(6, GLshort, SWAP16(t));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD2SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord2svARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLshort * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord2svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.s2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLshort, t[0]);
	WRITE_DATA(6, GLshort, t[1]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD2SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2svARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLshort * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord2svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.s2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLshort, SWAP16(t[0]));
	WRITE_DATA(6, GLshort, SWAP16(t[1]));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD2SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord3dARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLdouble s, GLdouble t, GLdouble r)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	pc->current.c.texCoord.d3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DOUBLE(4, s);
	WRITE_DOUBLE(12, t);
	WRITE_DOUBLE(20, r);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD3DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3dARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLdouble s, GLdouble t, GLdouble r)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	pc->current.c.texCoord.d3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_SWAPPED_DOUBLE(4, s);
	WRITE_SWAPPED_DOUBLE(12, t);
	WRITE_SWAPPED_DOUBLE(20, r);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD3DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord3dvARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLdouble * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord3dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 28);
	pc->current.c.texCoord.d3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DOUBLE(4, t[0]);
	WRITE_DOUBLE(12, t[1]);
	WRITE_DOUBLE(20, t[2]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD3DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3dvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLdouble * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord3dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 28);
	pc->current.c.texCoord.d3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_SWAPPED_DOUBLE(4, t[0]);
	WRITE_SWAPPED_DOUBLE(12, t[1]);
	WRITE_SWAPPED_DOUBLE(20, t[2]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD3DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord3fARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLfloat s, GLfloat t, GLfloat r)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.f3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLfloat, s);
	WRITE_DATA(8, GLfloat, t);
	WRITE_DATA(12, GLfloat, r);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD3FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3fARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLfloat s, GLfloat t, GLfloat r)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.f3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLuint, SWAPFLOAT(s));
	WRITE_DATA(8, GLuint, SWAPFLOAT(t));
	WRITE_DATA(12, GLuint, SWAPFLOAT(r));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD3FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord3fvARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLfloat * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord3fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.f3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLfloat, t[0]);
	WRITE_DATA(8, GLfloat, t[1]);
	WRITE_DATA(12, GLfloat, t[2]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD3FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3fvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLfloat * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord3fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.f3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLuint, SWAPFLOAT(t[0]));
	WRITE_DATA(8, GLuint, SWAPFLOAT(t[1]));
	WRITE_DATA(12, GLuint, SWAPFLOAT(t[2]));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD3FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord3iARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLint s, GLint t, GLint r)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.i3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLint, s);
	WRITE_DATA(8, GLint, t);
	WRITE_DATA(12, GLint, r);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD3IARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3iARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLint s, GLint t, GLint r)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.i3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLint, SWAP32(s));
	WRITE_DATA(8, GLint, SWAP32(t));
	WRITE_DATA(12, GLint, SWAP32(r));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD3IARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord3ivARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLint * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord3ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.i3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLint, t[0]);
	WRITE_DATA(8, GLint, t[1]);
	WRITE_DATA(12, GLint, t[2]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD3IARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3ivARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLint * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord3ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.i3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLint, SWAP32(t[0]));
	WRITE_DATA(8, GLint, SWAP32(t[1]));
	WRITE_DATA(12, GLint, SWAP32(t[2]));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD3IARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord3sARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLshort s, GLshort t, GLshort r)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.s3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLshort, s);
	WRITE_DATA(6, GLshort, t);
	WRITE_DATA(8, GLshort, r);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD3SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3sARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLshort s, GLshort t, GLshort r)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.s3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLshort, SWAP16(s));
	WRITE_DATA(6, GLshort, SWAP16(t));
	WRITE_DATA(8, GLshort, SWAP16(r));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD3SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord3svARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLshort * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord3svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.s3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLshort, t[0]);
	WRITE_DATA(6, GLshort, t[1]);
	WRITE_DATA(8, GLshort, t[2]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD3SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3svARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLshort * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord3svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.s3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLshort, SWAP16(t[0]));
	WRITE_DATA(6, GLshort, SWAP16(t[1]));
	WRITE_DATA(8, GLshort, SWAP16(t[2]));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD3SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord4dARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLdouble s, GLdouble t, GLdouble r, GLdouble q)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	pc->current.c.texCoord.d4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DOUBLE(4, s);
	WRITE_DOUBLE(12, t);
	WRITE_DOUBLE(20, r);
	WRITE_DOUBLE(28, q);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD4DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4dARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLdouble s, GLdouble t, GLdouble r, GLdouble q)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	pc->current.c.texCoord.d4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_SWAPPED_DOUBLE(4, s);
	WRITE_SWAPPED_DOUBLE(12, t);
	WRITE_SWAPPED_DOUBLE(20, r);
	WRITE_SWAPPED_DOUBLE(28, q);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD4DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord4dvARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLdouble * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord4dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 36);
	pc->current.c.texCoord.d4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DOUBLE(4, t[0]);
	WRITE_DOUBLE(12, t[1]);
	WRITE_DOUBLE(20, t[2]);
	WRITE_DOUBLE(28, t[3]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD4DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4dvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLdouble * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord4dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 36);
	pc->current.c.texCoord.d4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_SWAPPED_DOUBLE(4, t[0]);
	WRITE_SWAPPED_DOUBLE(12, t[1]);
	WRITE_SWAPPED_DOUBLE(20, t[2]);
	WRITE_SWAPPED_DOUBLE(28, t[3]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD4DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord4fARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLfloat s, GLfloat t, GLfloat r, GLfloat q)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.texCoord.f4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLfloat, s);
	WRITE_DATA(8, GLfloat, t);
	WRITE_DATA(12, GLfloat, r);
	WRITE_DATA(16, GLfloat, q);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD4FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4fARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLfloat s, GLfloat t, GLfloat r, GLfloat q)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.texCoord.f4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLuint, SWAPFLOAT(s));
	WRITE_DATA(8, GLuint, SWAPFLOAT(t));
	WRITE_DATA(12, GLuint, SWAPFLOAT(r));
	WRITE_DATA(16, GLuint, SWAPFLOAT(q));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD4FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord4fvARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLfloat * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord4fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.texCoord.f4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLfloat, t[0]);
	WRITE_DATA(8, GLfloat, t[1]);
	WRITE_DATA(12, GLfloat, t[2]);
	WRITE_DATA(16, GLfloat, t[3]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD4FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4fvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLfloat * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord4fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.texCoord.f4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLuint, SWAPFLOAT(t[0]));
	WRITE_DATA(8, GLuint, SWAPFLOAT(t[1]));
	WRITE_DATA(12, GLuint, SWAPFLOAT(t[2]));
	WRITE_DATA(16, GLuint, SWAPFLOAT(t[3]));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD4FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord4iARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLint s, GLint t, GLint r, GLint q)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.texCoord.i4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLint, s);
	WRITE_DATA(8, GLint, t);
	WRITE_DATA(12, GLint, r);
	WRITE_DATA(16, GLint, q);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD4IARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4iARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLint s, GLint t, GLint r, GLint q)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.texCoord.i4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLint, SWAP32(s));
	WRITE_DATA(8, GLint, SWAP32(t));
	WRITE_DATA(12, GLint, SWAP32(r));
	WRITE_DATA(16, GLint, SWAP32(q));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD4IARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord4ivARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLint * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord4ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.texCoord.i4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLint, t[0]);
	WRITE_DATA(8, GLint, t[1]);
	WRITE_DATA(12, GLint, t[2]);
	WRITE_DATA(16, GLint, t[3]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD4IARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4ivARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLint * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord4ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.texCoord.i4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLint, SWAP32(t[0]));
	WRITE_DATA(8, GLint, SWAP32(t[1]));
	WRITE_DATA(12, GLint, SWAP32(t[2]));
	WRITE_DATA(16, GLint, SWAP32(t[3]));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD4IARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord4sARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLshort s, GLshort t, GLshort r, GLshort q)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.s4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLshort, s);
	WRITE_DATA(6, GLshort, t);
	WRITE_DATA(8, GLshort, r);
	WRITE_DATA(10, GLshort, q);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD4SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4sARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, GLshort s, GLshort t, GLshort r, GLshort q)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.s4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLshort, SWAP16(s));
	WRITE_DATA(6, GLshort, SWAP16(t));
	WRITE_DATA(8, GLshort, SWAP16(r));
	WRITE_DATA(10, GLshort, SWAP16(q));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD4SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackMultiTexCoord4svARB(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLshort * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord4svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.s4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, texture);
	WRITE_DATA(4, GLshort, t[0]);
	WRITE_DATA(6, GLshort, t[1]);
	WRITE_DATA(8, GLshort, t[2]);
	WRITE_DATA(10, GLshort, t[3]);
	WRITE_OPCODE(pc, CR_MULTITEXCOORD4SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4svARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum texture, const GLshort * t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord4svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.s4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA(0, GLenum, SWAP32(texture));
	WRITE_DATA(4, GLshort, SWAP16(t[0]));
	WRITE_DATA(6, GLshort, SWAP16(t[1]));
	WRITE_DATA(8, GLshort, SWAP16(t[2]));
	WRITE_DATA(10, GLshort, SWAP16(t[3]));
	WRITE_OPCODE(pc, CR_MULTITEXCOORD4SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackNormal3b(CR_PACKER_CONTEXT_ARGDECL GLbyte nx, GLbyte ny, GLbyte nz)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.normal.b3 = data_ptr;
	WRITE_DATA(0, GLbyte, nx);
	WRITE_DATA(1, GLbyte, ny);
	WRITE_DATA(2, GLbyte, nz);
	WRITE_OPCODE(pc, CR_NORMAL3B_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3bSWAP(CR_PACKER_CONTEXT_ARGDECL GLbyte nx, GLbyte ny, GLbyte nz)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.normal.b3 = data_ptr;
	WRITE_DATA(0, GLbyte, nx);
	WRITE_DATA(1, GLbyte, ny);
	WRITE_DATA(2, GLbyte, nz);
	WRITE_OPCODE(pc, CR_NORMAL3B_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackNormal3bv(CR_PACKER_CONTEXT_ARGDECL const GLbyte * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3bv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.normal.b3 = data_ptr;
	WRITE_DATA(0, GLbyte, v[0]);
	WRITE_DATA(1, GLbyte, v[1]);
	WRITE_DATA(2, GLbyte, v[2]);
	WRITE_OPCODE(pc, CR_NORMAL3B_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3bvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLbyte * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3bv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.normal.b3 = data_ptr;
	WRITE_DATA(0, GLbyte, v[0]);
	WRITE_DATA(1, GLbyte, v[1]);
	WRITE_DATA(2, GLbyte, v[2]);
	WRITE_OPCODE(pc, CR_NORMAL3B_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackNormal3d(CR_PACKER_CONTEXT_ARGDECL GLdouble nx, GLdouble ny, GLdouble nz)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	pc->current.c.normal.d3 = data_ptr;
	WRITE_DOUBLE(0, nx);
	WRITE_DOUBLE(8, ny);
	WRITE_DOUBLE(16, nz);
	WRITE_OPCODE(pc, CR_NORMAL3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3dSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble nx, GLdouble ny, GLdouble nz)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	pc->current.c.normal.d3 = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, nx);
	WRITE_SWAPPED_DOUBLE(8, ny);
	WRITE_SWAPPED_DOUBLE(16, nz);
	WRITE_OPCODE(pc, CR_NORMAL3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackNormal3dv(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 24);
	pc->current.c.normal.d3 = data_ptr;
	WRITE_DOUBLE(0, v[0]);
	WRITE_DOUBLE(8, v[1]);
	WRITE_DOUBLE(16, v[2]);
	WRITE_OPCODE(pc, CR_NORMAL3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3dvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 24);
	pc->current.c.normal.d3 = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, v[0]);
	WRITE_SWAPPED_DOUBLE(8, v[1]);
	WRITE_SWAPPED_DOUBLE(16, v[2]);
	WRITE_OPCODE(pc, CR_NORMAL3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackNormal3f(CR_PACKER_CONTEXT_ARGDECL GLfloat nx, GLfloat ny, GLfloat nz)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.normal.f3 = data_ptr;
	WRITE_DATA(0, GLfloat, nx);
	WRITE_DATA(4, GLfloat, ny);
	WRITE_DATA(8, GLfloat, nz);
	WRITE_OPCODE(pc, CR_NORMAL3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3fSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat nx, GLfloat ny, GLfloat nz)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.normal.f3 = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(nx));
	WRITE_DATA(4, GLuint, SWAPFLOAT(ny));
	WRITE_DATA(8, GLuint, SWAPFLOAT(nz));
	WRITE_OPCODE(pc, CR_NORMAL3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackNormal3fv(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.normal.f3 = data_ptr;
	WRITE_DATA(0, GLfloat, v[0]);
	WRITE_DATA(4, GLfloat, v[1]);
	WRITE_DATA(8, GLfloat, v[2]);
	WRITE_OPCODE(pc, CR_NORMAL3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3fvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.normal.f3 = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(v[0]));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v[1]));
	WRITE_DATA(8, GLuint, SWAPFLOAT(v[2]));
	WRITE_OPCODE(pc, CR_NORMAL3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackNormal3i(CR_PACKER_CONTEXT_ARGDECL GLint nx, GLint ny, GLint nz)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.normal.i3 = data_ptr;
	WRITE_DATA(0, GLint, nx);
	WRITE_DATA(4, GLint, ny);
	WRITE_DATA(8, GLint, nz);
	WRITE_OPCODE(pc, CR_NORMAL3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3iSWAP(CR_PACKER_CONTEXT_ARGDECL GLint nx, GLint ny, GLint nz)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.normal.i3 = data_ptr;
	WRITE_DATA(0, GLint, SWAP32(nx));
	WRITE_DATA(4, GLint, SWAP32(ny));
	WRITE_DATA(8, GLint, SWAP32(nz));
	WRITE_OPCODE(pc, CR_NORMAL3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackNormal3iv(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.normal.i3 = data_ptr;
	WRITE_DATA(0, GLint, v[0]);
	WRITE_DATA(4, GLint, v[1]);
	WRITE_DATA(8, GLint, v[2]);
	WRITE_OPCODE(pc, CR_NORMAL3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3ivSWAP(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.normal.i3 = data_ptr;
	WRITE_DATA(0, GLint, SWAP32(v[0]));
	WRITE_DATA(4, GLint, SWAP32(v[1]));
	WRITE_DATA(8, GLint, SWAP32(v[2]));
	WRITE_OPCODE(pc, CR_NORMAL3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackNormal3s(CR_PACKER_CONTEXT_ARGDECL GLshort nx, GLshort ny, GLshort nz)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.normal.s3 = data_ptr;
	WRITE_DATA(0, GLshort, nx);
	WRITE_DATA(2, GLshort, ny);
	WRITE_DATA(4, GLshort, nz);
	WRITE_OPCODE(pc, CR_NORMAL3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3sSWAP(CR_PACKER_CONTEXT_ARGDECL GLshort nx, GLshort ny, GLshort nz)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.normal.s3 = data_ptr;
	WRITE_DATA(0, GLshort, SWAP16(nx));
	WRITE_DATA(2, GLshort, SWAP16(ny));
	WRITE_DATA(4, GLshort, SWAP16(nz));
	WRITE_OPCODE(pc, CR_NORMAL3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackNormal3sv(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.normal.s3 = data_ptr;
	WRITE_DATA(0, GLshort, v[0]);
	WRITE_DATA(2, GLshort, v[1]);
	WRITE_DATA(4, GLshort, v[2]);
	WRITE_OPCODE(pc, CR_NORMAL3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3svSWAP(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.normal.s3 = data_ptr;
	WRITE_DATA(0, GLshort, SWAP16(v[0]));
	WRITE_DATA(2, GLshort, SWAP16(v[1]));
	WRITE_DATA(4, GLshort, SWAP16(v[2]));
	WRITE_OPCODE(pc, CR_NORMAL3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackOrtho(CR_PACKER_CONTEXT_ARGDECL GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 48);
	WRITE_DOUBLE(0, left);
	WRITE_DOUBLE(8, right);
	WRITE_DOUBLE(16, bottom);
	WRITE_DOUBLE(24, top);
	WRITE_DOUBLE(32, zNear);
	WRITE_DOUBLE(40, zFar);
	WRITE_OPCODE(pc, CR_ORTHO_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackOrthoSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 48);
	WRITE_SWAPPED_DOUBLE(0, left);
	WRITE_SWAPPED_DOUBLE(8, right);
	WRITE_SWAPPED_DOUBLE(16, bottom);
	WRITE_SWAPPED_DOUBLE(24, top);
	WRITE_SWAPPED_DOUBLE(32, zNear);
	WRITE_SWAPPED_DOUBLE(40, zFar);
	WRITE_OPCODE(pc, CR_ORTHO_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPassThrough(CR_PACKER_CONTEXT_ARGDECL GLfloat token)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLfloat, token);
	WRITE_OPCODE(pc, CR_PASSTHROUGH_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPassThroughSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat token)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLuint, SWAPFLOAT(token));
	WRITE_OPCODE(pc, CR_PASSTHROUGH_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPixelStoref(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLfloat param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, pname);
	WRITE_DATA(4, GLfloat, param);
	WRITE_OPCODE(pc, CR_PIXELSTOREF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPixelStorefSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLfloat param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, SWAP32(pname));
	WRITE_DATA(4, GLuint, SWAPFLOAT(param));
	WRITE_OPCODE(pc, CR_PIXELSTOREF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPixelStorei(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLint param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, pname);
	WRITE_DATA(4, GLint, param);
	WRITE_OPCODE(pc, CR_PIXELSTOREI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPixelStoreiSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLint param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, SWAP32(pname));
	WRITE_DATA(4, GLint, SWAP32(param));
	WRITE_OPCODE(pc, CR_PIXELSTOREI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPixelTransferf(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLfloat param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, pname);
	WRITE_DATA(4, GLfloat, param);
	WRITE_OPCODE(pc, CR_PIXELTRANSFERF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPixelTransferfSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLfloat param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, SWAP32(pname));
	WRITE_DATA(4, GLuint, SWAPFLOAT(param));
	WRITE_OPCODE(pc, CR_PIXELTRANSFERF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPixelTransferi(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLint param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, pname);
	WRITE_DATA(4, GLint, param);
	WRITE_OPCODE(pc, CR_PIXELTRANSFERI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPixelTransferiSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLint param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, SWAP32(pname));
	WRITE_DATA(4, GLint, SWAP32(param));
	WRITE_OPCODE(pc, CR_PIXELTRANSFERI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPixelZoom(CR_PACKER_CONTEXT_ARGDECL GLfloat xfactor, GLfloat yfactor)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLfloat, xfactor);
	WRITE_DATA(4, GLfloat, yfactor);
	WRITE_OPCODE(pc, CR_PIXELZOOM_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPixelZoomSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat xfactor, GLfloat yfactor)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLuint, SWAPFLOAT(xfactor));
	WRITE_DATA(4, GLuint, SWAPFLOAT(yfactor));
	WRITE_OPCODE(pc, CR_PIXELZOOM_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPointParameterfARB(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLfloat param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_POINTPARAMETERFARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, pname);
	WRITE_DATA(12, GLfloat, param);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPointParameterfARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLfloat param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_POINTPARAMETERFARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(pname));
	WRITE_DATA(12, GLuint, SWAPFLOAT(param));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPointParameteri(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLint param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_POINTPARAMETERI_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, pname);
	WRITE_DATA(12, GLint, param);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPointParameteriSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum pname, GLint param)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_POINTPARAMETERI_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(pname));
	WRITE_DATA(12, GLint, SWAP32(param));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPointSize(CR_PACKER_CONTEXT_ARGDECL GLfloat size)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLfloat, size);
	WRITE_OPCODE(pc, CR_POINTSIZE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPointSizeSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat size)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLuint, SWAPFLOAT(size));
	WRITE_OPCODE(pc, CR_POINTSIZE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPolygonMode(CR_PACKER_CONTEXT_ARGDECL GLenum face, GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, face);
	WRITE_DATA(4, GLenum, mode);
	WRITE_OPCODE(pc, CR_POLYGONMODE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPolygonModeSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum face, GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLenum, SWAP32(face));
	WRITE_DATA(4, GLenum, SWAP32(mode));
	WRITE_OPCODE(pc, CR_POLYGONMODE_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPolygonOffset(CR_PACKER_CONTEXT_ARGDECL GLfloat factor, GLfloat units)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLfloat, factor);
	WRITE_DATA(4, GLfloat, units);
	WRITE_OPCODE(pc, CR_POLYGONOFFSET_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPolygonOffsetSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat factor, GLfloat units)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLuint, SWAPFLOAT(factor));
	WRITE_DATA(4, GLuint, SWAPFLOAT(units));
	WRITE_OPCODE(pc, CR_POLYGONOFFSET_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPopAttrib(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, 8);
	WRITE_DATA(4, GLenum, CR_POPATTRIB_EXTEND_OPCODE);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPopAttribSWAP(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, SWAP32(8));
	WRITE_DATA(4, GLenum, SWAP32(CR_POPATTRIB_EXTEND_OPCODE));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPopClientAttrib(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, 8);
	WRITE_DATA(4, GLenum, CR_POPCLIENTATTRIB_EXTEND_OPCODE);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPopClientAttribSWAP(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, SWAP32(8));
	WRITE_DATA(4, GLenum, SWAP32(CR_POPCLIENTATTRIB_EXTEND_OPCODE));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPopMatrix(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS(pc);
	WRITE_OPCODE(pc, CR_POPMATRIX_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPopMatrixSWAP(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS(pc);
	WRITE_OPCODE(pc, CR_POPMATRIX_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPopName(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS(pc);
	WRITE_OPCODE(pc, CR_POPNAME_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPopNameSWAP(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS(pc);
	WRITE_OPCODE(pc, CR_POPNAME_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackProgramEnvParameter4dARB(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 48);
	WRITE_DATA(0, GLint, 48);
	WRITE_DATA(4, GLenum, CR_PROGRAMENVPARAMETER4DARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_DOUBLE(16, x);
	WRITE_DOUBLE(24, y);
	WRITE_DOUBLE(32, z);
	WRITE_DOUBLE(40, w);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramEnvParameter4dARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 48);
	WRITE_DATA(0, GLint, SWAP32(48));
	WRITE_DATA(4, GLenum, SWAP32(CR_PROGRAMENVPARAMETER4DARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_SWAPPED_DOUBLE(16, x);
	WRITE_SWAPPED_DOUBLE(24, y);
	WRITE_SWAPPED_DOUBLE(32, z);
	WRITE_SWAPPED_DOUBLE(40, w);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackProgramEnvParameter4dvARB(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, const GLdouble * params)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramEnvParameter4dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 48);
	WRITE_DATA(0, GLint, 48);
	WRITE_DATA(4, GLenum, CR_PROGRAMENVPARAMETER4DARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_DOUBLE(16, params[0]);
	WRITE_DOUBLE(24, params[1]);
	WRITE_DOUBLE(32, params[2]);
	WRITE_DOUBLE(40, params[3]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramEnvParameter4dvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, const GLdouble * params)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramEnvParameter4dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 48);
	WRITE_DATA(0, GLint, SWAP32(48));
	WRITE_DATA(4, GLenum, SWAP32(CR_PROGRAMENVPARAMETER4DARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_SWAPPED_DOUBLE(16, params[0]);
	WRITE_SWAPPED_DOUBLE(24, params[1]);
	WRITE_SWAPPED_DOUBLE(32, params[2]);
	WRITE_SWAPPED_DOUBLE(40, params[3]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackProgramEnvParameter4fARB(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_PROGRAMENVPARAMETER4FARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_DATA(16, GLfloat, x);
	WRITE_DATA(20, GLfloat, y);
	WRITE_DATA(24, GLfloat, z);
	WRITE_DATA(28, GLfloat, w);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramEnvParameter4fARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_PROGRAMENVPARAMETER4FARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_DATA(16, GLuint, SWAPFLOAT(x));
	WRITE_DATA(20, GLuint, SWAPFLOAT(y));
	WRITE_DATA(24, GLuint, SWAPFLOAT(z));
	WRITE_DATA(28, GLuint, SWAPFLOAT(w));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackProgramEnvParameter4fvARB(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, const GLfloat * params)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramEnvParameter4fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_PROGRAMENVPARAMETER4FARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_DATA(16, GLfloat, params[0]);
	WRITE_DATA(20, GLfloat, params[1]);
	WRITE_DATA(24, GLfloat, params[2]);
	WRITE_DATA(28, GLfloat, params[3]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramEnvParameter4fvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, const GLfloat * params)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramEnvParameter4fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_PROGRAMENVPARAMETER4FARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_DATA(16, GLuint, SWAPFLOAT(params[0]));
	WRITE_DATA(20, GLuint, SWAPFLOAT(params[1]));
	WRITE_DATA(24, GLuint, SWAPFLOAT(params[2]));
	WRITE_DATA(28, GLuint, SWAPFLOAT(params[3]));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackProgramLocalParameter4dARB(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 48);
	WRITE_DATA(0, GLint, 48);
	WRITE_DATA(4, GLenum, CR_PROGRAMLOCALPARAMETER4DARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_DOUBLE(16, x);
	WRITE_DOUBLE(24, y);
	WRITE_DOUBLE(32, z);
	WRITE_DOUBLE(40, w);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramLocalParameter4dARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 48);
	WRITE_DATA(0, GLint, SWAP32(48));
	WRITE_DATA(4, GLenum, SWAP32(CR_PROGRAMLOCALPARAMETER4DARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_SWAPPED_DOUBLE(16, x);
	WRITE_SWAPPED_DOUBLE(24, y);
	WRITE_SWAPPED_DOUBLE(32, z);
	WRITE_SWAPPED_DOUBLE(40, w);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackProgramLocalParameter4dvARB(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, const GLdouble * params)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramLocalParameter4dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 48);
	WRITE_DATA(0, GLint, 48);
	WRITE_DATA(4, GLenum, CR_PROGRAMLOCALPARAMETER4DARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_DOUBLE(16, params[0]);
	WRITE_DOUBLE(24, params[1]);
	WRITE_DOUBLE(32, params[2]);
	WRITE_DOUBLE(40, params[3]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramLocalParameter4dvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, const GLdouble * params)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramLocalParameter4dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 48);
	WRITE_DATA(0, GLint, SWAP32(48));
	WRITE_DATA(4, GLenum, SWAP32(CR_PROGRAMLOCALPARAMETER4DARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_SWAPPED_DOUBLE(16, params[0]);
	WRITE_SWAPPED_DOUBLE(24, params[1]);
	WRITE_SWAPPED_DOUBLE(32, params[2]);
	WRITE_SWAPPED_DOUBLE(40, params[3]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackProgramLocalParameter4fARB(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_PROGRAMLOCALPARAMETER4FARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_DATA(16, GLfloat, x);
	WRITE_DATA(20, GLfloat, y);
	WRITE_DATA(24, GLfloat, z);
	WRITE_DATA(28, GLfloat, w);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramLocalParameter4fARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_PROGRAMLOCALPARAMETER4FARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_DATA(16, GLuint, SWAPFLOAT(x));
	WRITE_DATA(20, GLuint, SWAPFLOAT(y));
	WRITE_DATA(24, GLuint, SWAPFLOAT(z));
	WRITE_DATA(28, GLuint, SWAPFLOAT(w));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackProgramLocalParameter4fvARB(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, const GLfloat * params)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramLocalParameter4fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_PROGRAMLOCALPARAMETER4FARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_DATA(16, GLfloat, params[0]);
	WRITE_DATA(20, GLfloat, params[1]);
	WRITE_DATA(24, GLfloat, params[2]);
	WRITE_DATA(28, GLfloat, params[3]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramLocalParameter4fvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, const GLfloat * params)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramLocalParameter4fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_PROGRAMLOCALPARAMETER4FARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_DATA(16, GLuint, SWAPFLOAT(params[0]));
	WRITE_DATA(20, GLuint, SWAPFLOAT(params[1]));
	WRITE_DATA(24, GLuint, SWAPFLOAT(params[2]));
	WRITE_DATA(28, GLuint, SWAPFLOAT(params[3]));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackProgramParameter4dNV(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 48);
	WRITE_DATA(0, GLint, 48);
	WRITE_DATA(4, GLenum, CR_PROGRAMPARAMETER4DNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_DOUBLE(16, x);
	WRITE_DOUBLE(24, y);
	WRITE_DOUBLE(32, z);
	WRITE_DOUBLE(40, w);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramParameter4dNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 48);
	WRITE_DATA(0, GLint, SWAP32(48));
	WRITE_DATA(4, GLenum, SWAP32(CR_PROGRAMPARAMETER4DNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_SWAPPED_DOUBLE(16, x);
	WRITE_SWAPPED_DOUBLE(24, y);
	WRITE_SWAPPED_DOUBLE(32, z);
	WRITE_SWAPPED_DOUBLE(40, w);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackProgramParameter4dvNV(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, const GLdouble * params)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramParameter4dvNV");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 48);
	WRITE_DATA(0, GLint, 48);
	WRITE_DATA(4, GLenum, CR_PROGRAMPARAMETER4DNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_DOUBLE(16, params[0]);
	WRITE_DOUBLE(24, params[1]);
	WRITE_DOUBLE(32, params[2]);
	WRITE_DOUBLE(40, params[3]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramParameter4dvNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, const GLdouble * params)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramParameter4dvNV");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 48);
	WRITE_DATA(0, GLint, SWAP32(48));
	WRITE_DATA(4, GLenum, SWAP32(CR_PROGRAMPARAMETER4DNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_SWAPPED_DOUBLE(16, params[0]);
	WRITE_SWAPPED_DOUBLE(24, params[1]);
	WRITE_SWAPPED_DOUBLE(32, params[2]);
	WRITE_SWAPPED_DOUBLE(40, params[3]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackProgramParameter4fNV(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_PROGRAMPARAMETER4FNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_DATA(16, GLfloat, x);
	WRITE_DATA(20, GLfloat, y);
	WRITE_DATA(24, GLfloat, z);
	WRITE_DATA(28, GLfloat, w);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramParameter4fNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_PROGRAMPARAMETER4FNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_DATA(16, GLuint, SWAPFLOAT(x));
	WRITE_DATA(20, GLuint, SWAPFLOAT(y));
	WRITE_DATA(24, GLuint, SWAPFLOAT(z));
	WRITE_DATA(28, GLuint, SWAPFLOAT(w));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackProgramParameter4fvNV(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, const GLfloat * params)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramParameter4fvNV");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_PROGRAMPARAMETER4FNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, index);
	WRITE_DATA(16, GLfloat, params[0]);
	WRITE_DATA(20, GLfloat, params[1]);
	WRITE_DATA(24, GLfloat, params[2]);
	WRITE_DATA(28, GLfloat, params[3]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramParameter4fvNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint index, const GLfloat * params)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramParameter4fvNV");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_PROGRAMPARAMETER4FNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(index));
	WRITE_DATA(16, GLuint, SWAPFLOAT(params[0]));
	WRITE_DATA(20, GLuint, SWAPFLOAT(params[1]));
	WRITE_DATA(24, GLuint, SWAPFLOAT(params[2]));
	WRITE_DATA(28, GLuint, SWAPFLOAT(params[3]));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPushAttrib(CR_PACKER_CONTEXT_ARGDECL GLbitfield mask)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_PUSHATTRIB_EXTEND_OPCODE);
	WRITE_DATA(8, GLbitfield, mask);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPushAttribSWAP(CR_PACKER_CONTEXT_ARGDECL GLbitfield mask)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_PUSHATTRIB_EXTEND_OPCODE));
	WRITE_DATA(8, GLbitfield, SWAP32(mask));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPushClientAttrib(CR_PACKER_CONTEXT_ARGDECL GLbitfield mask)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_PUSHCLIENTATTRIB_EXTEND_OPCODE);
	WRITE_DATA(8, GLbitfield, mask);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPushClientAttribSWAP(CR_PACKER_CONTEXT_ARGDECL GLbitfield mask)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_PUSHCLIENTATTRIB_EXTEND_OPCODE));
	WRITE_DATA(8, GLbitfield, SWAP32(mask));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPushMatrix(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS(pc);
	WRITE_OPCODE(pc, CR_PUSHMATRIX_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPushMatrixSWAP(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS(pc);
	WRITE_OPCODE(pc, CR_PUSHMATRIX_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackPushName(CR_PACKER_CONTEXT_ARGDECL GLuint name)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLuint, name);
	WRITE_OPCODE(pc, CR_PUSHNAME_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPushNameSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint name)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLuint, SWAP32(name));
	WRITE_OPCODE(pc, CR_PUSHNAME_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos2d(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DOUBLE(0, x);
	WRITE_DOUBLE(8, y);
	WRITE_OPCODE(pc, CR_RASTERPOS2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2dSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_SWAPPED_DOUBLE(0, x);
	WRITE_SWAPPED_DOUBLE(8, y);
	WRITE_OPCODE(pc, CR_RASTERPOS2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos2dv(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos2dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DOUBLE(0, v[0]);
	WRITE_DOUBLE(8, v[1]);
	WRITE_OPCODE(pc, CR_RASTERPOS2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2dvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos2dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_SWAPPED_DOUBLE(0, v[0]);
	WRITE_SWAPPED_DOUBLE(8, v[1]);
	WRITE_OPCODE(pc, CR_RASTERPOS2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos2f(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLfloat, x);
	WRITE_DATA(4, GLfloat, y);
	WRITE_OPCODE(pc, CR_RASTERPOS2F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2fSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLuint, SWAPFLOAT(x));
	WRITE_DATA(4, GLuint, SWAPFLOAT(y));
	WRITE_OPCODE(pc, CR_RASTERPOS2F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos2fv(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos2fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLfloat, v[0]);
	WRITE_DATA(4, GLfloat, v[1]);
	WRITE_OPCODE(pc, CR_RASTERPOS2F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2fvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos2fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLuint, SWAPFLOAT(v[0]));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v[1]));
	WRITE_OPCODE(pc, CR_RASTERPOS2F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos2i(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, x);
	WRITE_DATA(4, GLint, y);
	WRITE_OPCODE(pc, CR_RASTERPOS2I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2iSWAP(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, SWAP32(x));
	WRITE_DATA(4, GLint, SWAP32(y));
	WRITE_OPCODE(pc, CR_RASTERPOS2I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos2iv(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos2iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, v[0]);
	WRITE_DATA(4, GLint, v[1]);
	WRITE_OPCODE(pc, CR_RASTERPOS2I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2ivSWAP(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos2iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, SWAP32(v[0]));
	WRITE_DATA(4, GLint, SWAP32(v[1]));
	WRITE_OPCODE(pc, CR_RASTERPOS2I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos2s(CR_PACKER_CONTEXT_ARGDECL GLshort x, GLshort y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLshort, x);
	WRITE_DATA(2, GLshort, y);
	WRITE_OPCODE(pc, CR_RASTERPOS2S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2sSWAP(CR_PACKER_CONTEXT_ARGDECL GLshort x, GLshort y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLshort, SWAP16(x));
	WRITE_DATA(2, GLshort, SWAP16(y));
	WRITE_OPCODE(pc, CR_RASTERPOS2S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos2sv(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos2sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLshort, v[0]);
	WRITE_DATA(2, GLshort, v[1]);
	WRITE_OPCODE(pc, CR_RASTERPOS2S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2svSWAP(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos2sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLshort, SWAP16(v[0]));
	WRITE_DATA(2, GLshort, SWAP16(v[1]));
	WRITE_OPCODE(pc, CR_RASTERPOS2S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos3d(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y, GLdouble z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DOUBLE(0, x);
	WRITE_DOUBLE(8, y);
	WRITE_DOUBLE(16, z);
	WRITE_OPCODE(pc, CR_RASTERPOS3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3dSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y, GLdouble z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_SWAPPED_DOUBLE(0, x);
	WRITE_SWAPPED_DOUBLE(8, y);
	WRITE_SWAPPED_DOUBLE(16, z);
	WRITE_OPCODE(pc, CR_RASTERPOS3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos3dv(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DOUBLE(0, v[0]);
	WRITE_DOUBLE(8, v[1]);
	WRITE_DOUBLE(16, v[2]);
	WRITE_OPCODE(pc, CR_RASTERPOS3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3dvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_SWAPPED_DOUBLE(0, v[0]);
	WRITE_SWAPPED_DOUBLE(8, v[1]);
	WRITE_SWAPPED_DOUBLE(16, v[2]);
	WRITE_OPCODE(pc, CR_RASTERPOS3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos3f(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y, GLfloat z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLfloat, x);
	WRITE_DATA(4, GLfloat, y);
	WRITE_DATA(8, GLfloat, z);
	WRITE_OPCODE(pc, CR_RASTERPOS3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3fSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y, GLfloat z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLuint, SWAPFLOAT(x));
	WRITE_DATA(4, GLuint, SWAPFLOAT(y));
	WRITE_DATA(8, GLuint, SWAPFLOAT(z));
	WRITE_OPCODE(pc, CR_RASTERPOS3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos3fv(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLfloat, v[0]);
	WRITE_DATA(4, GLfloat, v[1]);
	WRITE_DATA(8, GLfloat, v[2]);
	WRITE_OPCODE(pc, CR_RASTERPOS3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3fvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLuint, SWAPFLOAT(v[0]));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v[1]));
	WRITE_DATA(8, GLuint, SWAPFLOAT(v[2]));
	WRITE_OPCODE(pc, CR_RASTERPOS3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos3i(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y, GLint z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, x);
	WRITE_DATA(4, GLint, y);
	WRITE_DATA(8, GLint, z);
	WRITE_OPCODE(pc, CR_RASTERPOS3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3iSWAP(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y, GLint z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(x));
	WRITE_DATA(4, GLint, SWAP32(y));
	WRITE_DATA(8, GLint, SWAP32(z));
	WRITE_OPCODE(pc, CR_RASTERPOS3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos3iv(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, v[0]);
	WRITE_DATA(4, GLint, v[1]);
	WRITE_DATA(8, GLint, v[2]);
	WRITE_OPCODE(pc, CR_RASTERPOS3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3ivSWAP(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(v[0]));
	WRITE_DATA(4, GLint, SWAP32(v[1]));
	WRITE_DATA(8, GLint, SWAP32(v[2]));
	WRITE_OPCODE(pc, CR_RASTERPOS3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos3s(CR_PACKER_CONTEXT_ARGDECL GLshort x, GLshort y, GLshort z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, x);
	WRITE_DATA(2, GLshort, y);
	WRITE_DATA(4, GLshort, z);
	WRITE_OPCODE(pc, CR_RASTERPOS3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3sSWAP(CR_PACKER_CONTEXT_ARGDECL GLshort x, GLshort y, GLshort z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, SWAP16(x));
	WRITE_DATA(2, GLshort, SWAP16(y));
	WRITE_DATA(4, GLshort, SWAP16(z));
	WRITE_OPCODE(pc, CR_RASTERPOS3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos3sv(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, v[0]);
	WRITE_DATA(2, GLshort, v[1]);
	WRITE_DATA(4, GLshort, v[2]);
	WRITE_OPCODE(pc, CR_RASTERPOS3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3svSWAP(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, SWAP16(v[0]));
	WRITE_DATA(2, GLshort, SWAP16(v[1]));
	WRITE_DATA(4, GLshort, SWAP16(v[2]));
	WRITE_OPCODE(pc, CR_RASTERPOS3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos4d(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DOUBLE(0, x);
	WRITE_DOUBLE(8, y);
	WRITE_DOUBLE(16, z);
	WRITE_DOUBLE(24, w);
	WRITE_OPCODE(pc, CR_RASTERPOS4D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4dSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_SWAPPED_DOUBLE(0, x);
	WRITE_SWAPPED_DOUBLE(8, y);
	WRITE_SWAPPED_DOUBLE(16, z);
	WRITE_SWAPPED_DOUBLE(24, w);
	WRITE_OPCODE(pc, CR_RASTERPOS4D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos4dv(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos4dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DOUBLE(0, v[0]);
	WRITE_DOUBLE(8, v[1]);
	WRITE_DOUBLE(16, v[2]);
	WRITE_DOUBLE(24, v[3]);
	WRITE_OPCODE(pc, CR_RASTERPOS4D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4dvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos4dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_SWAPPED_DOUBLE(0, v[0]);
	WRITE_SWAPPED_DOUBLE(8, v[1]);
	WRITE_SWAPPED_DOUBLE(16, v[2]);
	WRITE_SWAPPED_DOUBLE(24, v[3]);
	WRITE_OPCODE(pc, CR_RASTERPOS4D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos4f(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLfloat, x);
	WRITE_DATA(4, GLfloat, y);
	WRITE_DATA(8, GLfloat, z);
	WRITE_DATA(12, GLfloat, w);
	WRITE_OPCODE(pc, CR_RASTERPOS4F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4fSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLuint, SWAPFLOAT(x));
	WRITE_DATA(4, GLuint, SWAPFLOAT(y));
	WRITE_DATA(8, GLuint, SWAPFLOAT(z));
	WRITE_DATA(12, GLuint, SWAPFLOAT(w));
	WRITE_OPCODE(pc, CR_RASTERPOS4F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos4fv(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos4fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLfloat, v[0]);
	WRITE_DATA(4, GLfloat, v[1]);
	WRITE_DATA(8, GLfloat, v[2]);
	WRITE_DATA(12, GLfloat, v[3]);
	WRITE_OPCODE(pc, CR_RASTERPOS4F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4fvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos4fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLuint, SWAPFLOAT(v[0]));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v[1]));
	WRITE_DATA(8, GLuint, SWAPFLOAT(v[2]));
	WRITE_DATA(12, GLuint, SWAPFLOAT(v[3]));
	WRITE_OPCODE(pc, CR_RASTERPOS4F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos4i(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y, GLint z, GLint w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, x);
	WRITE_DATA(4, GLint, y);
	WRITE_DATA(8, GLint, z);
	WRITE_DATA(12, GLint, w);
	WRITE_OPCODE(pc, CR_RASTERPOS4I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4iSWAP(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y, GLint z, GLint w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(x));
	WRITE_DATA(4, GLint, SWAP32(y));
	WRITE_DATA(8, GLint, SWAP32(z));
	WRITE_DATA(12, GLint, SWAP32(w));
	WRITE_OPCODE(pc, CR_RASTERPOS4I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos4iv(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos4iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, v[0]);
	WRITE_DATA(4, GLint, v[1]);
	WRITE_DATA(8, GLint, v[2]);
	WRITE_DATA(12, GLint, v[3]);
	WRITE_OPCODE(pc, CR_RASTERPOS4I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4ivSWAP(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos4iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(v[0]));
	WRITE_DATA(4, GLint, SWAP32(v[1]));
	WRITE_DATA(8, GLint, SWAP32(v[2]));
	WRITE_DATA(12, GLint, SWAP32(v[3]));
	WRITE_OPCODE(pc, CR_RASTERPOS4I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos4s(CR_PACKER_CONTEXT_ARGDECL GLshort x, GLshort y, GLshort z, GLshort w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, x);
	WRITE_DATA(2, GLshort, y);
	WRITE_DATA(4, GLshort, z);
	WRITE_DATA(6, GLshort, w);
	WRITE_OPCODE(pc, CR_RASTERPOS4S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4sSWAP(CR_PACKER_CONTEXT_ARGDECL GLshort x, GLshort y, GLshort z, GLshort w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, SWAP16(x));
	WRITE_DATA(2, GLshort, SWAP16(y));
	WRITE_DATA(4, GLshort, SWAP16(z));
	WRITE_DATA(6, GLshort, SWAP16(w));
	WRITE_OPCODE(pc, CR_RASTERPOS4S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRasterPos4sv(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos4sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, v[0]);
	WRITE_DATA(2, GLshort, v[1]);
	WRITE_DATA(4, GLshort, v[2]);
	WRITE_DATA(6, GLshort, v[3]);
	WRITE_OPCODE(pc, CR_RASTERPOS4S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4svSWAP(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos4sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, SWAP16(v[0]));
	WRITE_DATA(2, GLshort, SWAP16(v[1]));
	WRITE_DATA(4, GLshort, SWAP16(v[2]));
	WRITE_DATA(6, GLshort, SWAP16(v[3]));
	WRITE_OPCODE(pc, CR_RASTERPOS4S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackReadBuffer(CR_PACKER_CONTEXT_ARGDECL GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_READBUFFER_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, mode);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackReadBufferSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_READBUFFER_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(mode));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRectd(CR_PACKER_CONTEXT_ARGDECL GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DOUBLE(0, x1);
	WRITE_DOUBLE(8, y1);
	WRITE_DOUBLE(16, x2);
	WRITE_DOUBLE(24, y2);
	WRITE_OPCODE(pc, CR_RECTD_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectdSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_SWAPPED_DOUBLE(0, x1);
	WRITE_SWAPPED_DOUBLE(8, y1);
	WRITE_SWAPPED_DOUBLE(16, x2);
	WRITE_SWAPPED_DOUBLE(24, y2);
	WRITE_OPCODE(pc, CR_RECTD_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRectdv(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v1, const GLdouble * v2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v1) {
        crDebug("App passed NULL as v1 for Rectdv");
        return;
    }
    if (!v2) {
        crDebug("App passed NULL as v2 for Rectdv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DOUBLE(0, v1[0]);
	WRITE_DOUBLE(8, v1[1]);
	WRITE_DOUBLE(0, v2[0]);
	WRITE_DOUBLE(8, v2[1]);
	WRITE_OPCODE(pc, CR_RECTD_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectdvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v1, const GLdouble * v2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v1) {
        crDebug("App passed NULL as v1 for Rectdv");
        return;
    }
    if (!v2) {
        crDebug("App passed NULL as v2 for Rectdv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_SWAPPED_DOUBLE(0, v1[0]);
	WRITE_SWAPPED_DOUBLE(8, v1[1]);
	WRITE_SWAPPED_DOUBLE(0, v2[0]);
	WRITE_SWAPPED_DOUBLE(8, v2[1]);
	WRITE_OPCODE(pc, CR_RECTD_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRectf(CR_PACKER_CONTEXT_ARGDECL GLfloat x1, GLfloat y1, GLfloat x2, GLfloat y2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLfloat, x1);
	WRITE_DATA(4, GLfloat, y1);
	WRITE_DATA(8, GLfloat, x2);
	WRITE_DATA(12, GLfloat, y2);
	WRITE_OPCODE(pc, CR_RECTF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectfSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat x1, GLfloat y1, GLfloat x2, GLfloat y2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLuint, SWAPFLOAT(x1));
	WRITE_DATA(4, GLuint, SWAPFLOAT(y1));
	WRITE_DATA(8, GLuint, SWAPFLOAT(x2));
	WRITE_DATA(12, GLuint, SWAPFLOAT(y2));
	WRITE_OPCODE(pc, CR_RECTF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRectfv(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v1, const GLfloat * v2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v1) {
        crDebug("App passed NULL as v1 for Rectfv");
        return;
    }
    if (!v2) {
        crDebug("App passed NULL as v2 for Rectfv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLfloat, v1[0]);
	WRITE_DATA(4, GLfloat, v1[1]);
	WRITE_DATA(0, GLfloat, v2[0]);
	WRITE_DATA(4, GLfloat, v2[1]);
	WRITE_OPCODE(pc, CR_RECTF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectfvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v1, const GLfloat * v2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v1) {
        crDebug("App passed NULL as v1 for Rectfv");
        return;
    }
    if (!v2) {
        crDebug("App passed NULL as v2 for Rectfv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLuint, SWAPFLOAT(v1[0]));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v1[1]));
	WRITE_DATA(0, GLuint, SWAPFLOAT(v2[0]));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v2[1]));
	WRITE_OPCODE(pc, CR_RECTF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRecti(CR_PACKER_CONTEXT_ARGDECL GLint x1, GLint y1, GLint x2, GLint y2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, x1);
	WRITE_DATA(4, GLint, y1);
	WRITE_DATA(8, GLint, x2);
	WRITE_DATA(12, GLint, y2);
	WRITE_OPCODE(pc, CR_RECTI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectiSWAP(CR_PACKER_CONTEXT_ARGDECL GLint x1, GLint y1, GLint x2, GLint y2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(x1));
	WRITE_DATA(4, GLint, SWAP32(y1));
	WRITE_DATA(8, GLint, SWAP32(x2));
	WRITE_DATA(12, GLint, SWAP32(y2));
	WRITE_OPCODE(pc, CR_RECTI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRectiv(CR_PACKER_CONTEXT_ARGDECL const GLint * v1, const GLint * v2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v1) {
        crDebug("App passed NULL as v1 for Rectiv");
        return;
    }
    if (!v2) {
        crDebug("App passed NULL as v2 for Rectiv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, v1[0]);
	WRITE_DATA(4, GLint, v1[1]);
	WRITE_DATA(0, GLint, v2[0]);
	WRITE_DATA(4, GLint, v2[1]);
	WRITE_OPCODE(pc, CR_RECTI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectivSWAP(CR_PACKER_CONTEXT_ARGDECL const GLint * v1, const GLint * v2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v1) {
        crDebug("App passed NULL as v1 for Rectiv");
        return;
    }
    if (!v2) {
        crDebug("App passed NULL as v2 for Rectiv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(v1[0]));
	WRITE_DATA(4, GLint, SWAP32(v1[1]));
	WRITE_DATA(0, GLint, SWAP32(v2[0]));
	WRITE_DATA(4, GLint, SWAP32(v2[1]));
	WRITE_OPCODE(pc, CR_RECTI_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRects(CR_PACKER_CONTEXT_ARGDECL GLshort x1, GLshort y1, GLshort x2, GLshort y2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, x1);
	WRITE_DATA(2, GLshort, y1);
	WRITE_DATA(4, GLshort, x2);
	WRITE_DATA(6, GLshort, y2);
	WRITE_OPCODE(pc, CR_RECTS_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectsSWAP(CR_PACKER_CONTEXT_ARGDECL GLshort x1, GLshort y1, GLshort x2, GLshort y2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, SWAP16(x1));
	WRITE_DATA(2, GLshort, SWAP16(y1));
	WRITE_DATA(4, GLshort, SWAP16(x2));
	WRITE_DATA(6, GLshort, SWAP16(y2));
	WRITE_OPCODE(pc, CR_RECTS_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRectsv(CR_PACKER_CONTEXT_ARGDECL const GLshort * v1, const GLshort * v2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v1) {
        crDebug("App passed NULL as v1 for Rectsv");
        return;
    }
    if (!v2) {
        crDebug("App passed NULL as v2 for Rectsv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, v1[0]);
	WRITE_DATA(2, GLshort, v1[1]);
	WRITE_DATA(0, GLshort, v2[0]);
	WRITE_DATA(2, GLshort, v2[1]);
	WRITE_OPCODE(pc, CR_RECTS_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectsvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLshort * v1, const GLshort * v2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v1) {
        crDebug("App passed NULL as v1 for Rectsv");
        return;
    }
    if (!v2) {
        crDebug("App passed NULL as v2 for Rectsv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, SWAP16(v1[0]));
	WRITE_DATA(2, GLshort, SWAP16(v1[1]));
	WRITE_DATA(0, GLshort, SWAP16(v2[0]));
	WRITE_DATA(2, GLshort, SWAP16(v2[1]));
	WRITE_OPCODE(pc, CR_RECTS_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRenderMode(CR_PACKER_CONTEXT_ARGDECL GLenum mode, GLint * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_RENDERMODE_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, mode);
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRenderModeSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum mode, GLint * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_RENDERMODE_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(mode));
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRenderbufferStorageEXT(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum internalformat, GLsizei width, GLsizei height)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, 24);
	WRITE_DATA(4, GLenum, CR_RENDERBUFFERSTORAGEEXT_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLenum, internalformat);
	WRITE_DATA(16, GLsizei, width);
	WRITE_DATA(20, GLsizei, height);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRenderbufferStorageEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLenum internalformat, GLsizei width, GLsizei height)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, SWAP32(24));
	WRITE_DATA(4, GLenum, SWAP32(CR_RENDERBUFFERSTORAGEEXT_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLenum, SWAP32(internalformat));
	WRITE_DATA(16, GLsizei, SWAP32(width));
	WRITE_DATA(20, GLsizei, SWAP32(height));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRotated(CR_PACKER_CONTEXT_ARGDECL GLdouble angle, GLdouble x, GLdouble y, GLdouble z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DOUBLE(0, angle);
	WRITE_DOUBLE(8, x);
	WRITE_DOUBLE(16, y);
	WRITE_DOUBLE(24, z);
	WRITE_OPCODE(pc, CR_ROTATED_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRotatedSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble angle, GLdouble x, GLdouble y, GLdouble z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_SWAPPED_DOUBLE(0, angle);
	WRITE_SWAPPED_DOUBLE(8, x);
	WRITE_SWAPPED_DOUBLE(16, y);
	WRITE_SWAPPED_DOUBLE(24, z);
	WRITE_OPCODE(pc, CR_ROTATED_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackRotatef(CR_PACKER_CONTEXT_ARGDECL GLfloat angle, GLfloat x, GLfloat y, GLfloat z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLfloat, angle);
	WRITE_DATA(4, GLfloat, x);
	WRITE_DATA(8, GLfloat, y);
	WRITE_DATA(12, GLfloat, z);
	WRITE_OPCODE(pc, CR_ROTATEF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRotatefSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat angle, GLfloat x, GLfloat y, GLfloat z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLuint, SWAPFLOAT(angle));
	WRITE_DATA(4, GLuint, SWAPFLOAT(x));
	WRITE_DATA(8, GLuint, SWAPFLOAT(y));
	WRITE_DATA(12, GLuint, SWAPFLOAT(z));
	WRITE_OPCODE(pc, CR_ROTATEF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSampleCoverageARB(CR_PACKER_CONTEXT_ARGDECL GLclampf value, GLboolean invert)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_SAMPLECOVERAGEARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLclampf, value);
	WRITE_DATA(12, GLboolean, invert);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSampleCoverageARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLclampf value, GLboolean invert)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_SAMPLECOVERAGEARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAPFLOAT(value));
	WRITE_DATA(12, GLboolean, invert);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackScaled(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y, GLdouble z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DOUBLE(0, x);
	WRITE_DOUBLE(8, y);
	WRITE_DOUBLE(16, z);
	WRITE_OPCODE(pc, CR_SCALED_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackScaledSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y, GLdouble z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_SWAPPED_DOUBLE(0, x);
	WRITE_SWAPPED_DOUBLE(8, y);
	WRITE_SWAPPED_DOUBLE(16, z);
	WRITE_OPCODE(pc, CR_SCALED_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackScalef(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y, GLfloat z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLfloat, x);
	WRITE_DATA(4, GLfloat, y);
	WRITE_DATA(8, GLfloat, z);
	WRITE_OPCODE(pc, CR_SCALEF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackScalefSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y, GLfloat z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLuint, SWAPFLOAT(x));
	WRITE_DATA(4, GLuint, SWAPFLOAT(y));
	WRITE_DATA(8, GLuint, SWAPFLOAT(z));
	WRITE_OPCODE(pc, CR_SCALEF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackScissor(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y, GLsizei width, GLsizei height)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, x);
	WRITE_DATA(4, GLint, y);
	WRITE_DATA(8, GLsizei, width);
	WRITE_DATA(12, GLsizei, height);
	WRITE_OPCODE(pc, CR_SCISSOR_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackScissorSWAP(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y, GLsizei width, GLsizei height)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(x));
	WRITE_DATA(4, GLint, SWAP32(y));
	WRITE_DATA(8, GLsizei, SWAP32(width));
	WRITE_DATA(12, GLsizei, SWAP32(height));
	WRITE_OPCODE(pc, CR_SCISSOR_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSecondaryColor3bEXT(CR_PACKER_CONTEXT_ARGDECL GLbyte red, GLbyte green, GLbyte blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.secondaryColor.b3 = data_ptr;
	WRITE_DATA(0, GLbyte, red);
	WRITE_DATA(1, GLbyte, green);
	WRITE_DATA(2, GLbyte, blue);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3BEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3bEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLbyte red, GLbyte green, GLbyte blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.secondaryColor.b3 = data_ptr;
	WRITE_DATA(0, GLbyte, red);
	WRITE_DATA(1, GLbyte, green);
	WRITE_DATA(2, GLbyte, blue);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3BEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSecondaryColor3bvEXT(CR_PACKER_CONTEXT_ARGDECL const GLbyte * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3bvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.secondaryColor.b3 = data_ptr;
	WRITE_DATA(0, GLbyte, v[0]);
	WRITE_DATA(1, GLbyte, v[1]);
	WRITE_DATA(2, GLbyte, v[2]);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3BEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3bvEXTSWAP(CR_PACKER_CONTEXT_ARGDECL const GLbyte * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3bvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.secondaryColor.b3 = data_ptr;
	WRITE_DATA(0, GLbyte, v[0]);
	WRITE_DATA(1, GLbyte, v[1]);
	WRITE_DATA(2, GLbyte, v[2]);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3BEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSecondaryColor3dEXT(CR_PACKER_CONTEXT_ARGDECL GLdouble red, GLdouble green, GLdouble blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	pc->current.c.secondaryColor.d3 = data_ptr;
	WRITE_DOUBLE(0, red);
	WRITE_DOUBLE(8, green);
	WRITE_DOUBLE(16, blue);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3DEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3dEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble red, GLdouble green, GLdouble blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	pc->current.c.secondaryColor.d3 = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, red);
	WRITE_SWAPPED_DOUBLE(8, green);
	WRITE_SWAPPED_DOUBLE(16, blue);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3DEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSecondaryColor3dvEXT(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3dvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 24);
	pc->current.c.secondaryColor.d3 = data_ptr;
	WRITE_DOUBLE(0, v[0]);
	WRITE_DOUBLE(8, v[1]);
	WRITE_DOUBLE(16, v[2]);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3DEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3dvEXTSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3dvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 24);
	pc->current.c.secondaryColor.d3 = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, v[0]);
	WRITE_SWAPPED_DOUBLE(8, v[1]);
	WRITE_SWAPPED_DOUBLE(16, v[2]);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3DEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSecondaryColor3fEXT(CR_PACKER_CONTEXT_ARGDECL GLfloat red, GLfloat green, GLfloat blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.secondaryColor.f3 = data_ptr;
	WRITE_DATA(0, GLfloat, red);
	WRITE_DATA(4, GLfloat, green);
	WRITE_DATA(8, GLfloat, blue);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3FEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3fEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat red, GLfloat green, GLfloat blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.secondaryColor.f3 = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(red));
	WRITE_DATA(4, GLuint, SWAPFLOAT(green));
	WRITE_DATA(8, GLuint, SWAPFLOAT(blue));
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3FEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSecondaryColor3fvEXT(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.secondaryColor.f3 = data_ptr;
	WRITE_DATA(0, GLfloat, v[0]);
	WRITE_DATA(4, GLfloat, v[1]);
	WRITE_DATA(8, GLfloat, v[2]);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3FEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3fvEXTSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.secondaryColor.f3 = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(v[0]));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v[1]));
	WRITE_DATA(8, GLuint, SWAPFLOAT(v[2]));
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3FEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSecondaryColor3iEXT(CR_PACKER_CONTEXT_ARGDECL GLint red, GLint green, GLint blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.secondaryColor.i3 = data_ptr;
	WRITE_DATA(0, GLint, red);
	WRITE_DATA(4, GLint, green);
	WRITE_DATA(8, GLint, blue);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3IEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3iEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLint red, GLint green, GLint blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.secondaryColor.i3 = data_ptr;
	WRITE_DATA(0, GLint, SWAP32(red));
	WRITE_DATA(4, GLint, SWAP32(green));
	WRITE_DATA(8, GLint, SWAP32(blue));
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3IEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSecondaryColor3ivEXT(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3ivEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.secondaryColor.i3 = data_ptr;
	WRITE_DATA(0, GLint, v[0]);
	WRITE_DATA(4, GLint, v[1]);
	WRITE_DATA(8, GLint, v[2]);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3IEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3ivEXTSWAP(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3ivEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.secondaryColor.i3 = data_ptr;
	WRITE_DATA(0, GLint, SWAP32(v[0]));
	WRITE_DATA(4, GLint, SWAP32(v[1]));
	WRITE_DATA(8, GLint, SWAP32(v[2]));
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3IEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSecondaryColor3sEXT(CR_PACKER_CONTEXT_ARGDECL GLshort red, GLshort green, GLshort blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.secondaryColor.s3 = data_ptr;
	WRITE_DATA(0, GLshort, red);
	WRITE_DATA(2, GLshort, green);
	WRITE_DATA(4, GLshort, blue);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3SEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3sEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLshort red, GLshort green, GLshort blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.secondaryColor.s3 = data_ptr;
	WRITE_DATA(0, GLshort, SWAP16(red));
	WRITE_DATA(2, GLshort, SWAP16(green));
	WRITE_DATA(4, GLshort, SWAP16(blue));
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3SEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSecondaryColor3svEXT(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3svEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.secondaryColor.s3 = data_ptr;
	WRITE_DATA(0, GLshort, v[0]);
	WRITE_DATA(2, GLshort, v[1]);
	WRITE_DATA(4, GLshort, v[2]);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3SEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3svEXTSWAP(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3svEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.secondaryColor.s3 = data_ptr;
	WRITE_DATA(0, GLshort, SWAP16(v[0]));
	WRITE_DATA(2, GLshort, SWAP16(v[1]));
	WRITE_DATA(4, GLshort, SWAP16(v[2]));
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3SEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSecondaryColor3ubEXT(CR_PACKER_CONTEXT_ARGDECL GLubyte red, GLubyte green, GLubyte blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.secondaryColor.ub3 = data_ptr;
	WRITE_DATA(0, GLubyte, red);
	WRITE_DATA(1, GLubyte, green);
	WRITE_DATA(2, GLubyte, blue);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3UBEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3ubEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLubyte red, GLubyte green, GLubyte blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.secondaryColor.ub3 = data_ptr;
	WRITE_DATA(0, GLubyte, red);
	WRITE_DATA(1, GLubyte, green);
	WRITE_DATA(2, GLubyte, blue);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3UBEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSecondaryColor3ubvEXT(CR_PACKER_CONTEXT_ARGDECL const GLubyte * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3ubvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.secondaryColor.ub3 = data_ptr;
	WRITE_DATA(0, GLubyte, v[0]);
	WRITE_DATA(1, GLubyte, v[1]);
	WRITE_DATA(2, GLubyte, v[2]);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3UBEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3ubvEXTSWAP(CR_PACKER_CONTEXT_ARGDECL const GLubyte * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3ubvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.secondaryColor.ub3 = data_ptr;
	WRITE_DATA(0, GLubyte, v[0]);
	WRITE_DATA(1, GLubyte, v[1]);
	WRITE_DATA(2, GLubyte, v[2]);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3UBEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSecondaryColor3uiEXT(CR_PACKER_CONTEXT_ARGDECL GLuint red, GLuint green, GLuint blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.secondaryColor.ui3 = data_ptr;
	WRITE_DATA(0, GLuint, red);
	WRITE_DATA(4, GLuint, green);
	WRITE_DATA(8, GLuint, blue);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3UIEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3uiEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint red, GLuint green, GLuint blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.secondaryColor.ui3 = data_ptr;
	WRITE_DATA(0, GLuint, SWAP32(red));
	WRITE_DATA(4, GLuint, SWAP32(green));
	WRITE_DATA(8, GLuint, SWAP32(blue));
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3UIEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSecondaryColor3uivEXT(CR_PACKER_CONTEXT_ARGDECL const GLuint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3uivEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.secondaryColor.ui3 = data_ptr;
	WRITE_DATA(0, GLuint, v[0]);
	WRITE_DATA(4, GLuint, v[1]);
	WRITE_DATA(8, GLuint, v[2]);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3UIEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3uivEXTSWAP(CR_PACKER_CONTEXT_ARGDECL const GLuint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3uivEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.secondaryColor.ui3 = data_ptr;
	WRITE_DATA(0, GLuint, SWAP32(v[0]));
	WRITE_DATA(4, GLuint, SWAP32(v[1]));
	WRITE_DATA(8, GLuint, SWAP32(v[2]));
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3UIEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSecondaryColor3usEXT(CR_PACKER_CONTEXT_ARGDECL GLushort red, GLushort green, GLushort blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.secondaryColor.us3 = data_ptr;
	WRITE_DATA(0, GLushort, red);
	WRITE_DATA(2, GLushort, green);
	WRITE_DATA(4, GLushort, blue);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3USEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3usEXTSWAP(CR_PACKER_CONTEXT_ARGDECL GLushort red, GLushort green, GLushort blue)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.secondaryColor.us3 = data_ptr;
	WRITE_DATA(0, GLushort, SWAP16(red));
	WRITE_DATA(2, GLushort, SWAP16(green));
	WRITE_DATA(4, GLushort, SWAP16(blue));
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3USEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSecondaryColor3usvEXT(CR_PACKER_CONTEXT_ARGDECL const GLushort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3usvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.secondaryColor.us3 = data_ptr;
	WRITE_DATA(0, GLushort, v[0]);
	WRITE_DATA(2, GLushort, v[1]);
	WRITE_DATA(4, GLushort, v[2]);
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3USEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3usvEXTSWAP(CR_PACKER_CONTEXT_ARGDECL const GLushort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3usvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.secondaryColor.us3 = data_ptr;
	WRITE_DATA(0, GLushort, SWAP16(v[0]));
	WRITE_DATA(2, GLushort, SWAP16(v[1]));
	WRITE_DATA(4, GLushort, SWAP16(v[2]));
	WRITE_OPCODE(pc, CR_SECONDARYCOLOR3USEXT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSemaphoreCreateCR(CR_PACKER_CONTEXT_ARGDECL GLuint name, GLuint count)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_SEMAPHORECREATECR_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, name);
	WRITE_DATA(12, GLuint, count);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSemaphoreCreateCRSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint name, GLuint count)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_SEMAPHORECREATECR_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(name));
	WRITE_DATA(12, GLuint, SWAP32(count));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSemaphoreDestroyCR(CR_PACKER_CONTEXT_ARGDECL GLuint name)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_SEMAPHOREDESTROYCR_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, name);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSemaphoreDestroyCRSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint name)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_SEMAPHOREDESTROYCR_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(name));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSemaphorePCR(CR_PACKER_CONTEXT_ARGDECL GLuint name)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_SEMAPHOREPCR_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, name);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSemaphorePCRSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint name)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_SEMAPHOREPCR_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(name));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSemaphoreVCR(CR_PACKER_CONTEXT_ARGDECL GLuint name)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_SEMAPHOREVCR_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, name);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSemaphoreVCRSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint name)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_SEMAPHOREVCR_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(name));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSetFenceNV(CR_PACKER_CONTEXT_ARGDECL GLuint fence, GLenum condition)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_SETFENCENV_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, fence);
	WRITE_DATA(12, GLenum, condition);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSetFenceNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint fence, GLenum condition)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_SETFENCENV_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(fence));
	WRITE_DATA(12, GLenum, SWAP32(condition));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackShadeModel(CR_PACKER_CONTEXT_ARGDECL GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLenum, mode);
	WRITE_OPCODE(pc, CR_SHADEMODEL_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackShadeModelSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum mode)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLenum, SWAP32(mode));
	WRITE_OPCODE(pc, CR_SHADEMODEL_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackStencilFunc(CR_PACKER_CONTEXT_ARGDECL GLenum func, GLint ref, GLuint mask)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLenum, func);
	WRITE_DATA(4, GLint, ref);
	WRITE_DATA(8, GLuint, mask);
	WRITE_OPCODE(pc, CR_STENCILFUNC_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackStencilFuncSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum func, GLint ref, GLuint mask)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLenum, SWAP32(func));
	WRITE_DATA(4, GLint, SWAP32(ref));
	WRITE_DATA(8, GLuint, SWAP32(mask));
	WRITE_OPCODE(pc, CR_STENCILFUNC_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackStencilFuncSeparate(CR_PACKER_CONTEXT_ARGDECL GLenum frontfunc, GLenum backfunc, GLint ref, GLuint mask)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, 24);
	WRITE_DATA(4, GLenum, CR_STENCILFUNCSEPARATE_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, frontfunc);
	WRITE_DATA(12, GLenum, backfunc);
	WRITE_DATA(16, GLint, ref);
	WRITE_DATA(20, GLuint, mask);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackStencilFuncSeparateSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum frontfunc, GLenum backfunc, GLint ref, GLuint mask)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, SWAP32(24));
	WRITE_DATA(4, GLenum, SWAP32(CR_STENCILFUNCSEPARATE_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(frontfunc));
	WRITE_DATA(12, GLenum, SWAP32(backfunc));
	WRITE_DATA(16, GLint, SWAP32(ref));
	WRITE_DATA(20, GLuint, SWAP32(mask));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackStencilMask(CR_PACKER_CONTEXT_ARGDECL GLuint mask)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLuint, mask);
	WRITE_OPCODE(pc, CR_STENCILMASK_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackStencilMaskSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint mask)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLuint, SWAP32(mask));
	WRITE_OPCODE(pc, CR_STENCILMASK_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackStencilMaskSeparate(CR_PACKER_CONTEXT_ARGDECL GLenum face, GLuint mask)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_STENCILMASKSEPARATE_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, face);
	WRITE_DATA(12, GLuint, mask);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackStencilMaskSeparateSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum face, GLuint mask)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_STENCILMASKSEPARATE_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(face));
	WRITE_DATA(12, GLuint, SWAP32(mask));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackStencilOp(CR_PACKER_CONTEXT_ARGDECL GLenum fail, GLenum zfail, GLenum zpass)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLenum, fail);
	WRITE_DATA(4, GLenum, zfail);
	WRITE_DATA(8, GLenum, zpass);
	WRITE_OPCODE(pc, CR_STENCILOP_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackStencilOpSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum fail, GLenum zfail, GLenum zpass)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLenum, SWAP32(fail));
	WRITE_DATA(4, GLenum, SWAP32(zfail));
	WRITE_DATA(8, GLenum, SWAP32(zpass));
	WRITE_OPCODE(pc, CR_STENCILOP_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackStencilOpSeparate(CR_PACKER_CONTEXT_ARGDECL GLenum face, GLenum fail, GLenum zfail, GLenum zpass)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, 24);
	WRITE_DATA(4, GLenum, CR_STENCILOPSEPARATE_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, face);
	WRITE_DATA(12, GLenum, fail);
	WRITE_DATA(16, GLenum, zfail);
	WRITE_DATA(20, GLenum, zpass);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackStencilOpSeparateSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum face, GLenum fail, GLenum zfail, GLenum zpass)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, SWAP32(24));
	WRITE_DATA(4, GLenum, SWAP32(CR_STENCILOPSEPARATE_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(face));
	WRITE_DATA(12, GLenum, SWAP32(fail));
	WRITE_DATA(16, GLenum, SWAP32(zfail));
	WRITE_DATA(20, GLenum, SWAP32(zpass));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackSwapBuffers(CR_PACKER_CONTEXT_ARGDECL GLint window, GLint flags)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_SWAPBUFFERS_EXTEND_OPCODE);
	WRITE_DATA(8, GLint, window);
	WRITE_DATA(12, GLint, flags);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSwapBuffersSWAP(CR_PACKER_CONTEXT_ARGDECL GLint window, GLint flags)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_SWAPBUFFERS_EXTEND_OPCODE));
	WRITE_DATA(8, GLint, SWAP32(window));
	WRITE_DATA(12, GLint, SWAP32(flags));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTestFenceNV(CR_PACKER_CONTEXT_ARGDECL GLuint fence, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_TESTFENCENV_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, fence);
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTestFenceNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint fence, GLboolean * return_value, int * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_TESTFENCENV_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(fence));
	WRITE_NETWORK_POINTER(12, (void *) return_value);
	WRITE_NETWORK_POINTER(20, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_CMDBLOCK_CHECK_FLUSH(pc);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord1d(CR_PACKER_CONTEXT_ARGDECL GLdouble s)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.d1[0] = data_ptr;
	WRITE_DOUBLE(0, s);
	WRITE_OPCODE(pc, CR_TEXCOORD1D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1dSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble s)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.d1[0] = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, s);
	WRITE_OPCODE(pc, CR_TEXCOORD1D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord1dv(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord1dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.d1[0] = data_ptr;
	WRITE_DOUBLE(0, v[0]);
	WRITE_OPCODE(pc, CR_TEXCOORD1D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1dvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord1dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.d1[0] = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, v[0]);
	WRITE_OPCODE(pc, CR_TEXCOORD1D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord1f(CR_PACKER_CONTEXT_ARGDECL GLfloat s)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.texCoord.f1[0] = data_ptr;
	WRITE_DATA(0, GLfloat, s);
	WRITE_OPCODE(pc, CR_TEXCOORD1F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1fSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat s)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.texCoord.f1[0] = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(s));
	WRITE_OPCODE(pc, CR_TEXCOORD1F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord1fv(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord1fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.texCoord.f1[0] = data_ptr;
	WRITE_DATA(0, GLfloat, v[0]);
	WRITE_OPCODE(pc, CR_TEXCOORD1F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1fvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord1fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.texCoord.f1[0] = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(v[0]));
	WRITE_OPCODE(pc, CR_TEXCOORD1F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord1i(CR_PACKER_CONTEXT_ARGDECL GLint s)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.texCoord.i1[0] = data_ptr;
	WRITE_DATA(0, GLint, s);
	WRITE_OPCODE(pc, CR_TEXCOORD1I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1iSWAP(CR_PACKER_CONTEXT_ARGDECL GLint s)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.texCoord.i1[0] = data_ptr;
	WRITE_DATA(0, GLint, SWAP32(s));
	WRITE_OPCODE(pc, CR_TEXCOORD1I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord1iv(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord1iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.texCoord.i1[0] = data_ptr;
	WRITE_DATA(0, GLint, v[0]);
	WRITE_OPCODE(pc, CR_TEXCOORD1I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1ivSWAP(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord1iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.texCoord.i1[0] = data_ptr;
	WRITE_DATA(0, GLint, SWAP32(v[0]));
	WRITE_OPCODE(pc, CR_TEXCOORD1I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord1s(CR_PACKER_CONTEXT_ARGDECL GLshort s)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.texCoord.s1[0] = data_ptr;
	WRITE_DATA(0, GLshort, s);
	WRITE_OPCODE(pc, CR_TEXCOORD1S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1sSWAP(CR_PACKER_CONTEXT_ARGDECL GLshort s)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.texCoord.s1[0] = data_ptr;
	WRITE_DATA(0, GLshort, SWAP16(s));
	WRITE_OPCODE(pc, CR_TEXCOORD1S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord1sv(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord1sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.texCoord.s1[0] = data_ptr;
	WRITE_DATA(0, GLshort, v[0]);
	WRITE_OPCODE(pc, CR_TEXCOORD1S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1svSWAP(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord1sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.texCoord.s1[0] = data_ptr;
	WRITE_DATA(0, GLshort, SWAP16(v[0]));
	WRITE_OPCODE(pc, CR_TEXCOORD1S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord2d(CR_PACKER_CONTEXT_ARGDECL GLdouble s, GLdouble t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.d2[0] = data_ptr;
	WRITE_DOUBLE(0, s);
	WRITE_DOUBLE(8, t);
	WRITE_OPCODE(pc, CR_TEXCOORD2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2dSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble s, GLdouble t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.d2[0] = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, s);
	WRITE_SWAPPED_DOUBLE(8, t);
	WRITE_OPCODE(pc, CR_TEXCOORD2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord2dv(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord2dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.d2[0] = data_ptr;
	WRITE_DOUBLE(0, v[0]);
	WRITE_DOUBLE(8, v[1]);
	WRITE_OPCODE(pc, CR_TEXCOORD2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2dvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord2dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.d2[0] = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, v[0]);
	WRITE_SWAPPED_DOUBLE(8, v[1]);
	WRITE_OPCODE(pc, CR_TEXCOORD2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord2f(CR_PACKER_CONTEXT_ARGDECL GLfloat s, GLfloat t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.f2[0] = data_ptr;
	WRITE_DATA(0, GLfloat, s);
	WRITE_DATA(4, GLfloat, t);
	WRITE_OPCODE(pc, CR_TEXCOORD2F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2fSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat s, GLfloat t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.f2[0] = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(s));
	WRITE_DATA(4, GLuint, SWAPFLOAT(t));
	WRITE_OPCODE(pc, CR_TEXCOORD2F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord2fv(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord2fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.f2[0] = data_ptr;
	WRITE_DATA(0, GLfloat, v[0]);
	WRITE_DATA(4, GLfloat, v[1]);
	WRITE_OPCODE(pc, CR_TEXCOORD2F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2fvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord2fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.f2[0] = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(v[0]));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v[1]));
	WRITE_OPCODE(pc, CR_TEXCOORD2F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord2i(CR_PACKER_CONTEXT_ARGDECL GLint s, GLint t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.i2[0] = data_ptr;
	WRITE_DATA(0, GLint, s);
	WRITE_DATA(4, GLint, t);
	WRITE_OPCODE(pc, CR_TEXCOORD2I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2iSWAP(CR_PACKER_CONTEXT_ARGDECL GLint s, GLint t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.i2[0] = data_ptr;
	WRITE_DATA(0, GLint, SWAP32(s));
	WRITE_DATA(4, GLint, SWAP32(t));
	WRITE_OPCODE(pc, CR_TEXCOORD2I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord2iv(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord2iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.i2[0] = data_ptr;
	WRITE_DATA(0, GLint, v[0]);
	WRITE_DATA(4, GLint, v[1]);
	WRITE_OPCODE(pc, CR_TEXCOORD2I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2ivSWAP(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord2iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.i2[0] = data_ptr;
	WRITE_DATA(0, GLint, SWAP32(v[0]));
	WRITE_DATA(4, GLint, SWAP32(v[1]));
	WRITE_OPCODE(pc, CR_TEXCOORD2I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord2s(CR_PACKER_CONTEXT_ARGDECL GLshort s, GLshort t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.texCoord.s2[0] = data_ptr;
	WRITE_DATA(0, GLshort, s);
	WRITE_DATA(2, GLshort, t);
	WRITE_OPCODE(pc, CR_TEXCOORD2S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2sSWAP(CR_PACKER_CONTEXT_ARGDECL GLshort s, GLshort t)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.texCoord.s2[0] = data_ptr;
	WRITE_DATA(0, GLshort, SWAP16(s));
	WRITE_DATA(2, GLshort, SWAP16(t));
	WRITE_OPCODE(pc, CR_TEXCOORD2S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord2sv(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord2sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.texCoord.s2[0] = data_ptr;
	WRITE_DATA(0, GLshort, v[0]);
	WRITE_DATA(2, GLshort, v[1]);
	WRITE_OPCODE(pc, CR_TEXCOORD2S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2svSWAP(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord2sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	pc->current.c.texCoord.s2[0] = data_ptr;
	WRITE_DATA(0, GLshort, SWAP16(v[0]));
	WRITE_DATA(2, GLshort, SWAP16(v[1]));
	WRITE_OPCODE(pc, CR_TEXCOORD2S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord3d(CR_PACKER_CONTEXT_ARGDECL GLdouble s, GLdouble t, GLdouble r)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	pc->current.c.texCoord.d3[0] = data_ptr;
	WRITE_DOUBLE(0, s);
	WRITE_DOUBLE(8, t);
	WRITE_DOUBLE(16, r);
	WRITE_OPCODE(pc, CR_TEXCOORD3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3dSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble s, GLdouble t, GLdouble r)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	pc->current.c.texCoord.d3[0] = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, s);
	WRITE_SWAPPED_DOUBLE(8, t);
	WRITE_SWAPPED_DOUBLE(16, r);
	WRITE_OPCODE(pc, CR_TEXCOORD3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord3dv(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 24);
	pc->current.c.texCoord.d3[0] = data_ptr;
	WRITE_DOUBLE(0, v[0]);
	WRITE_DOUBLE(8, v[1]);
	WRITE_DOUBLE(16, v[2]);
	WRITE_OPCODE(pc, CR_TEXCOORD3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3dvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 24);
	pc->current.c.texCoord.d3[0] = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, v[0]);
	WRITE_SWAPPED_DOUBLE(8, v[1]);
	WRITE_SWAPPED_DOUBLE(16, v[2]);
	WRITE_OPCODE(pc, CR_TEXCOORD3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord3f(CR_PACKER_CONTEXT_ARGDECL GLfloat s, GLfloat t, GLfloat r)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.f3[0] = data_ptr;
	WRITE_DATA(0, GLfloat, s);
	WRITE_DATA(4, GLfloat, t);
	WRITE_DATA(8, GLfloat, r);
	WRITE_OPCODE(pc, CR_TEXCOORD3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3fSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat s, GLfloat t, GLfloat r)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.f3[0] = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(s));
	WRITE_DATA(4, GLuint, SWAPFLOAT(t));
	WRITE_DATA(8, GLuint, SWAPFLOAT(r));
	WRITE_OPCODE(pc, CR_TEXCOORD3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord3fv(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.f3[0] = data_ptr;
	WRITE_DATA(0, GLfloat, v[0]);
	WRITE_DATA(4, GLfloat, v[1]);
	WRITE_DATA(8, GLfloat, v[2]);
	WRITE_OPCODE(pc, CR_TEXCOORD3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3fvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.f3[0] = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(v[0]));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v[1]));
	WRITE_DATA(8, GLuint, SWAPFLOAT(v[2]));
	WRITE_OPCODE(pc, CR_TEXCOORD3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord3i(CR_PACKER_CONTEXT_ARGDECL GLint s, GLint t, GLint r)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.i3[0] = data_ptr;
	WRITE_DATA(0, GLint, s);
	WRITE_DATA(4, GLint, t);
	WRITE_DATA(8, GLint, r);
	WRITE_OPCODE(pc, CR_TEXCOORD3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3iSWAP(CR_PACKER_CONTEXT_ARGDECL GLint s, GLint t, GLint r)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.i3[0] = data_ptr;
	WRITE_DATA(0, GLint, SWAP32(s));
	WRITE_DATA(4, GLint, SWAP32(t));
	WRITE_DATA(8, GLint, SWAP32(r));
	WRITE_OPCODE(pc, CR_TEXCOORD3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord3iv(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.i3[0] = data_ptr;
	WRITE_DATA(0, GLint, v[0]);
	WRITE_DATA(4, GLint, v[1]);
	WRITE_DATA(8, GLint, v[2]);
	WRITE_OPCODE(pc, CR_TEXCOORD3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3ivSWAP(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.texCoord.i3[0] = data_ptr;
	WRITE_DATA(0, GLint, SWAP32(v[0]));
	WRITE_DATA(4, GLint, SWAP32(v[1]));
	WRITE_DATA(8, GLint, SWAP32(v[2]));
	WRITE_OPCODE(pc, CR_TEXCOORD3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord3s(CR_PACKER_CONTEXT_ARGDECL GLshort s, GLshort t, GLshort r)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.s3[0] = data_ptr;
	WRITE_DATA(0, GLshort, s);
	WRITE_DATA(2, GLshort, t);
	WRITE_DATA(4, GLshort, r);
	WRITE_OPCODE(pc, CR_TEXCOORD3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3sSWAP(CR_PACKER_CONTEXT_ARGDECL GLshort s, GLshort t, GLshort r)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.s3[0] = data_ptr;
	WRITE_DATA(0, GLshort, SWAP16(s));
	WRITE_DATA(2, GLshort, SWAP16(t));
	WRITE_DATA(4, GLshort, SWAP16(r));
	WRITE_OPCODE(pc, CR_TEXCOORD3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord3sv(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.s3[0] = data_ptr;
	WRITE_DATA(0, GLshort, v[0]);
	WRITE_DATA(2, GLshort, v[1]);
	WRITE_DATA(4, GLshort, v[2]);
	WRITE_OPCODE(pc, CR_TEXCOORD3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3svSWAP(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.s3[0] = data_ptr;
	WRITE_DATA(0, GLshort, SWAP16(v[0]));
	WRITE_DATA(2, GLshort, SWAP16(v[1]));
	WRITE_DATA(4, GLshort, SWAP16(v[2]));
	WRITE_OPCODE(pc, CR_TEXCOORD3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord4d(CR_PACKER_CONTEXT_ARGDECL GLdouble s, GLdouble t, GLdouble r, GLdouble q)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	pc->current.c.texCoord.d4[0] = data_ptr;
	WRITE_DOUBLE(0, s);
	WRITE_DOUBLE(8, t);
	WRITE_DOUBLE(16, r);
	WRITE_DOUBLE(24, q);
	WRITE_OPCODE(pc, CR_TEXCOORD4D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4dSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble s, GLdouble t, GLdouble r, GLdouble q)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	pc->current.c.texCoord.d4[0] = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, s);
	WRITE_SWAPPED_DOUBLE(8, t);
	WRITE_SWAPPED_DOUBLE(16, r);
	WRITE_SWAPPED_DOUBLE(24, q);
	WRITE_OPCODE(pc, CR_TEXCOORD4D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord4dv(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord4dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 32);
	pc->current.c.texCoord.d4[0] = data_ptr;
	WRITE_DOUBLE(0, v[0]);
	WRITE_DOUBLE(8, v[1]);
	WRITE_DOUBLE(16, v[2]);
	WRITE_DOUBLE(24, v[3]);
	WRITE_OPCODE(pc, CR_TEXCOORD4D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4dvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord4dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 32);
	pc->current.c.texCoord.d4[0] = data_ptr;
	WRITE_SWAPPED_DOUBLE(0, v[0]);
	WRITE_SWAPPED_DOUBLE(8, v[1]);
	WRITE_SWAPPED_DOUBLE(16, v[2]);
	WRITE_SWAPPED_DOUBLE(24, v[3]);
	WRITE_OPCODE(pc, CR_TEXCOORD4D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord4f(CR_PACKER_CONTEXT_ARGDECL GLfloat s, GLfloat t, GLfloat r, GLfloat q)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.f4[0] = data_ptr;
	WRITE_DATA(0, GLfloat, s);
	WRITE_DATA(4, GLfloat, t);
	WRITE_DATA(8, GLfloat, r);
	WRITE_DATA(12, GLfloat, q);
	WRITE_OPCODE(pc, CR_TEXCOORD4F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4fSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat s, GLfloat t, GLfloat r, GLfloat q)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.f4[0] = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(s));
	WRITE_DATA(4, GLuint, SWAPFLOAT(t));
	WRITE_DATA(8, GLuint, SWAPFLOAT(r));
	WRITE_DATA(12, GLuint, SWAPFLOAT(q));
	WRITE_OPCODE(pc, CR_TEXCOORD4F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord4fv(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord4fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.f4[0] = data_ptr;
	WRITE_DATA(0, GLfloat, v[0]);
	WRITE_DATA(4, GLfloat, v[1]);
	WRITE_DATA(8, GLfloat, v[2]);
	WRITE_DATA(12, GLfloat, v[3]);
	WRITE_OPCODE(pc, CR_TEXCOORD4F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4fvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord4fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.f4[0] = data_ptr;
	WRITE_DATA(0, GLuint, SWAPFLOAT(v[0]));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v[1]));
	WRITE_DATA(8, GLuint, SWAPFLOAT(v[2]));
	WRITE_DATA(12, GLuint, SWAPFLOAT(v[3]));
	WRITE_OPCODE(pc, CR_TEXCOORD4F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord4i(CR_PACKER_CONTEXT_ARGDECL GLint s, GLint t, GLint r, GLint q)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.i4[0] = data_ptr;
	WRITE_DATA(0, GLint, s);
	WRITE_DATA(4, GLint, t);
	WRITE_DATA(8, GLint, r);
	WRITE_DATA(12, GLint, q);
	WRITE_OPCODE(pc, CR_TEXCOORD4I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4iSWAP(CR_PACKER_CONTEXT_ARGDECL GLint s, GLint t, GLint r, GLint q)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.i4[0] = data_ptr;
	WRITE_DATA(0, GLint, SWAP32(s));
	WRITE_DATA(4, GLint, SWAP32(t));
	WRITE_DATA(8, GLint, SWAP32(r));
	WRITE_DATA(12, GLint, SWAP32(q));
	WRITE_OPCODE(pc, CR_TEXCOORD4I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord4iv(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord4iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.i4[0] = data_ptr;
	WRITE_DATA(0, GLint, v[0]);
	WRITE_DATA(4, GLint, v[1]);
	WRITE_DATA(8, GLint, v[2]);
	WRITE_DATA(12, GLint, v[3]);
	WRITE_OPCODE(pc, CR_TEXCOORD4I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4ivSWAP(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord4iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.texCoord.i4[0] = data_ptr;
	WRITE_DATA(0, GLint, SWAP32(v[0]));
	WRITE_DATA(4, GLint, SWAP32(v[1]));
	WRITE_DATA(8, GLint, SWAP32(v[2]));
	WRITE_DATA(12, GLint, SWAP32(v[3]));
	WRITE_OPCODE(pc, CR_TEXCOORD4I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord4s(CR_PACKER_CONTEXT_ARGDECL GLshort s, GLshort t, GLshort r, GLshort q)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.s4[0] = data_ptr;
	WRITE_DATA(0, GLshort, s);
	WRITE_DATA(2, GLshort, t);
	WRITE_DATA(4, GLshort, r);
	WRITE_DATA(6, GLshort, q);
	WRITE_OPCODE(pc, CR_TEXCOORD4S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4sSWAP(CR_PACKER_CONTEXT_ARGDECL GLshort s, GLshort t, GLshort r, GLshort q)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.s4[0] = data_ptr;
	WRITE_DATA(0, GLshort, SWAP16(s));
	WRITE_DATA(2, GLshort, SWAP16(t));
	WRITE_DATA(4, GLshort, SWAP16(r));
	WRITE_DATA(6, GLshort, SWAP16(q));
	WRITE_OPCODE(pc, CR_TEXCOORD4S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTexCoord4sv(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord4sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.s4[0] = data_ptr;
	WRITE_DATA(0, GLshort, v[0]);
	WRITE_DATA(2, GLshort, v[1]);
	WRITE_DATA(4, GLshort, v[2]);
	WRITE_DATA(6, GLshort, v[3]);
	WRITE_OPCODE(pc, CR_TEXCOORD4S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4svSWAP(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord4sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.texCoord.s4[0] = data_ptr;
	WRITE_DATA(0, GLshort, SWAP16(v[0]));
	WRITE_DATA(2, GLshort, SWAP16(v[1]));
	WRITE_DATA(4, GLshort, SWAP16(v[2]));
	WRITE_DATA(6, GLshort, SWAP16(v[3]));
	WRITE_OPCODE(pc, CR_TEXCOORD4S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTrackMatrixNV(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint address, GLenum matrix, GLenum transform)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, 24);
	WRITE_DATA(4, GLenum, CR_TRACKMATRIXNV_EXTEND_OPCODE);
	WRITE_DATA(8, GLenum, target);
	WRITE_DATA(12, GLuint, address);
	WRITE_DATA(16, GLenum, matrix);
	WRITE_DATA(20, GLenum, transform);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTrackMatrixNVSWAP(CR_PACKER_CONTEXT_ARGDECL GLenum target, GLuint address, GLenum matrix, GLenum transform)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, SWAP32(24));
	WRITE_DATA(4, GLenum, SWAP32(CR_TRACKMATRIXNV_EXTEND_OPCODE));
	WRITE_DATA(8, GLenum, SWAP32(target));
	WRITE_DATA(12, GLuint, SWAP32(address));
	WRITE_DATA(16, GLenum, SWAP32(matrix));
	WRITE_DATA(20, GLenum, SWAP32(transform));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTranslated(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y, GLdouble z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 24, GL_TRUE);
	WRITE_DOUBLE(0, x);
	WRITE_DOUBLE(8, y);
	WRITE_DOUBLE(16, z);
	WRITE_OPCODE(pc, CR_TRANSLATED_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTranslatedSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y, GLdouble z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 24, GL_TRUE);
	WRITE_SWAPPED_DOUBLE(0, x);
	WRITE_SWAPPED_DOUBLE(8, y);
	WRITE_SWAPPED_DOUBLE(16, z);
	WRITE_OPCODE(pc, CR_TRANSLATED_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackTranslatef(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y, GLfloat z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 12, GL_TRUE);
	WRITE_DATA(0, GLfloat, x);
	WRITE_DATA(4, GLfloat, y);
	WRITE_DATA(8, GLfloat, z);
	WRITE_OPCODE(pc, CR_TRANSLATEF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTranslatefSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y, GLfloat z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH(pc, 12, GL_TRUE);
	WRITE_DATA(0, GLuint, SWAPFLOAT(x));
	WRITE_DATA(4, GLuint, SWAPFLOAT(y));
	WRITE_DATA(8, GLuint, SWAPFLOAT(z));
	WRITE_OPCODE(pc, CR_TRANSLATEF_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackUniform1f(CR_PACKER_CONTEXT_ARGDECL GLint location, GLfloat v0)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_UNIFORM1F_EXTEND_OPCODE);
	WRITE_DATA(8, GLint, location);
	WRITE_DATA(12, GLfloat, v0);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform1fSWAP(CR_PACKER_CONTEXT_ARGDECL GLint location, GLfloat v0)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_UNIFORM1F_EXTEND_OPCODE));
	WRITE_DATA(8, GLint, SWAP32(location));
	WRITE_DATA(12, GLuint, SWAPFLOAT(v0));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackUniform1i(CR_PACKER_CONTEXT_ARGDECL GLint location, GLint v0)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_UNIFORM1I_EXTEND_OPCODE);
	WRITE_DATA(8, GLint, location);
	WRITE_DATA(12, GLint, v0);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform1iSWAP(CR_PACKER_CONTEXT_ARGDECL GLint location, GLint v0)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_UNIFORM1I_EXTEND_OPCODE));
	WRITE_DATA(8, GLint, SWAP32(location));
	WRITE_DATA(12, GLint, SWAP32(v0));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackUniform2f(CR_PACKER_CONTEXT_ARGDECL GLint location, GLfloat v0, GLfloat v1)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLint, 20);
	WRITE_DATA(4, GLenum, CR_UNIFORM2F_EXTEND_OPCODE);
	WRITE_DATA(8, GLint, location);
	WRITE_DATA(12, GLfloat, v0);
	WRITE_DATA(16, GLfloat, v1);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform2fSWAP(CR_PACKER_CONTEXT_ARGDECL GLint location, GLfloat v0, GLfloat v1)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLint, SWAP32(20));
	WRITE_DATA(4, GLenum, SWAP32(CR_UNIFORM2F_EXTEND_OPCODE));
	WRITE_DATA(8, GLint, SWAP32(location));
	WRITE_DATA(12, GLuint, SWAPFLOAT(v0));
	WRITE_DATA(16, GLuint, SWAPFLOAT(v1));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackUniform2i(CR_PACKER_CONTEXT_ARGDECL GLint location, GLint v0, GLint v1)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLint, 20);
	WRITE_DATA(4, GLenum, CR_UNIFORM2I_EXTEND_OPCODE);
	WRITE_DATA(8, GLint, location);
	WRITE_DATA(12, GLint, v0);
	WRITE_DATA(16, GLint, v1);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform2iSWAP(CR_PACKER_CONTEXT_ARGDECL GLint location, GLint v0, GLint v1)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLint, SWAP32(20));
	WRITE_DATA(4, GLenum, SWAP32(CR_UNIFORM2I_EXTEND_OPCODE));
	WRITE_DATA(8, GLint, SWAP32(location));
	WRITE_DATA(12, GLint, SWAP32(v0));
	WRITE_DATA(16, GLint, SWAP32(v1));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackUniform3f(CR_PACKER_CONTEXT_ARGDECL GLint location, GLfloat v0, GLfloat v1, GLfloat v2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, 24);
	WRITE_DATA(4, GLenum, CR_UNIFORM3F_EXTEND_OPCODE);
	WRITE_DATA(8, GLint, location);
	WRITE_DATA(12, GLfloat, v0);
	WRITE_DATA(16, GLfloat, v1);
	WRITE_DATA(20, GLfloat, v2);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform3fSWAP(CR_PACKER_CONTEXT_ARGDECL GLint location, GLfloat v0, GLfloat v1, GLfloat v2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, SWAP32(24));
	WRITE_DATA(4, GLenum, SWAP32(CR_UNIFORM3F_EXTEND_OPCODE));
	WRITE_DATA(8, GLint, SWAP32(location));
	WRITE_DATA(12, GLuint, SWAPFLOAT(v0));
	WRITE_DATA(16, GLuint, SWAPFLOAT(v1));
	WRITE_DATA(20, GLuint, SWAPFLOAT(v2));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackUniform3i(CR_PACKER_CONTEXT_ARGDECL GLint location, GLint v0, GLint v1, GLint v2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, 24);
	WRITE_DATA(4, GLenum, CR_UNIFORM3I_EXTEND_OPCODE);
	WRITE_DATA(8, GLint, location);
	WRITE_DATA(12, GLint, v0);
	WRITE_DATA(16, GLint, v1);
	WRITE_DATA(20, GLint, v2);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform3iSWAP(CR_PACKER_CONTEXT_ARGDECL GLint location, GLint v0, GLint v1, GLint v2)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, SWAP32(24));
	WRITE_DATA(4, GLenum, SWAP32(CR_UNIFORM3I_EXTEND_OPCODE));
	WRITE_DATA(8, GLint, SWAP32(location));
	WRITE_DATA(12, GLint, SWAP32(v0));
	WRITE_DATA(16, GLint, SWAP32(v1));
	WRITE_DATA(20, GLint, SWAP32(v2));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackUniform4f(CR_PACKER_CONTEXT_ARGDECL GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_UNIFORM4F_EXTEND_OPCODE);
	WRITE_DATA(8, GLint, location);
	WRITE_DATA(12, GLfloat, v0);
	WRITE_DATA(16, GLfloat, v1);
	WRITE_DATA(20, GLfloat, v2);
	WRITE_DATA(24, GLfloat, v3);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform4fSWAP(CR_PACKER_CONTEXT_ARGDECL GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_UNIFORM4F_EXTEND_OPCODE));
	WRITE_DATA(8, GLint, SWAP32(location));
	WRITE_DATA(12, GLuint, SWAPFLOAT(v0));
	WRITE_DATA(16, GLuint, SWAPFLOAT(v1));
	WRITE_DATA(20, GLuint, SWAPFLOAT(v2));
	WRITE_DATA(24, GLuint, SWAPFLOAT(v3));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackUniform4i(CR_PACKER_CONTEXT_ARGDECL GLint location, GLint v0, GLint v1, GLint v2, GLint v3)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, 28);
	WRITE_DATA(4, GLenum, CR_UNIFORM4I_EXTEND_OPCODE);
	WRITE_DATA(8, GLint, location);
	WRITE_DATA(12, GLint, v0);
	WRITE_DATA(16, GLint, v1);
	WRITE_DATA(20, GLint, v2);
	WRITE_DATA(24, GLint, v3);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform4iSWAP(CR_PACKER_CONTEXT_ARGDECL GLint location, GLint v0, GLint v1, GLint v2, GLint v3)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	WRITE_DATA(0, GLint, SWAP32(28));
	WRITE_DATA(4, GLenum, SWAP32(CR_UNIFORM4I_EXTEND_OPCODE));
	WRITE_DATA(8, GLint, SWAP32(location));
	WRITE_DATA(12, GLint, SWAP32(v0));
	WRITE_DATA(16, GLint, SWAP32(v1));
	WRITE_DATA(20, GLint, SWAP32(v2));
	WRITE_DATA(24, GLint, SWAP32(v3));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackUnlockArraysEXT(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, 8);
	WRITE_DATA(4, GLenum, CR_UNLOCKARRAYSEXT_EXTEND_OPCODE);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUnlockArraysEXTSWAP(CR_PACKER_CONTEXT_ARGSINGLEDECL)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, SWAP32(8));
	WRITE_DATA(4, GLenum, SWAP32(CR_UNLOCKARRAYSEXT_EXTEND_OPCODE));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackUseProgram(CR_PACKER_CONTEXT_ARGDECL GLuint program)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_USEPROGRAM_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, program);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUseProgramSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint program)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_USEPROGRAM_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(program));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackValidateProgram(CR_PACKER_CONTEXT_ARGDECL GLuint program)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_VALIDATEPROGRAM_EXTEND_OPCODE);
	WRITE_DATA(8, GLuint, program);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackValidateProgramSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint program)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_VALIDATEPROGRAM_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAP32(program));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex2d(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DOUBLE(0, x);
	WRITE_DOUBLE(8, y);
	WRITE_OPCODE(pc, CR_VERTEX2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2dSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_SWAPPED_DOUBLE(0, x);
	WRITE_SWAPPED_DOUBLE(8, y);
	WRITE_OPCODE(pc, CR_VERTEX2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex2dv(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex2dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DOUBLE(0, v[0]);
	WRITE_DOUBLE(8, v[1]);
	WRITE_OPCODE(pc, CR_VERTEX2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2dvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex2dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_SWAPPED_DOUBLE(0, v[0]);
	WRITE_SWAPPED_DOUBLE(8, v[1]);
	WRITE_OPCODE(pc, CR_VERTEX2D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex2f(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLfloat, x);
	WRITE_DATA(4, GLfloat, y);
	WRITE_OPCODE(pc, CR_VERTEX2F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2fSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLuint, SWAPFLOAT(x));
	WRITE_DATA(4, GLuint, SWAPFLOAT(y));
	WRITE_OPCODE(pc, CR_VERTEX2F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex2fv(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex2fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLfloat, v[0]);
	WRITE_DATA(4, GLfloat, v[1]);
	WRITE_OPCODE(pc, CR_VERTEX2F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2fvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex2fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLuint, SWAPFLOAT(v[0]));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v[1]));
	WRITE_OPCODE(pc, CR_VERTEX2F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex2i(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, x);
	WRITE_DATA(4, GLint, y);
	WRITE_OPCODE(pc, CR_VERTEX2I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2iSWAP(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, SWAP32(x));
	WRITE_DATA(4, GLint, SWAP32(y));
	WRITE_OPCODE(pc, CR_VERTEX2I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex2iv(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex2iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, v[0]);
	WRITE_DATA(4, GLint, v[1]);
	WRITE_OPCODE(pc, CR_VERTEX2I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2ivSWAP(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex2iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLint, SWAP32(v[0]));
	WRITE_DATA(4, GLint, SWAP32(v[1]));
	WRITE_OPCODE(pc, CR_VERTEX2I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex2s(CR_PACKER_CONTEXT_ARGDECL GLshort x, GLshort y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLshort, x);
	WRITE_DATA(2, GLshort, y);
	WRITE_OPCODE(pc, CR_VERTEX2S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2sSWAP(CR_PACKER_CONTEXT_ARGDECL GLshort x, GLshort y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLshort, SWAP16(x));
	WRITE_DATA(2, GLshort, SWAP16(y));
	WRITE_OPCODE(pc, CR_VERTEX2S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex2sv(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex2sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLshort, v[0]);
	WRITE_DATA(2, GLshort, v[1]);
	WRITE_OPCODE(pc, CR_VERTEX2S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2svSWAP(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex2sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 4);
	WRITE_DATA(0, GLshort, SWAP16(v[0]));
	WRITE_DATA(2, GLshort, SWAP16(v[1]));
	WRITE_OPCODE(pc, CR_VERTEX2S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex3d(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y, GLdouble z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DOUBLE(0, x);
	WRITE_DOUBLE(8, y);
	WRITE_DOUBLE(16, z);
	WRITE_OPCODE(pc, CR_VERTEX3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3dSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y, GLdouble z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_SWAPPED_DOUBLE(0, x);
	WRITE_SWAPPED_DOUBLE(8, y);
	WRITE_SWAPPED_DOUBLE(16, z);
	WRITE_OPCODE(pc, CR_VERTEX3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex3dv(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DOUBLE(0, v[0]);
	WRITE_DOUBLE(8, v[1]);
	WRITE_DOUBLE(16, v[2]);
	WRITE_OPCODE(pc, CR_VERTEX3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3dvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_SWAPPED_DOUBLE(0, v[0]);
	WRITE_SWAPPED_DOUBLE(8, v[1]);
	WRITE_SWAPPED_DOUBLE(16, v[2]);
	WRITE_OPCODE(pc, CR_VERTEX3D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex3f(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y, GLfloat z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLfloat, x);
	WRITE_DATA(4, GLfloat, y);
	WRITE_DATA(8, GLfloat, z);
	WRITE_OPCODE(pc, CR_VERTEX3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3fSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y, GLfloat z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLuint, SWAPFLOAT(x));
	WRITE_DATA(4, GLuint, SWAPFLOAT(y));
	WRITE_DATA(8, GLuint, SWAPFLOAT(z));
	WRITE_OPCODE(pc, CR_VERTEX3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex3fv(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLfloat, v[0]);
	WRITE_DATA(4, GLfloat, v[1]);
	WRITE_DATA(8, GLfloat, v[2]);
	WRITE_OPCODE(pc, CR_VERTEX3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3fvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLuint, SWAPFLOAT(v[0]));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v[1]));
	WRITE_DATA(8, GLuint, SWAPFLOAT(v[2]));
	WRITE_OPCODE(pc, CR_VERTEX3F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex3i(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y, GLint z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, x);
	WRITE_DATA(4, GLint, y);
	WRITE_DATA(8, GLint, z);
	WRITE_OPCODE(pc, CR_VERTEX3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3iSWAP(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y, GLint z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(x));
	WRITE_DATA(4, GLint, SWAP32(y));
	WRITE_DATA(8, GLint, SWAP32(z));
	WRITE_OPCODE(pc, CR_VERTEX3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex3iv(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, v[0]);
	WRITE_DATA(4, GLint, v[1]);
	WRITE_DATA(8, GLint, v[2]);
	WRITE_OPCODE(pc, CR_VERTEX3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3ivSWAP(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(v[0]));
	WRITE_DATA(4, GLint, SWAP32(v[1]));
	WRITE_DATA(8, GLint, SWAP32(v[2]));
	WRITE_OPCODE(pc, CR_VERTEX3I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex3s(CR_PACKER_CONTEXT_ARGDECL GLshort x, GLshort y, GLshort z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, x);
	WRITE_DATA(2, GLshort, y);
	WRITE_DATA(4, GLshort, z);
	WRITE_OPCODE(pc, CR_VERTEX3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3sSWAP(CR_PACKER_CONTEXT_ARGDECL GLshort x, GLshort y, GLshort z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, SWAP16(x));
	WRITE_DATA(2, GLshort, SWAP16(y));
	WRITE_DATA(4, GLshort, SWAP16(z));
	WRITE_OPCODE(pc, CR_VERTEX3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex3sv(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, v[0]);
	WRITE_DATA(2, GLshort, v[1]);
	WRITE_DATA(4, GLshort, v[2]);
	WRITE_OPCODE(pc, CR_VERTEX3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3svSWAP(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, SWAP16(v[0]));
	WRITE_DATA(2, GLshort, SWAP16(v[1]));
	WRITE_DATA(4, GLshort, SWAP16(v[2]));
	WRITE_OPCODE(pc, CR_VERTEX3S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex4d(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DOUBLE(0, x);
	WRITE_DOUBLE(8, y);
	WRITE_DOUBLE(16, z);
	WRITE_DOUBLE(24, w);
	WRITE_OPCODE(pc, CR_VERTEX4D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4dSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_SWAPPED_DOUBLE(0, x);
	WRITE_SWAPPED_DOUBLE(8, y);
	WRITE_SWAPPED_DOUBLE(16, z);
	WRITE_SWAPPED_DOUBLE(24, w);
	WRITE_OPCODE(pc, CR_VERTEX4D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex4dv(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex4dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DOUBLE(0, v[0]);
	WRITE_DOUBLE(8, v[1]);
	WRITE_DOUBLE(16, v[2]);
	WRITE_DOUBLE(24, v[3]);
	WRITE_OPCODE(pc, CR_VERTEX4D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4dvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex4dv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_SWAPPED_DOUBLE(0, v[0]);
	WRITE_SWAPPED_DOUBLE(8, v[1]);
	WRITE_SWAPPED_DOUBLE(16, v[2]);
	WRITE_SWAPPED_DOUBLE(24, v[3]);
	WRITE_OPCODE(pc, CR_VERTEX4D_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex4f(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLfloat, x);
	WRITE_DATA(4, GLfloat, y);
	WRITE_DATA(8, GLfloat, z);
	WRITE_DATA(12, GLfloat, w);
	WRITE_OPCODE(pc, CR_VERTEX4F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4fSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLuint, SWAPFLOAT(x));
	WRITE_DATA(4, GLuint, SWAPFLOAT(y));
	WRITE_DATA(8, GLuint, SWAPFLOAT(z));
	WRITE_DATA(12, GLuint, SWAPFLOAT(w));
	WRITE_OPCODE(pc, CR_VERTEX4F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex4fv(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex4fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLfloat, v[0]);
	WRITE_DATA(4, GLfloat, v[1]);
	WRITE_DATA(8, GLfloat, v[2]);
	WRITE_DATA(12, GLfloat, v[3]);
	WRITE_OPCODE(pc, CR_VERTEX4F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4fvSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex4fv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLuint, SWAPFLOAT(v[0]));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v[1]));
	WRITE_DATA(8, GLuint, SWAPFLOAT(v[2]));
	WRITE_DATA(12, GLuint, SWAPFLOAT(v[3]));
	WRITE_OPCODE(pc, CR_VERTEX4F_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex4i(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y, GLint z, GLint w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, x);
	WRITE_DATA(4, GLint, y);
	WRITE_DATA(8, GLint, z);
	WRITE_DATA(12, GLint, w);
	WRITE_OPCODE(pc, CR_VERTEX4I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4iSWAP(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y, GLint z, GLint w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(x));
	WRITE_DATA(4, GLint, SWAP32(y));
	WRITE_DATA(8, GLint, SWAP32(z));
	WRITE_DATA(12, GLint, SWAP32(w));
	WRITE_OPCODE(pc, CR_VERTEX4I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex4iv(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex4iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, v[0]);
	WRITE_DATA(4, GLint, v[1]);
	WRITE_DATA(8, GLint, v[2]);
	WRITE_DATA(12, GLint, v[3]);
	WRITE_OPCODE(pc, CR_VERTEX4I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4ivSWAP(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex4iv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(v[0]));
	WRITE_DATA(4, GLint, SWAP32(v[1]));
	WRITE_DATA(8, GLint, SWAP32(v[2]));
	WRITE_DATA(12, GLint, SWAP32(v[3]));
	WRITE_OPCODE(pc, CR_VERTEX4I_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex4s(CR_PACKER_CONTEXT_ARGDECL GLshort x, GLshort y, GLshort z, GLshort w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, x);
	WRITE_DATA(2, GLshort, y);
	WRITE_DATA(4, GLshort, z);
	WRITE_DATA(6, GLshort, w);
	WRITE_OPCODE(pc, CR_VERTEX4S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4sSWAP(CR_PACKER_CONTEXT_ARGDECL GLshort x, GLshort y, GLshort z, GLshort w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, SWAP16(x));
	WRITE_DATA(2, GLshort, SWAP16(y));
	WRITE_DATA(4, GLshort, SWAP16(z));
	WRITE_DATA(6, GLshort, SWAP16(w));
	WRITE_OPCODE(pc, CR_VERTEX4S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertex4sv(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex4sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, v[0]);
	WRITE_DATA(2, GLshort, v[1]);
	WRITE_DATA(4, GLshort, v[2]);
	WRITE_DATA(6, GLshort, v[3]);
	WRITE_OPCODE(pc, CR_VERTEX4S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4svSWAP(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex4sv");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	WRITE_DATA(0, GLshort, SWAP16(v[0]));
	WRITE_DATA(2, GLshort, SWAP16(v[1]));
	WRITE_DATA(4, GLshort, SWAP16(v[2]));
	WRITE_DATA(6, GLshort, SWAP16(v[3]));
	WRITE_OPCODE(pc, CR_VERTEX4S_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib1dARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLdouble x)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.vertexAttrib.d1[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DOUBLE(4, x);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB1DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib1dARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLdouble x)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.vertexAttrib.d1[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_SWAPPED_DOUBLE(4, x);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB1DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib1dvARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib1dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.vertexAttrib.d1[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DOUBLE(4, v[0]);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB1DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib1dvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib1dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.vertexAttrib.d1[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_SWAPPED_DOUBLE(4, v[0]);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB1DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib1fARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLfloat x)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.vertexAttrib.f1[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DATA(4, GLfloat, x);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB1FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib1fARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLfloat x)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.vertexAttrib.f1[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_DATA(4, GLuint, SWAPFLOAT(x));
	WRITE_OPCODE(pc, CR_VERTEXATTRIB1FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib1fvARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib1fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.vertexAttrib.f1[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DATA(4, GLfloat, v[0]);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB1FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib1fvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib1fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.vertexAttrib.f1[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v[0]));
	WRITE_OPCODE(pc, CR_VERTEXATTRIB1FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib1sARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLshort x)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.vertexAttrib.s1[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DATA(4, GLshort, x);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB1SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib1sARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLshort x)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.vertexAttrib.s1[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_DATA(4, GLshort, SWAP16(x));
	WRITE_OPCODE(pc, CR_VERTEXATTRIB1SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib1svARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib1svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.vertexAttrib.s1[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DATA(4, GLshort, v[0]);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB1SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib1svARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib1svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.vertexAttrib.s1[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_DATA(4, GLshort, SWAP16(v[0]));
	WRITE_OPCODE(pc, CR_VERTEXATTRIB1SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib2dARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLdouble x, GLdouble y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.vertexAttrib.d2[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DOUBLE(4, x);
	WRITE_DOUBLE(12, y);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB2DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib2dARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLdouble x, GLdouble y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.vertexAttrib.d2[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_SWAPPED_DOUBLE(4, x);
	WRITE_SWAPPED_DOUBLE(12, y);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB2DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib2dvARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib2dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.vertexAttrib.d2[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DOUBLE(4, v[0]);
	WRITE_DOUBLE(12, v[1]);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB2DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib2dvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib2dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.vertexAttrib.d2[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_SWAPPED_DOUBLE(4, v[0]);
	WRITE_SWAPPED_DOUBLE(12, v[1]);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB2DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib2fARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLfloat x, GLfloat y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.vertexAttrib.f2[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DATA(4, GLfloat, x);
	WRITE_DATA(8, GLfloat, y);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB2FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib2fARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLfloat x, GLfloat y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.vertexAttrib.f2[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_DATA(4, GLuint, SWAPFLOAT(x));
	WRITE_DATA(8, GLuint, SWAPFLOAT(y));
	WRITE_OPCODE(pc, CR_VERTEXATTRIB2FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib2fvARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib2fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.vertexAttrib.f2[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DATA(4, GLfloat, v[0]);
	WRITE_DATA(8, GLfloat, v[1]);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB2FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib2fvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib2fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.vertexAttrib.f2[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v[0]));
	WRITE_DATA(8, GLuint, SWAPFLOAT(v[1]));
	WRITE_OPCODE(pc, CR_VERTEXATTRIB2FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib2sARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLshort x, GLshort y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.vertexAttrib.s2[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DATA(4, GLshort, x);
	WRITE_DATA(6, GLshort, y);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB2SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib2sARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLshort x, GLshort y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.vertexAttrib.s2[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_DATA(4, GLshort, SWAP16(x));
	WRITE_DATA(6, GLshort, SWAP16(y));
	WRITE_OPCODE(pc, CR_VERTEXATTRIB2SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib2svARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib2svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.vertexAttrib.s2[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DATA(4, GLshort, v[0]);
	WRITE_DATA(6, GLshort, v[1]);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB2SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib2svARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib2svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.vertexAttrib.s2[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_DATA(4, GLshort, SWAP16(v[0]));
	WRITE_DATA(6, GLshort, SWAP16(v[1]));
	WRITE_OPCODE(pc, CR_VERTEXATTRIB2SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib3dARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLdouble x, GLdouble y, GLdouble z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	pc->current.c.vertexAttrib.d3[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DOUBLE(4, x);
	WRITE_DOUBLE(12, y);
	WRITE_DOUBLE(20, z);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB3DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib3dARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLdouble x, GLdouble y, GLdouble z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 28);
	pc->current.c.vertexAttrib.d3[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_SWAPPED_DOUBLE(4, x);
	WRITE_SWAPPED_DOUBLE(12, y);
	WRITE_SWAPPED_DOUBLE(20, z);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB3DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib3dvARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib3dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 28);
	pc->current.c.vertexAttrib.d3[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DOUBLE(4, v[0]);
	WRITE_DOUBLE(12, v[1]);
	WRITE_DOUBLE(20, v[2]);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB3DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib3dvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib3dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 28);
	pc->current.c.vertexAttrib.d3[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_SWAPPED_DOUBLE(4, v[0]);
	WRITE_SWAPPED_DOUBLE(12, v[1]);
	WRITE_SWAPPED_DOUBLE(20, v[2]);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB3DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib3fARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLfloat x, GLfloat y, GLfloat z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.vertexAttrib.f3[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DATA(4, GLfloat, x);
	WRITE_DATA(8, GLfloat, y);
	WRITE_DATA(12, GLfloat, z);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB3FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib3fARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLfloat x, GLfloat y, GLfloat z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.vertexAttrib.f3[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_DATA(4, GLuint, SWAPFLOAT(x));
	WRITE_DATA(8, GLuint, SWAPFLOAT(y));
	WRITE_DATA(12, GLuint, SWAPFLOAT(z));
	WRITE_OPCODE(pc, CR_VERTEXATTRIB3FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib3fvARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib3fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.vertexAttrib.f3[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DATA(4, GLfloat, v[0]);
	WRITE_DATA(8, GLfloat, v[1]);
	WRITE_DATA(12, GLfloat, v[2]);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB3FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib3fvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib3fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	pc->current.c.vertexAttrib.f3[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v[0]));
	WRITE_DATA(8, GLuint, SWAPFLOAT(v[1]));
	WRITE_DATA(12, GLuint, SWAPFLOAT(v[2]));
	WRITE_OPCODE(pc, CR_VERTEXATTRIB3FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib3sARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLshort x, GLshort y, GLshort z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.vertexAttrib.s3[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DATA(4, GLshort, x);
	WRITE_DATA(6, GLshort, y);
	WRITE_DATA(8, GLshort, z);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB3SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib3sARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLshort x, GLshort y, GLshort z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.vertexAttrib.s3[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_DATA(4, GLshort, SWAP16(x));
	WRITE_DATA(6, GLshort, SWAP16(y));
	WRITE_DATA(8, GLshort, SWAP16(z));
	WRITE_OPCODE(pc, CR_VERTEXATTRIB3SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib3svARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib3svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.vertexAttrib.s3[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DATA(4, GLshort, v[0]);
	WRITE_DATA(6, GLshort, v[1]);
	WRITE_DATA(8, GLshort, v[2]);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB3SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib3svARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib3svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.vertexAttrib.s3[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_DATA(4, GLshort, SWAP16(v[0]));
	WRITE_DATA(6, GLshort, SWAP16(v[1]));
	WRITE_DATA(8, GLshort, SWAP16(v[2]));
	WRITE_OPCODE(pc, CR_VERTEXATTRIB3SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib4NubARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.vertexAttrib.ub4[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DATA(4, GLubyte, x);
	WRITE_DATA(5, GLubyte, y);
	WRITE_DATA(6, GLubyte, z);
	WRITE_DATA(7, GLubyte, w);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB4NUBARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4NubARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 8);
	pc->current.c.vertexAttrib.ub4[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_DATA(4, GLubyte, x);
	WRITE_DATA(5, GLubyte, y);
	WRITE_DATA(6, GLubyte, z);
	WRITE_DATA(7, GLubyte, w);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB4NUBARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib4dARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	pc->current.c.vertexAttrib.d4[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DOUBLE(4, x);
	WRITE_DOUBLE(12, y);
	WRITE_DOUBLE(20, z);
	WRITE_DOUBLE(28, w);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB4DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4dARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 36);
	pc->current.c.vertexAttrib.d4[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_SWAPPED_DOUBLE(4, x);
	WRITE_SWAPPED_DOUBLE(12, y);
	WRITE_SWAPPED_DOUBLE(20, z);
	WRITE_SWAPPED_DOUBLE(28, w);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB4DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib4dvARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib4dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 36);
	pc->current.c.vertexAttrib.d4[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DOUBLE(4, v[0]);
	WRITE_DOUBLE(12, v[1]);
	WRITE_DOUBLE(20, v[2]);
	WRITE_DOUBLE(28, v[3]);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB4DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4dvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib4dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 36);
	pc->current.c.vertexAttrib.d4[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_SWAPPED_DOUBLE(4, v[0]);
	WRITE_SWAPPED_DOUBLE(12, v[1]);
	WRITE_SWAPPED_DOUBLE(20, v[2]);
	WRITE_SWAPPED_DOUBLE(28, v[3]);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB4DARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib4fARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.vertexAttrib.f4[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DATA(4, GLfloat, x);
	WRITE_DATA(8, GLfloat, y);
	WRITE_DATA(12, GLfloat, z);
	WRITE_DATA(16, GLfloat, w);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB4FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4fARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.vertexAttrib.f4[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_DATA(4, GLuint, SWAPFLOAT(x));
	WRITE_DATA(8, GLuint, SWAPFLOAT(y));
	WRITE_DATA(12, GLuint, SWAPFLOAT(z));
	WRITE_DATA(16, GLuint, SWAPFLOAT(w));
	WRITE_OPCODE(pc, CR_VERTEXATTRIB4FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib4fvARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib4fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.vertexAttrib.f4[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DATA(4, GLfloat, v[0]);
	WRITE_DATA(8, GLfloat, v[1]);
	WRITE_DATA(12, GLfloat, v[2]);
	WRITE_DATA(16, GLfloat, v[3]);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB4FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4fvARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib4fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 20);
	pc->current.c.vertexAttrib.f4[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_DATA(4, GLuint, SWAPFLOAT(v[0]));
	WRITE_DATA(8, GLuint, SWAPFLOAT(v[1]));
	WRITE_DATA(12, GLuint, SWAPFLOAT(v[2]));
	WRITE_DATA(16, GLuint, SWAPFLOAT(v[3]));
	WRITE_OPCODE(pc, CR_VERTEXATTRIB4FARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib4sARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLshort x, GLshort y, GLshort z, GLshort w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.vertexAttrib.s4[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DATA(4, GLshort, x);
	WRITE_DATA(6, GLshort, y);
	WRITE_DATA(8, GLshort, z);
	WRITE_DATA(10, GLshort, w);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB4SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4sARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, GLshort x, GLshort y, GLshort z, GLshort w)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.vertexAttrib.s4[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_DATA(4, GLshort, SWAP16(x));
	WRITE_DATA(6, GLshort, SWAP16(y));
	WRITE_DATA(8, GLshort, SWAP16(z));
	WRITE_DATA(10, GLshort, SWAP16(w));
	WRITE_OPCODE(pc, CR_VERTEXATTRIB4SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackVertexAttrib4svARB(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib4svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.vertexAttrib.s4[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, index);
	WRITE_DATA(4, GLshort, v[0]);
	WRITE_DATA(6, GLshort, v[1]);
	WRITE_DATA(8, GLshort, v[2]);
	WRITE_DATA(10, GLshort, v[3]);
	WRITE_OPCODE(pc, CR_VERTEXATTRIB4SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4svARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLuint index, const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib4svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	pc->current.c.vertexAttrib.s4[index] = data_ptr + 4;
	pc->current.attribsUsedMask |= (1 << index);
	pc->current.changedVertexAttrib |= (1 << index);
	WRITE_DATA(0, GLuint, SWAP32(index));
	WRITE_DATA(4, GLshort, SWAP16(v[0]));
	WRITE_DATA(6, GLshort, SWAP16(v[1]));
	WRITE_DATA(8, GLshort, SWAP16(v[2]));
	WRITE_DATA(10, GLshort, SWAP16(v[3]));
	WRITE_OPCODE(pc, CR_VERTEXATTRIB4SARB_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackViewport(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y, GLsizei width, GLsizei height)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, x);
	WRITE_DATA(4, GLint, y);
	WRITE_DATA(8, GLsizei, width);
	WRITE_DATA(12, GLsizei, height);
	WRITE_OPCODE(pc, CR_VIEWPORT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackViewportSWAP(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y, GLsizei width, GLsizei height)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(x));
	WRITE_DATA(4, GLint, SWAP32(y));
	WRITE_DATA(8, GLsizei, SWAP32(width));
	WRITE_DATA(12, GLsizei, SWAP32(height));
	WRITE_OPCODE(pc, CR_VIEWPORT_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackWindowDestroy(CR_PACKER_CONTEXT_ARGDECL GLint window)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_WINDOWDESTROY_EXTEND_OPCODE);
	WRITE_DATA(8, GLint, window);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowDestroySWAP(CR_PACKER_CONTEXT_ARGDECL GLint window)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_WINDOWDESTROY_EXTEND_OPCODE));
	WRITE_DATA(8, GLint, SWAP32(window));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackWindowPos2dARB(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, 24);
	WRITE_DATA(4, GLenum, CR_WINDOWPOS2DARB_EXTEND_OPCODE);
	WRITE_DOUBLE(8, x);
	WRITE_DOUBLE(16, y);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2dARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, SWAP32(24));
	WRITE_DATA(4, GLenum, SWAP32(CR_WINDOWPOS2DARB_EXTEND_OPCODE));
	WRITE_SWAPPED_DOUBLE(8, x);
	WRITE_SWAPPED_DOUBLE(16, y);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackWindowPos2dvARB(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos2dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, 24);
	WRITE_DATA(4, GLenum, CR_WINDOWPOS2DARB_EXTEND_OPCODE);
	WRITE_DOUBLE(8, v[0]);
	WRITE_DOUBLE(16, v[1]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2dvARBSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos2dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 24);
	WRITE_DATA(0, GLint, SWAP32(24));
	WRITE_DATA(4, GLenum, SWAP32(CR_WINDOWPOS2DARB_EXTEND_OPCODE));
	WRITE_SWAPPED_DOUBLE(8, v[0]);
	WRITE_SWAPPED_DOUBLE(16, v[1]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackWindowPos2fARB(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_WINDOWPOS2FARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLfloat, x);
	WRITE_DATA(12, GLfloat, y);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2fARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_WINDOWPOS2FARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAPFLOAT(x));
	WRITE_DATA(12, GLuint, SWAPFLOAT(y));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackWindowPos2fvARB(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos2fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_WINDOWPOS2FARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLfloat, v[0]);
	WRITE_DATA(12, GLfloat, v[1]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2fvARBSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos2fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_WINDOWPOS2FARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAPFLOAT(v[0]));
	WRITE_DATA(12, GLuint, SWAPFLOAT(v[1]));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackWindowPos2iARB(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_WINDOWPOS2IARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLint, x);
	WRITE_DATA(12, GLint, y);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2iARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_WINDOWPOS2IARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLint, SWAP32(x));
	WRITE_DATA(12, GLint, SWAP32(y));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackWindowPos2ivARB(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos2ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_WINDOWPOS2IARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLint, v[0]);
	WRITE_DATA(12, GLint, v[1]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2ivARBSWAP(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos2ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_WINDOWPOS2IARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLint, SWAP32(v[0]));
	WRITE_DATA(12, GLint, SWAP32(v[1]));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackWindowPos2sARB(CR_PACKER_CONTEXT_ARGDECL GLshort x, GLshort y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_WINDOWPOS2SARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLshort, x);
	WRITE_DATA(10, GLshort, y);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2sARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLshort x, GLshort y)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_WINDOWPOS2SARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLshort, SWAP16(x));
	WRITE_DATA(10, GLshort, SWAP16(y));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackWindowPos2svARB(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos2svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, 12);
	WRITE_DATA(4, GLenum, CR_WINDOWPOS2SARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLshort, v[0]);
	WRITE_DATA(10, GLshort, v[1]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2svARBSWAP(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos2svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 12);
	WRITE_DATA(0, GLint, SWAP32(12));
	WRITE_DATA(4, GLenum, SWAP32(CR_WINDOWPOS2SARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLshort, SWAP16(v[0]));
	WRITE_DATA(10, GLshort, SWAP16(v[1]));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackWindowPos3dARB(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y, GLdouble z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_WINDOWPOS3DARB_EXTEND_OPCODE);
	WRITE_DOUBLE(8, x);
	WRITE_DOUBLE(16, y);
	WRITE_DOUBLE(24, z);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3dARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLdouble x, GLdouble y, GLdouble z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_WINDOWPOS3DARB_EXTEND_OPCODE));
	WRITE_SWAPPED_DOUBLE(8, x);
	WRITE_SWAPPED_DOUBLE(16, y);
	WRITE_SWAPPED_DOUBLE(24, z);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackWindowPos3dvARB(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos3dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, 32);
	WRITE_DATA(4, GLenum, CR_WINDOWPOS3DARB_EXTEND_OPCODE);
	WRITE_DOUBLE(8, v[0]);
	WRITE_DOUBLE(16, v[1]);
	WRITE_DOUBLE(24, v[2]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3dvARBSWAP(CR_PACKER_CONTEXT_ARGDECL const GLdouble * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos3dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 32);
	WRITE_DATA(0, GLint, SWAP32(32));
	WRITE_DATA(4, GLenum, SWAP32(CR_WINDOWPOS3DARB_EXTEND_OPCODE));
	WRITE_SWAPPED_DOUBLE(8, v[0]);
	WRITE_SWAPPED_DOUBLE(16, v[1]);
	WRITE_SWAPPED_DOUBLE(24, v[2]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackWindowPos3fARB(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y, GLfloat z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLint, 20);
	WRITE_DATA(4, GLenum, CR_WINDOWPOS3FARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLfloat, x);
	WRITE_DATA(12, GLfloat, y);
	WRITE_DATA(16, GLfloat, z);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3fARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLfloat x, GLfloat y, GLfloat z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLint, SWAP32(20));
	WRITE_DATA(4, GLenum, SWAP32(CR_WINDOWPOS3FARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAPFLOAT(x));
	WRITE_DATA(12, GLuint, SWAPFLOAT(y));
	WRITE_DATA(16, GLuint, SWAPFLOAT(z));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackWindowPos3fvARB(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos3fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLint, 20);
	WRITE_DATA(4, GLenum, CR_WINDOWPOS3FARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLfloat, v[0]);
	WRITE_DATA(12, GLfloat, v[1]);
	WRITE_DATA(16, GLfloat, v[2]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3fvARBSWAP(CR_PACKER_CONTEXT_ARGDECL const GLfloat * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos3fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLint, SWAP32(20));
	WRITE_DATA(4, GLenum, SWAP32(CR_WINDOWPOS3FARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLuint, SWAPFLOAT(v[0]));
	WRITE_DATA(12, GLuint, SWAPFLOAT(v[1]));
	WRITE_DATA(16, GLuint, SWAPFLOAT(v[2]));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackWindowPos3iARB(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y, GLint z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLint, 20);
	WRITE_DATA(4, GLenum, CR_WINDOWPOS3IARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLint, x);
	WRITE_DATA(12, GLint, y);
	WRITE_DATA(16, GLint, z);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3iARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLint x, GLint y, GLint z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLint, SWAP32(20));
	WRITE_DATA(4, GLenum, SWAP32(CR_WINDOWPOS3IARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLint, SWAP32(x));
	WRITE_DATA(12, GLint, SWAP32(y));
	WRITE_DATA(16, GLint, SWAP32(z));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackWindowPos3ivARB(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos3ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLint, 20);
	WRITE_DATA(4, GLenum, CR_WINDOWPOS3IARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLint, v[0]);
	WRITE_DATA(12, GLint, v[1]);
	WRITE_DATA(16, GLint, v[2]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3ivARBSWAP(CR_PACKER_CONTEXT_ARGDECL const GLint * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos3ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 20);
	WRITE_DATA(0, GLint, SWAP32(20));
	WRITE_DATA(4, GLenum, SWAP32(CR_WINDOWPOS3IARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLint, SWAP32(v[0]));
	WRITE_DATA(12, GLint, SWAP32(v[1]));
	WRITE_DATA(16, GLint, SWAP32(v[2]));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackWindowPos3sARB(CR_PACKER_CONTEXT_ARGDECL GLshort x, GLshort y, GLshort z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_WINDOWPOS3SARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLshort, x);
	WRITE_DATA(10, GLshort, y);
	WRITE_DATA(12, GLshort, z);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3sARBSWAP(CR_PACKER_CONTEXT_ARGDECL GLshort x, GLshort y, GLshort z)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_WINDOWPOS3SARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLshort, SWAP16(x));
	WRITE_DATA(10, GLshort, SWAP16(y));
	WRITE_DATA(12, GLshort, SWAP16(z));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackWindowPos3svARB(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos3svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_WINDOWPOS3SARB_EXTEND_OPCODE);
	WRITE_DATA(8, GLshort, v[0]);
	WRITE_DATA(10, GLshort, v[1]);
	WRITE_DATA(12, GLshort, v[2]);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3svARBSWAP(CR_PACKER_CONTEXT_ARGDECL const GLshort * v)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos3svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_WINDOWPOS3SARB_EXTEND_OPCODE));
	WRITE_DATA(8, GLshort, SWAP16(v[0]));
	WRITE_DATA(10, GLshort, SWAP16(v[1]));
	WRITE_DATA(12, GLshort, SWAP16(v[2]));
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
#ifndef IN_RING0
void PACK_APIENTRY crPackWriteback(CR_PACKER_CONTEXT_ARGDECL GLint * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, 16);
	WRITE_DATA(4, GLenum, CR_WRITEBACK_EXTEND_OPCODE);
	WRITE_NETWORK_POINTER(8, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWritebackSWAP(CR_PACKER_CONTEXT_ARGDECL GLint * writeback)
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr = NULL;
	(void) pc;
	CR_GET_BUFFERED_POINTER(pc, 16);
	WRITE_DATA(0, GLint, SWAP32(16));
	WRITE_DATA(4, GLenum, SWAP32(CR_WRITEBACK_EXTEND_OPCODE));
	WRITE_NETWORK_POINTER(8, (void *) writeback);
	WRITE_OPCODE(pc, CR_EXTEND_OPCODE);
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

#endif
